/*
Copyright 2020 Rancher Labs.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package fake

import (
	adminriocattleiov1 "github.com/rancher/rio/pkg/apis/admin.rio.cattle.io/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeSystemStacks implements SystemStackInterface
type FakeSystemStacks struct {
	Fake *FakeAdminV1
}

var systemstacksResource = schema.GroupVersionResource{Group: "admin.rio.cattle.io", Version: "v1", Resource: "systemstacks"}

var systemstacksKind = schema.GroupVersionKind{Group: "admin.rio.cattle.io", Version: "v1", Kind: "SystemStack"}

// Get takes name of the systemStack, and returns the corresponding systemStack object, and an error if there is any.
func (c *FakeSystemStacks) Get(name string, options v1.GetOptions) (result *adminriocattleiov1.SystemStack, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(systemstacksResource, name), &adminriocattleiov1.SystemStack{})
	if obj == nil {
		return nil, err
	}
	return obj.(*adminriocattleiov1.SystemStack), err
}

// List takes label and field selectors, and returns the list of SystemStacks that match those selectors.
func (c *FakeSystemStacks) List(opts v1.ListOptions) (result *adminriocattleiov1.SystemStackList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(systemstacksResource, systemstacksKind, opts), &adminriocattleiov1.SystemStackList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &adminriocattleiov1.SystemStackList{ListMeta: obj.(*adminriocattleiov1.SystemStackList).ListMeta}
	for _, item := range obj.(*adminriocattleiov1.SystemStackList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested systemStacks.
func (c *FakeSystemStacks) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(systemstacksResource, opts))
}

// Create takes the representation of a systemStack and creates it.  Returns the server's representation of the systemStack, and an error, if there is any.
func (c *FakeSystemStacks) Create(systemStack *adminriocattleiov1.SystemStack) (result *adminriocattleiov1.SystemStack, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(systemstacksResource, systemStack), &adminriocattleiov1.SystemStack{})
	if obj == nil {
		return nil, err
	}
	return obj.(*adminriocattleiov1.SystemStack), err
}

// Update takes the representation of a systemStack and updates it. Returns the server's representation of the systemStack, and an error, if there is any.
func (c *FakeSystemStacks) Update(systemStack *adminriocattleiov1.SystemStack) (result *adminriocattleiov1.SystemStack, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(systemstacksResource, systemStack), &adminriocattleiov1.SystemStack{})
	if obj == nil {
		return nil, err
	}
	return obj.(*adminriocattleiov1.SystemStack), err
}

// Delete takes name of the systemStack and deletes it. Returns an error if one occurs.
func (c *FakeSystemStacks) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(systemstacksResource, name), &adminriocattleiov1.SystemStack{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeSystemStacks) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(systemstacksResource, listOptions)

	_, err := c.Fake.Invokes(action, &adminriocattleiov1.SystemStackList{})
	return err
}

// Patch applies the patch and returns the patched systemStack.
func (c *FakeSystemStacks) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *adminriocattleiov1.SystemStack, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(systemstacksResource, name, pt, data, subresources...), &adminriocattleiov1.SystemStack{})
	if obj == nil {
		return nil, err
	}
	return obj.(*adminriocattleiov1.SystemStack), err
}
