/*
Copyright 2020 Rancher Labs.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package v1

import (
	v1 "github.com/rancher/rio/pkg/apis/admin.rio.cattle.io/v1"
	clientset "github.com/rancher/rio/pkg/generated/clientset/versioned/typed/admin.rio.cattle.io/v1"
	informers "github.com/rancher/rio/pkg/generated/informers/externalversions/admin.rio.cattle.io/v1"
	"github.com/rancher/wrangler/pkg/generic"
)

type Interface interface {
	Certificate() CertificateController
	ClusterDomain() ClusterDomainController
	PublicDomain() PublicDomainController
	RioInfo() RioInfoController
	SystemStack() SystemStackController
}

func New(controllerManager *generic.ControllerManager, client clientset.AdminV1Interface,
	informers informers.Interface) Interface {
	return &version{
		controllerManager: controllerManager,
		client:            client,
		informers:         informers,
	}
}

type version struct {
	controllerManager *generic.ControllerManager
	informers         informers.Interface
	client            clientset.AdminV1Interface
}

func (c *version) Certificate() CertificateController {
	return NewCertificateController(v1.SchemeGroupVersion.WithKind("Certificate"), c.controllerManager, c.client, c.informers.Certificates())
}
func (c *version) ClusterDomain() ClusterDomainController {
	return NewClusterDomainController(v1.SchemeGroupVersion.WithKind("ClusterDomain"), c.controllerManager, c.client, c.informers.ClusterDomains())
}
func (c *version) PublicDomain() PublicDomainController {
	return NewPublicDomainController(v1.SchemeGroupVersion.WithKind("PublicDomain"), c.controllerManager, c.client, c.informers.PublicDomains())
}
func (c *version) RioInfo() RioInfoController {
	return NewRioInfoController(v1.SchemeGroupVersion.WithKind("RioInfo"), c.controllerManager, c.client, c.informers.RioInfos())
}
func (c *version) SystemStack() SystemStackController {
	return NewSystemStackController(v1.SchemeGroupVersion.WithKind("SystemStack"), c.controllerManager, c.client, c.informers.SystemStacks())
}
