/*
Copyright 2020 Rancher Labs.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package v1alpha3

import (
	clientset "github.com/rancher/rio/pkg/generated/clientset/versioned/typed/networking/v1alpha3"
	informers "github.com/rancher/rio/pkg/generated/informers/externalversions/networking/v1alpha3"
	"github.com/rancher/wrangler/pkg/generic"
	v1alpha3 "istio.io/client-go/pkg/apis/networking/v1alpha3"
)

type Interface interface {
	DestinationRule() DestinationRuleController
	Gateway() GatewayController
	ServiceEntry() ServiceEntryController
	VirtualService() VirtualServiceController
}

func New(controllerManager *generic.ControllerManager, client clientset.NetworkingV1alpha3Interface,
	informers informers.Interface) Interface {
	return &version{
		controllerManager: controllerManager,
		client:            client,
		informers:         informers,
	}
}

type version struct {
	controllerManager *generic.ControllerManager
	informers         informers.Interface
	client            clientset.NetworkingV1alpha3Interface
}

func (c *version) DestinationRule() DestinationRuleController {
	return NewDestinationRuleController(v1alpha3.SchemeGroupVersion.WithKind("DestinationRule"), c.controllerManager, c.client, c.informers.DestinationRules())
}
func (c *version) Gateway() GatewayController {
	return NewGatewayController(v1alpha3.SchemeGroupVersion.WithKind("Gateway"), c.controllerManager, c.client, c.informers.Gateways())
}
func (c *version) ServiceEntry() ServiceEntryController {
	return NewServiceEntryController(v1alpha3.SchemeGroupVersion.WithKind("ServiceEntry"), c.controllerManager, c.client, c.informers.ServiceEntries())
}
func (c *version) VirtualService() VirtualServiceController {
	return NewVirtualServiceController(v1alpha3.SchemeGroupVersion.WithKind("VirtualService"), c.controllerManager, c.client, c.informers.VirtualServices())
}
