/*
Copyright 2020 Rancher Labs.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package v1

import (
	time "time"

	adminriocattleiov1 "github.com/rancher/rio/pkg/apis/admin.rio.cattle.io/v1"
	versioned "github.com/rancher/rio/pkg/generated/clientset/versioned"
	internalinterfaces "github.com/rancher/rio/pkg/generated/informers/externalversions/internalinterfaces"
	v1 "github.com/rancher/rio/pkg/generated/listers/admin.rio.cattle.io/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// SystemStackInformer provides access to a shared informer and lister for
// SystemStacks.
type SystemStackInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.SystemStackLister
}

type systemStackInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// NewSystemStackInformer constructs a new informer for SystemStack type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewSystemStackInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredSystemStackInformer(client, resyncPeriod, indexers, nil)
}

// NewFilteredSystemStackInformer constructs a new informer for SystemStack type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredSystemStackInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.AdminV1().SystemStacks().List(options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.AdminV1().SystemStacks().Watch(options)
			},
		},
		&adminriocattleiov1.SystemStack{},
		resyncPeriod,
		indexers,
	)
}

func (f *systemStackInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredSystemStackInformer(client, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *systemStackInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&adminriocattleiov1.SystemStack{}, f.defaultInformer)
}

func (f *systemStackInformer) Lister() v1.SystemStackLister {
	return v1.NewSystemStackLister(f.Informer().GetIndexer())
}
