/*
Copyright 2020 Rancher Labs.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package v1

import (
	v1 "github.com/rancher/rio/pkg/apis/admin.rio.cattle.io/v1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// ClusterDomainLister helps list ClusterDomains.
type ClusterDomainLister interface {
	// List lists all ClusterDomains in the indexer.
	List(selector labels.Selector) (ret []*v1.ClusterDomain, err error)
	// Get retrieves the ClusterDomain from the index for a given name.
	Get(name string) (*v1.ClusterDomain, error)
	ClusterDomainListerExpansion
}

// clusterDomainLister implements the ClusterDomainLister interface.
type clusterDomainLister struct {
	indexer cache.Indexer
}

// NewClusterDomainLister returns a new ClusterDomainLister.
func NewClusterDomainLister(indexer cache.Indexer) ClusterDomainLister {
	return &clusterDomainLister{indexer: indexer}
}

// List lists all ClusterDomains in the indexer.
func (s *clusterDomainLister) List(selector labels.Selector) (ret []*v1.ClusterDomain, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.ClusterDomain))
	})
	return ret, err
}

// Get retrieves the ClusterDomain from the index for a given name.
func (s *clusterDomainLister) Get(name string) (*v1.ClusterDomain, error) {
	obj, exists, err := s.indexer.GetByKey(name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1.Resource("clusterdomain"), name)
	}
	return obj.(*v1.ClusterDomain), nil
}
