// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: github.com/solo-io/gloo/projects/gloo/api/external/envoy/api/v2/cluster/outlier_detection.proto

package cluster

import (
	bytes "bytes"
	fmt "fmt"
	math "math"

	_ "github.com/envoyproxy/protoc-gen-validate/validate"
	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/gogo/protobuf/proto"
	types "github.com/gogo/protobuf/types"
	_ "github.com/solo-io/protoc-gen-ext/extproto"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

// See the `architecture overview (arch_overview_outlier_detection)` for
// more information on outlier detection.
type OutlierDetection struct {
	// The number of consecutive 5xx responses or local origin errors that are mapped
	// to 5xx error codes before a consecutive 5xx ejection
	// occurs. Defaults to 5.
	Consecutive_5Xx *types.UInt32Value `protobuf:"bytes,1,opt,name=consecutive_5xx,json=consecutive5xx,proto3" json:"consecutive_5xx,omitempty"`
	// The time interval between ejection analysis sweeps. This can result in
	// both new ejections as well as hosts being returned to service. Defaults
	// to 10000ms or 10s.
	Interval *types.Duration `protobuf:"bytes,2,opt,name=interval,proto3" json:"interval,omitempty"`
	// The base time that a host is ejected for. The real time is equal to the
	// base time multiplied by the number of times the host has been ejected.
	// Defaults to 30000ms or 30s.
	BaseEjectionTime *types.Duration `protobuf:"bytes,3,opt,name=base_ejection_time,json=baseEjectionTime,proto3" json:"base_ejection_time,omitempty"`
	// The maximum % of an upstream cluster that can be ejected due to outlier
	// detection. Defaults to 10% but will eject at least one host regardless of the value.
	MaxEjectionPercent *types.UInt32Value `protobuf:"bytes,4,opt,name=max_ejection_percent,json=maxEjectionPercent,proto3" json:"max_ejection_percent,omitempty"`
	// The % chance that a host will be actually ejected when an outlier status
	// is detected through consecutive 5xx. This setting can be used to disable
	// ejection or to ramp it up slowly. Defaults to 100.
	EnforcingConsecutive_5Xx *types.UInt32Value `protobuf:"bytes,5,opt,name=enforcing_consecutive_5xx,json=enforcingConsecutive5xx,proto3" json:"enforcing_consecutive_5xx,omitempty"`
	// The % chance that a host will be actually ejected when an outlier status
	// is detected through success rate statistics. This setting can be used to
	// disable ejection or to ramp it up slowly. Defaults to 100.
	EnforcingSuccessRate *types.UInt32Value `protobuf:"bytes,6,opt,name=enforcing_success_rate,json=enforcingSuccessRate,proto3" json:"enforcing_success_rate,omitempty"`
	// The number of hosts in a cluster that must have enough request volume to
	// detect success rate outliers. If the number of hosts is less than this
	// setting, outlier detection via success rate statistics is not performed
	// for any host in the cluster. Defaults to 5.
	SuccessRateMinimumHosts *types.UInt32Value `protobuf:"bytes,7,opt,name=success_rate_minimum_hosts,json=successRateMinimumHosts,proto3" json:"success_rate_minimum_hosts,omitempty"`
	// The minimum number of total requests that must be collected in one
	// interval (as defined by the interval duration above) to include this host
	// in success rate based outlier detection. If the volume is lower than this
	// setting, outlier detection via success rate statistics is not performed
	// for that host. Defaults to 100.
	SuccessRateRequestVolume *types.UInt32Value `protobuf:"bytes,8,opt,name=success_rate_request_volume,json=successRateRequestVolume,proto3" json:"success_rate_request_volume,omitempty"`
	// This factor is used to determine the ejection threshold for success rate
	// outlier ejection. The ejection threshold is the difference between the
	// mean success rate, and the product of this factor and the standard
	// deviation of the mean success rate: mean - (stdev *
	// success_rate_stdev_factor). This factor is divided by a thousand to get a
	// double. That is, if the desired factor is 1.9, the runtime value should
	// be 1900. Defaults to 1900.
	SuccessRateStdevFactor *types.UInt32Value `protobuf:"bytes,9,opt,name=success_rate_stdev_factor,json=successRateStdevFactor,proto3" json:"success_rate_stdev_factor,omitempty"`
	// The number of consecutive gateway failures (502, 503, 504 status codes)
	// before a consecutive gateway failure ejection occurs. Defaults to 5.
	ConsecutiveGatewayFailure *types.UInt32Value `protobuf:"bytes,10,opt,name=consecutive_gateway_failure,json=consecutiveGatewayFailure,proto3" json:"consecutive_gateway_failure,omitempty"`
	// The % chance that a host will be actually ejected when an outlier status
	// is detected through consecutive gateway failures. This setting can be
	// used to disable ejection or to ramp it up slowly. Defaults to 0.
	EnforcingConsecutiveGatewayFailure *types.UInt32Value `protobuf:"bytes,11,opt,name=enforcing_consecutive_gateway_failure,json=enforcingConsecutiveGatewayFailure,proto3" json:"enforcing_consecutive_gateway_failure,omitempty"`
	// Determines whether to distinguish local origin failures from external errors. If set to true
	// the following configuration parameters are taken into account:
	// `consecutive_local_origin_failure (envoy_api_field_cluster.OutlierDetection.consecutive_local_origin_failure)`,
	// `enforcing_consecutive_local_origin_failure (envoy_api_field_cluster.OutlierDetection.enforcing_consecutive_local_origin_failure)`
	// and
	// `enforcing_local_origin_success_rate (envoy_api_field_cluster.OutlierDetection.enforcing_local_origin_success_rate)`.
	// Defaults to false.
	SplitExternalLocalOriginErrors bool `protobuf:"varint,12,opt,name=split_external_local_origin_errors,json=splitExternalLocalOriginErrors,proto3" json:"split_external_local_origin_errors,omitempty"`
	// The number of consecutive locally originated failures before ejection
	// occurs. Defaults to 5. Parameter takes effect only when
	// `split_external_local_origin_errors (envoy_api_field_cluster.OutlierDetection.split_external_local_origin_errors)`
	// is set to true.
	ConsecutiveLocalOriginFailure *types.UInt32Value `protobuf:"bytes,13,opt,name=consecutive_local_origin_failure,json=consecutiveLocalOriginFailure,proto3" json:"consecutive_local_origin_failure,omitempty"`
	// The % chance that a host will be actually ejected when an outlier status
	// is detected through consecutive locally originated failures. This setting can be
	// used to disable ejection or to ramp it up slowly. Defaults to 100.
	// Parameter takes effect only when
	// `split_external_local_origin_errors (envoy_api_field_cluster.OutlierDetection.split_external_local_origin_errors)`
	// is set to true.
	EnforcingConsecutiveLocalOriginFailure *types.UInt32Value `protobuf:"bytes,14,opt,name=enforcing_consecutive_local_origin_failure,json=enforcingConsecutiveLocalOriginFailure,proto3" json:"enforcing_consecutive_local_origin_failure,omitempty"`
	// The % chance that a host will be actually ejected when an outlier status
	// is detected through success rate statistics for locally originated errors.
	// This setting can be used to disable ejection or to ramp it up slowly. Defaults to 100.
	// Parameter takes effect only when
	// `split_external_local_origin_errors (envoy_api_field_cluster.OutlierDetection.split_external_local_origin_errors)`
	// is set to true.
	EnforcingLocalOriginSuccessRate *types.UInt32Value `protobuf:"bytes,15,opt,name=enforcing_local_origin_success_rate,json=enforcingLocalOriginSuccessRate,proto3" json:"enforcing_local_origin_success_rate,omitempty"`
	XXX_NoUnkeyedLiteral            struct{}           `json:"-"`
	XXX_unrecognized                []byte             `json:"-"`
	XXX_sizecache                   int32              `json:"-"`
}

func (m *OutlierDetection) Reset()         { *m = OutlierDetection{} }
func (m *OutlierDetection) String() string { return proto.CompactTextString(m) }
func (*OutlierDetection) ProtoMessage()    {}
func (*OutlierDetection) Descriptor() ([]byte, []int) {
	return fileDescriptor_d66ea649b88221e5, []int{0}
}
func (m *OutlierDetection) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_OutlierDetection.Unmarshal(m, b)
}
func (m *OutlierDetection) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_OutlierDetection.Marshal(b, m, deterministic)
}
func (m *OutlierDetection) XXX_Merge(src proto.Message) {
	xxx_messageInfo_OutlierDetection.Merge(m, src)
}
func (m *OutlierDetection) XXX_Size() int {
	return xxx_messageInfo_OutlierDetection.Size(m)
}
func (m *OutlierDetection) XXX_DiscardUnknown() {
	xxx_messageInfo_OutlierDetection.DiscardUnknown(m)
}

var xxx_messageInfo_OutlierDetection proto.InternalMessageInfo

func (m *OutlierDetection) GetConsecutive_5Xx() *types.UInt32Value {
	if m != nil {
		return m.Consecutive_5Xx
	}
	return nil
}

func (m *OutlierDetection) GetInterval() *types.Duration {
	if m != nil {
		return m.Interval
	}
	return nil
}

func (m *OutlierDetection) GetBaseEjectionTime() *types.Duration {
	if m != nil {
		return m.BaseEjectionTime
	}
	return nil
}

func (m *OutlierDetection) GetMaxEjectionPercent() *types.UInt32Value {
	if m != nil {
		return m.MaxEjectionPercent
	}
	return nil
}

func (m *OutlierDetection) GetEnforcingConsecutive_5Xx() *types.UInt32Value {
	if m != nil {
		return m.EnforcingConsecutive_5Xx
	}
	return nil
}

func (m *OutlierDetection) GetEnforcingSuccessRate() *types.UInt32Value {
	if m != nil {
		return m.EnforcingSuccessRate
	}
	return nil
}

func (m *OutlierDetection) GetSuccessRateMinimumHosts() *types.UInt32Value {
	if m != nil {
		return m.SuccessRateMinimumHosts
	}
	return nil
}

func (m *OutlierDetection) GetSuccessRateRequestVolume() *types.UInt32Value {
	if m != nil {
		return m.SuccessRateRequestVolume
	}
	return nil
}

func (m *OutlierDetection) GetSuccessRateStdevFactor() *types.UInt32Value {
	if m != nil {
		return m.SuccessRateStdevFactor
	}
	return nil
}

func (m *OutlierDetection) GetConsecutiveGatewayFailure() *types.UInt32Value {
	if m != nil {
		return m.ConsecutiveGatewayFailure
	}
	return nil
}

func (m *OutlierDetection) GetEnforcingConsecutiveGatewayFailure() *types.UInt32Value {
	if m != nil {
		return m.EnforcingConsecutiveGatewayFailure
	}
	return nil
}

func (m *OutlierDetection) GetSplitExternalLocalOriginErrors() bool {
	if m != nil {
		return m.SplitExternalLocalOriginErrors
	}
	return false
}

func (m *OutlierDetection) GetConsecutiveLocalOriginFailure() *types.UInt32Value {
	if m != nil {
		return m.ConsecutiveLocalOriginFailure
	}
	return nil
}

func (m *OutlierDetection) GetEnforcingConsecutiveLocalOriginFailure() *types.UInt32Value {
	if m != nil {
		return m.EnforcingConsecutiveLocalOriginFailure
	}
	return nil
}

func (m *OutlierDetection) GetEnforcingLocalOriginSuccessRate() *types.UInt32Value {
	if m != nil {
		return m.EnforcingLocalOriginSuccessRate
	}
	return nil
}

func init() {
	proto.RegisterType((*OutlierDetection)(nil), "envoy.api.v2.cluster.OutlierDetection")
}

func init() {
	proto.RegisterFile("github.com/solo-io/gloo/projects/gloo/api/external/envoy/api/v2/cluster/outlier_detection.proto", fileDescriptor_d66ea649b88221e5)
}

var fileDescriptor_d66ea649b88221e5 = []byte{
	// 688 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x94, 0x95, 0x5f, 0x4f, 0xdb, 0x3a,
	0x18, 0xc6, 0x4f, 0x38, 0xfc, 0xe9, 0x31, 0xe7, 0x00, 0xb2, 0x7a, 0x20, 0x85, 0x8d, 0xa1, 0x4e,
	0x9b, 0x10, 0xd2, 0x12, 0xa9, 0x88, 0xeb, 0x49, 0x1d, 0x65, 0xff, 0x05, 0x2b, 0x1b, 0x68, 0x63,
	0x92, 0xe5, 0xa6, 0x6f, 0x83, 0x99, 0x13, 0x67, 0xb6, 0x13, 0xc2, 0xe5, 0xbe, 0xc2, 0x6e, 0xf7,
	0x05, 0xa6, 0x7d, 0x82, 0x7d, 0x9e, 0x7d, 0x87, 0xdd, 0x70, 0x35, 0x35, 0x69, 0xda, 0xb4, 0x44,
	0x22, 0xbd, 0x73, 0xec, 0xf7, 0xf9, 0x3d, 0x8f, 0x5f, 0x27, 0x31, 0x22, 0x2e, 0xd3, 0xe7, 0x61,
	0xc7, 0x72, 0x84, 0x67, 0x2b, 0xc1, 0xc5, 0x23, 0x26, 0x6c, 0x97, 0x0b, 0x61, 0x07, 0x52, 0x5c,
	0x80, 0xa3, 0x55, 0xfa, 0x44, 0x03, 0x66, 0x43, 0xac, 0x41, 0xfa, 0x94, 0xdb, 0xe0, 0x47, 0xe2,
	0x2a, 0x99, 0x8a, 0x1a, 0xb6, 0xc3, 0x43, 0xa5, 0x41, 0xda, 0x22, 0xd4, 0x9c, 0x81, 0x24, 0x5d,
	0xd0, 0xe0, 0x68, 0x26, 0x7c, 0x2b, 0x90, 0x42, 0x0b, 0x5c, 0x4d, 0xaa, 0x2d, 0x1a, 0x30, 0x2b,
	0x6a, 0x58, 0x83, 0xea, 0xf5, 0x4d, 0x57, 0x08, 0x97, 0x83, 0x9d, 0xd4, 0x74, 0xc2, 0x9e, 0xdd,
	0x0d, 0x25, 0x1d, 0xa9, 0x6e, 0xae, 0x5f, 0x4a, 0x1a, 0x04, 0x20, 0xd5, 0x60, 0x7d, 0x2d, 0xa2,
	0x9c, 0x75, 0xa9, 0x06, 0x3b, 0x1b, 0x0c, 0x16, 0xaa, 0xae, 0x70, 0x45, 0x32, 0xb4, 0xfb, 0xa3,
	0xc1, 0x2c, 0x86, 0x58, 0xa7, 0x93, 0x10, 0xeb, 0x74, 0xae, 0xfe, 0x6d, 0x11, 0xad, 0x1c, 0xa6,
	0xa1, 0xf7, 0xb3, 0xcc, 0xb8, 0x85, 0x96, 0x1d, 0xe1, 0x2b, 0x70, 0x42, 0xcd, 0x22, 0x20, 0x7b,
	0x71, 0x6c, 0x1a, 0x5b, 0xc6, 0xf6, 0x62, 0xe3, 0x8e, 0x95, 0x26, 0xb2, 0xb2, 0x44, 0xd6, 0xbb,
	0xe7, 0xbe, 0xde, 0x6d, 0x9c, 0x50, 0x1e, 0x42, 0x7b, 0x29, 0x27, 0xda, 0x8b, 0x63, 0xfc, 0x18,
	0x55, 0x98, 0xaf, 0x41, 0x46, 0x94, 0x9b, 0x33, 0x89, 0xbe, 0x76, 0x43, 0xbf, 0x3f, 0xd8, 0x71,
	0xb3, 0x72, 0xdd, 0x9c, 0xfb, 0x61, 0xcc, 0xec, 0xfc, 0xd5, 0x1e, 0x8a, 0xf0, 0x1b, 0x84, 0x3b,
	0x54, 0x01, 0x81, 0x8b, 0x34, 0x18, 0xd1, 0xcc, 0x03, 0xf3, 0xef, 0xf2, 0xa8, 0x95, 0xbe, 0xbc,
	0x35, 0x50, 0xbf, 0x65, 0x1e, 0xe0, 0x53, 0x54, 0xf5, 0x68, 0x3c, 0x22, 0x06, 0x20, 0x1d, 0xf0,
	0xb5, 0x39, 0x7b, 0xfb, 0xfe, 0x9a, 0x0b, 0xd7, 0xcd, 0xd9, 0x9d, 0x19, 0xb3, 0xdb, 0xc6, 0x1e,
	0x8d, 0x33, 0xea, 0x51, 0x0a, 0xc0, 0x14, 0xd5, 0xc0, 0xef, 0x09, 0xe9, 0x30, 0xdf, 0x25, 0x93,
	0xdd, 0x9b, 0x9b, 0x86, 0xbe, 0x36, 0xe4, 0x3c, 0x19, 0xef, 0xe7, 0x19, 0x5a, 0x1d, 0x59, 0xa8,
	0xd0, 0x71, 0x40, 0x29, 0x22, 0xa9, 0x06, 0x73, 0x7e, 0x1a, 0x7e, 0x75, 0x08, 0x39, 0x4e, 0x19,
	0x6d, 0xaa, 0x01, 0xbf, 0x47, 0xeb, 0x79, 0x24, 0xf1, 0x98, 0xcf, 0xbc, 0xd0, 0x23, 0xe7, 0x42,
	0x69, 0x65, 0x2e, 0x94, 0x38, 0xfe, 0x35, 0x35, 0xc2, 0xbd, 0x4e, 0xd5, 0xcf, 0xfa, 0x62, 0x7c,
	0x86, 0x36, 0xc6, 0xd0, 0x12, 0x3e, 0x87, 0xa0, 0x34, 0x89, 0x04, 0x0f, 0x3d, 0x30, 0x2b, 0x25,
	0xd8, 0x66, 0x8e, 0xdd, 0x4e, 0xe5, 0x27, 0x89, 0x1a, 0x9f, 0xa2, 0xda, 0x18, 0x5c, 0xe9, 0x2e,
	0x44, 0xa4, 0x47, 0x1d, 0x2d, 0xa4, 0xf9, 0x4f, 0x09, 0xf4, 0x6a, 0x0e, 0x7d, 0xdc, 0x17, 0x1f,
	0x24, 0x5a, 0xfc, 0x11, 0x6d, 0xe4, 0x8f, 0xd1, 0xa5, 0x1a, 0x2e, 0xe9, 0x15, 0xe9, 0x51, 0xc6,
	0x43, 0x09, 0x26, 0x2a, 0x81, 0xae, 0xe5, 0x00, 0x4f, 0x53, 0xfd, 0x41, 0x2a, 0xc7, 0x31, 0x7a,
	0x50, 0xfc, 0xba, 0x4c, 0xfa, 0x2c, 0x4e, 0x73, 0xb4, 0xf5, 0xa2, 0x57, 0x67, 0xc2, 0xf9, 0x05,
	0xaa, 0xab, 0x80, 0x33, 0x4d, 0xb2, 0x3f, 0x19, 0xe1, 0xc2, 0xa1, 0x9c, 0x08, 0xc9, 0x5c, 0xe6,
	0x13, 0x90, 0x52, 0x48, 0x65, 0xfe, 0xbb, 0x65, 0x6c, 0x57, 0xda, 0x9b, 0x49, 0x65, 0x6b, 0x50,
	0xf8, 0xaa, 0x5f, 0x77, 0x98, 0x94, 0xb5, 0x92, 0x2a, 0x0c, 0x68, 0x2b, 0x9f, 0x7d, 0x0c, 0x94,
	0x6d, 0xe0, 0xbf, 0x12, 0x8d, 0xba, 0x9b, 0xa3, 0xe4, 0x5c, 0xb2, 0xc8, 0x5f, 0x0c, 0xb4, 0x53,
	0xdc, 0xad, 0x42, 0xc7, 0xa5, 0x69, 0x5a, 0xf6, 0xb0, 0xa8, 0x65, 0x05, 0x19, 0x14, 0xba, 0x3f,
	0x8a, 0x30, 0x66, 0x3b, 0xf6, 0x25, 0x2e, 0x4f, 0xe3, 0x7d, 0x6f, 0x48, 0xcc, 0x19, 0xe6, 0x3e,
	0xca, 0xe6, 0x57, 0xe3, 0xe7, 0xef, 0x59, 0xe3, 0xfb, 0xaf, 0x4d, 0x03, 0xd5, 0x99, 0xb0, 0x92,
	0x4b, 0x24, 0x90, 0x22, 0xbe, 0xb2, 0x8a, 0xee, 0x93, 0xe6, 0xff, 0x93, 0x7f, 0xf2, 0xa3, 0xbe,
	0xfd, 0x91, 0xf1, 0xe1, 0x65, 0xb9, 0xfb, 0x2d, 0xf8, 0xe4, 0xde, 0x7e, 0xc7, 0x75, 0xe6, 0x93,
	0x4d, 0xed, 0xfe, 0x09, 0x00, 0x00, 0xff, 0xff, 0xba, 0xeb, 0x4f, 0x8e, 0x35, 0x07, 0x00, 0x00,
}

func (this *OutlierDetection) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*OutlierDetection)
	if !ok {
		that2, ok := that.(OutlierDetection)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.Consecutive_5Xx.Equal(that1.Consecutive_5Xx) {
		return false
	}
	if !this.Interval.Equal(that1.Interval) {
		return false
	}
	if !this.BaseEjectionTime.Equal(that1.BaseEjectionTime) {
		return false
	}
	if !this.MaxEjectionPercent.Equal(that1.MaxEjectionPercent) {
		return false
	}
	if !this.EnforcingConsecutive_5Xx.Equal(that1.EnforcingConsecutive_5Xx) {
		return false
	}
	if !this.EnforcingSuccessRate.Equal(that1.EnforcingSuccessRate) {
		return false
	}
	if !this.SuccessRateMinimumHosts.Equal(that1.SuccessRateMinimumHosts) {
		return false
	}
	if !this.SuccessRateRequestVolume.Equal(that1.SuccessRateRequestVolume) {
		return false
	}
	if !this.SuccessRateStdevFactor.Equal(that1.SuccessRateStdevFactor) {
		return false
	}
	if !this.ConsecutiveGatewayFailure.Equal(that1.ConsecutiveGatewayFailure) {
		return false
	}
	if !this.EnforcingConsecutiveGatewayFailure.Equal(that1.EnforcingConsecutiveGatewayFailure) {
		return false
	}
	if this.SplitExternalLocalOriginErrors != that1.SplitExternalLocalOriginErrors {
		return false
	}
	if !this.ConsecutiveLocalOriginFailure.Equal(that1.ConsecutiveLocalOriginFailure) {
		return false
	}
	if !this.EnforcingConsecutiveLocalOriginFailure.Equal(that1.EnforcingConsecutiveLocalOriginFailure) {
		return false
	}
	if !this.EnforcingLocalOriginSuccessRate.Equal(that1.EnforcingLocalOriginSuccessRate) {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
