// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: github.com/solo-io/gloo/projects/gloo/api/external/envoy/api/v2/core/health_check.proto

package core

import (
	bytes "bytes"
	fmt "fmt"
	math "math"
	time "time"

	_ "github.com/envoyproxy/protoc-gen-validate/validate"
	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/gogo/protobuf/proto"
	types "github.com/gogo/protobuf/types"
	_type "github.com/solo-io/gloo/projects/gloo/pkg/api/external/envoy/type"
	_ "github.com/solo-io/protoc-gen-ext/extproto"
	core "github.com/solo-io/solo-kit/pkg/api/external/envoy/api/v2/core"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf
var _ = time.Kitchen

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

// Endpoint health status.
type HealthStatus int32

const (
	// The health status is not known. This is interpreted by Envoy as *HEALTHY*.
	HealthStatus_UNKNOWN HealthStatus = 0
	// Healthy.
	HealthStatus_HEALTHY HealthStatus = 1
	// Unhealthy.
	HealthStatus_UNHEALTHY HealthStatus = 2
	// Connection draining in progress. E.g.,
	// `<https://aws.amazon.com/blogs/aws/elb-connection-draining-remove-instances-from-service-with-care/>`_
	// or
	// `<https://cloud.google.com/compute/docs/load-balancing/enabling-connection-draining>`_.
	// This is interpreted by Envoy as *UNHEALTHY*.
	HealthStatus_DRAINING HealthStatus = 3
	// Health check timed out. This is part of HDS and is interpreted by Envoy as
	// *UNHEALTHY*.
	HealthStatus_TIMEOUT HealthStatus = 4
	// Degraded.
	HealthStatus_DEGRADED HealthStatus = 5
)

var HealthStatus_name = map[int32]string{
	0: "UNKNOWN",
	1: "HEALTHY",
	2: "UNHEALTHY",
	3: "DRAINING",
	4: "TIMEOUT",
	5: "DEGRADED",
}

var HealthStatus_value = map[string]int32{
	"UNKNOWN":   0,
	"HEALTHY":   1,
	"UNHEALTHY": 2,
	"DRAINING":  3,
	"TIMEOUT":   4,
	"DEGRADED":  5,
}

func (x HealthStatus) String() string {
	return proto.EnumName(HealthStatus_name, int32(x))
}

func (HealthStatus) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_2938105d5c824354, []int{0}
}

type HealthCheck struct {
	// The time to wait for a health check response. If the timeout is reached the
	// health check attempt will be considered a failure.
	Timeout *time.Duration `protobuf:"bytes,1,opt,name=timeout,proto3,stdduration" json:"timeout,omitempty"`
	// The interval between health checks.
	Interval *time.Duration `protobuf:"bytes,2,opt,name=interval,proto3,stdduration" json:"interval,omitempty"`
	// An optional jitter amount in milliseconds. If specified, Envoy will start health
	// checking after for a random time in ms between 0 and initial_jitter. This only
	// applies to the first health check.
	InitialJitter *types.Duration `protobuf:"bytes,20,opt,name=initial_jitter,json=initialJitter,proto3" json:"initial_jitter,omitempty"`
	// An optional jitter amount in milliseconds. If specified, during every
	// interval Envoy will add interval_jitter to the wait time.
	IntervalJitter *types.Duration `protobuf:"bytes,3,opt,name=interval_jitter,json=intervalJitter,proto3" json:"interval_jitter,omitempty"`
	// An optional jitter amount as a percentage of interval_ms. If specified,
	// during every interval Envoy will add interval_ms *
	// interval_jitter_percent / 100 to the wait time.
	//
	// If interval_jitter_ms and interval_jitter_percent are both set, both of
	// them will be used to increase the wait time.
	IntervalJitterPercent uint32 `protobuf:"varint,18,opt,name=interval_jitter_percent,json=intervalJitterPercent,proto3" json:"interval_jitter_percent,omitempty"`
	// The number of unhealthy health checks required before a host is marked
	// unhealthy. Note that for *http* health checking if a host responds with 503
	// this threshold is ignored and the host is considered unhealthy immediately.
	UnhealthyThreshold *types.UInt32Value `protobuf:"bytes,4,opt,name=unhealthy_threshold,json=unhealthyThreshold,proto3" json:"unhealthy_threshold,omitempty"`
	// The number of healthy health checks required before a host is marked
	// healthy. Note that during startup, only a single successful health check is
	// required to mark a host healthy.
	HealthyThreshold *types.UInt32Value `protobuf:"bytes,5,opt,name=healthy_threshold,json=healthyThreshold,proto3" json:"healthy_threshold,omitempty"`
	// Reuse health check connection between health checks. Default is true.
	ReuseConnection *types.BoolValue `protobuf:"bytes,7,opt,name=reuse_connection,json=reuseConnection,proto3" json:"reuse_connection,omitempty"`
	// Types that are valid to be assigned to HealthChecker:
	//	*HealthCheck_HttpHealthCheck_
	//	*HealthCheck_TcpHealthCheck_
	//	*HealthCheck_GrpcHealthCheck_
	//	*HealthCheck_CustomHealthCheck_
	HealthChecker isHealthCheck_HealthChecker `protobuf_oneof:"health_checker"`
	// The "no traffic interval" is a special health check interval that is used when a cluster has
	// never had traffic routed to it. This lower interval allows cluster information to be kept up to
	// date, without sending a potentially large amount of active health checking traffic for no
	// reason. Once a cluster has been used for traffic routing, Envoy will shift back to using the
	// standard health check interval that is defined. Note that this interval takes precedence over
	// any other.
	//
	// The default value for "no traffic interval" is 60 seconds.
	NoTrafficInterval *types.Duration `protobuf:"bytes,12,opt,name=no_traffic_interval,json=noTrafficInterval,proto3" json:"no_traffic_interval,omitempty"`
	// The "unhealthy interval" is a health check interval that is used for hosts that are marked as
	// unhealthy. As soon as the host is marked as healthy, Envoy will shift back to using the
	// standard health check interval that is defined.
	//
	// The default value for "unhealthy interval" is the same as "interval".
	UnhealthyInterval *types.Duration `protobuf:"bytes,14,opt,name=unhealthy_interval,json=unhealthyInterval,proto3" json:"unhealthy_interval,omitempty"`
	// The "unhealthy edge interval" is a special health check interval that is used for the first
	// health check right after a host is marked as unhealthy. For subsequent health checks
	// Envoy will shift back to using either "unhealthy interval" if present or the standard health
	// check interval that is defined.
	//
	// The default value for "unhealthy edge interval" is the same as "unhealthy interval".
	UnhealthyEdgeInterval *types.Duration `protobuf:"bytes,15,opt,name=unhealthy_edge_interval,json=unhealthyEdgeInterval,proto3" json:"unhealthy_edge_interval,omitempty"`
	// The "healthy edge interval" is a special health check interval that is used for the first
	// health check right after a host is marked as healthy. For subsequent health checks
	// Envoy will shift back to using the standard health check interval that is defined.
	//
	// The default value for "healthy edge interval" is the same as the default interval.
	HealthyEdgeInterval *types.Duration `protobuf:"bytes,16,opt,name=healthy_edge_interval,json=healthyEdgeInterval,proto3" json:"healthy_edge_interval,omitempty"`
	// Specifies the path to the `health check event log (arch_overview_health_check_logging)`.
	// If empty, no event log will be written.
	EventLogPath string `protobuf:"bytes,17,opt,name=event_log_path,json=eventLogPath,proto3" json:"event_log_path,omitempty"`
	// If set to true, health check failure events will always be logged. If set to false, only the
	// initial health check failure event will be logged.
	// The default value is false.
	AlwaysLogHealthCheckFailures bool     `protobuf:"varint,19,opt,name=always_log_health_check_failures,json=alwaysLogHealthCheckFailures,proto3" json:"always_log_health_check_failures,omitempty"`
	XXX_NoUnkeyedLiteral         struct{} `json:"-"`
	XXX_unrecognized             []byte   `json:"-"`
	XXX_sizecache                int32    `json:"-"`
}

func (m *HealthCheck) Reset()         { *m = HealthCheck{} }
func (m *HealthCheck) String() string { return proto.CompactTextString(m) }
func (*HealthCheck) ProtoMessage()    {}
func (*HealthCheck) Descriptor() ([]byte, []int) {
	return fileDescriptor_2938105d5c824354, []int{0}
}
func (m *HealthCheck) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_HealthCheck.Unmarshal(m, b)
}
func (m *HealthCheck) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_HealthCheck.Marshal(b, m, deterministic)
}
func (m *HealthCheck) XXX_Merge(src proto.Message) {
	xxx_messageInfo_HealthCheck.Merge(m, src)
}
func (m *HealthCheck) XXX_Size() int {
	return xxx_messageInfo_HealthCheck.Size(m)
}
func (m *HealthCheck) XXX_DiscardUnknown() {
	xxx_messageInfo_HealthCheck.DiscardUnknown(m)
}

var xxx_messageInfo_HealthCheck proto.InternalMessageInfo

type isHealthCheck_HealthChecker interface {
	isHealthCheck_HealthChecker()
	Equal(interface{}) bool
}

type HealthCheck_HttpHealthCheck_ struct {
	HttpHealthCheck *HealthCheck_HttpHealthCheck `protobuf:"bytes,8,opt,name=http_health_check,json=httpHealthCheck,proto3,oneof" json:"http_health_check,omitempty"`
}
type HealthCheck_TcpHealthCheck_ struct {
	TcpHealthCheck *HealthCheck_TcpHealthCheck `protobuf:"bytes,9,opt,name=tcp_health_check,json=tcpHealthCheck,proto3,oneof" json:"tcp_health_check,omitempty"`
}
type HealthCheck_GrpcHealthCheck_ struct {
	GrpcHealthCheck *HealthCheck_GrpcHealthCheck `protobuf:"bytes,11,opt,name=grpc_health_check,json=grpcHealthCheck,proto3,oneof" json:"grpc_health_check,omitempty"`
}
type HealthCheck_CustomHealthCheck_ struct {
	CustomHealthCheck *HealthCheck_CustomHealthCheck `protobuf:"bytes,13,opt,name=custom_health_check,json=customHealthCheck,proto3,oneof" json:"custom_health_check,omitempty"`
}

func (*HealthCheck_HttpHealthCheck_) isHealthCheck_HealthChecker()   {}
func (*HealthCheck_TcpHealthCheck_) isHealthCheck_HealthChecker()    {}
func (*HealthCheck_GrpcHealthCheck_) isHealthCheck_HealthChecker()   {}
func (*HealthCheck_CustomHealthCheck_) isHealthCheck_HealthChecker() {}

func (m *HealthCheck) GetHealthChecker() isHealthCheck_HealthChecker {
	if m != nil {
		return m.HealthChecker
	}
	return nil
}

func (m *HealthCheck) GetTimeout() *time.Duration {
	if m != nil {
		return m.Timeout
	}
	return nil
}

func (m *HealthCheck) GetInterval() *time.Duration {
	if m != nil {
		return m.Interval
	}
	return nil
}

func (m *HealthCheck) GetInitialJitter() *types.Duration {
	if m != nil {
		return m.InitialJitter
	}
	return nil
}

func (m *HealthCheck) GetIntervalJitter() *types.Duration {
	if m != nil {
		return m.IntervalJitter
	}
	return nil
}

func (m *HealthCheck) GetIntervalJitterPercent() uint32 {
	if m != nil {
		return m.IntervalJitterPercent
	}
	return 0
}

func (m *HealthCheck) GetUnhealthyThreshold() *types.UInt32Value {
	if m != nil {
		return m.UnhealthyThreshold
	}
	return nil
}

func (m *HealthCheck) GetHealthyThreshold() *types.UInt32Value {
	if m != nil {
		return m.HealthyThreshold
	}
	return nil
}

func (m *HealthCheck) GetReuseConnection() *types.BoolValue {
	if m != nil {
		return m.ReuseConnection
	}
	return nil
}

func (m *HealthCheck) GetHttpHealthCheck() *HealthCheck_HttpHealthCheck {
	if x, ok := m.GetHealthChecker().(*HealthCheck_HttpHealthCheck_); ok {
		return x.HttpHealthCheck
	}
	return nil
}

func (m *HealthCheck) GetTcpHealthCheck() *HealthCheck_TcpHealthCheck {
	if x, ok := m.GetHealthChecker().(*HealthCheck_TcpHealthCheck_); ok {
		return x.TcpHealthCheck
	}
	return nil
}

func (m *HealthCheck) GetGrpcHealthCheck() *HealthCheck_GrpcHealthCheck {
	if x, ok := m.GetHealthChecker().(*HealthCheck_GrpcHealthCheck_); ok {
		return x.GrpcHealthCheck
	}
	return nil
}

func (m *HealthCheck) GetCustomHealthCheck() *HealthCheck_CustomHealthCheck {
	if x, ok := m.GetHealthChecker().(*HealthCheck_CustomHealthCheck_); ok {
		return x.CustomHealthCheck
	}
	return nil
}

func (m *HealthCheck) GetNoTrafficInterval() *types.Duration {
	if m != nil {
		return m.NoTrafficInterval
	}
	return nil
}

func (m *HealthCheck) GetUnhealthyInterval() *types.Duration {
	if m != nil {
		return m.UnhealthyInterval
	}
	return nil
}

func (m *HealthCheck) GetUnhealthyEdgeInterval() *types.Duration {
	if m != nil {
		return m.UnhealthyEdgeInterval
	}
	return nil
}

func (m *HealthCheck) GetHealthyEdgeInterval() *types.Duration {
	if m != nil {
		return m.HealthyEdgeInterval
	}
	return nil
}

func (m *HealthCheck) GetEventLogPath() string {
	if m != nil {
		return m.EventLogPath
	}
	return ""
}

func (m *HealthCheck) GetAlwaysLogHealthCheckFailures() bool {
	if m != nil {
		return m.AlwaysLogHealthCheckFailures
	}
	return false
}

// XXX_OneofWrappers is for the internal use of the proto package.
func (*HealthCheck) XXX_OneofWrappers() []interface{} {
	return []interface{}{
		(*HealthCheck_HttpHealthCheck_)(nil),
		(*HealthCheck_TcpHealthCheck_)(nil),
		(*HealthCheck_GrpcHealthCheck_)(nil),
		(*HealthCheck_CustomHealthCheck_)(nil),
	}
}

// Describes the encoding of the payload bytes in the payload.
type HealthCheck_Payload struct {
	// Types that are valid to be assigned to Payload:
	//	*HealthCheck_Payload_Text
	Payload              isHealthCheck_Payload_Payload `protobuf_oneof:"payload"`
	XXX_NoUnkeyedLiteral struct{}                      `json:"-"`
	XXX_unrecognized     []byte                        `json:"-"`
	XXX_sizecache        int32                         `json:"-"`
}

func (m *HealthCheck_Payload) Reset()         { *m = HealthCheck_Payload{} }
func (m *HealthCheck_Payload) String() string { return proto.CompactTextString(m) }
func (*HealthCheck_Payload) ProtoMessage()    {}
func (*HealthCheck_Payload) Descriptor() ([]byte, []int) {
	return fileDescriptor_2938105d5c824354, []int{0, 0}
}
func (m *HealthCheck_Payload) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_HealthCheck_Payload.Unmarshal(m, b)
}
func (m *HealthCheck_Payload) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_HealthCheck_Payload.Marshal(b, m, deterministic)
}
func (m *HealthCheck_Payload) XXX_Merge(src proto.Message) {
	xxx_messageInfo_HealthCheck_Payload.Merge(m, src)
}
func (m *HealthCheck_Payload) XXX_Size() int {
	return xxx_messageInfo_HealthCheck_Payload.Size(m)
}
func (m *HealthCheck_Payload) XXX_DiscardUnknown() {
	xxx_messageInfo_HealthCheck_Payload.DiscardUnknown(m)
}

var xxx_messageInfo_HealthCheck_Payload proto.InternalMessageInfo

type isHealthCheck_Payload_Payload interface {
	isHealthCheck_Payload_Payload()
	Equal(interface{}) bool
}

type HealthCheck_Payload_Text struct {
	Text string `protobuf:"bytes,1,opt,name=text,proto3,oneof" json:"text,omitempty"`
}

func (*HealthCheck_Payload_Text) isHealthCheck_Payload_Payload() {}

func (m *HealthCheck_Payload) GetPayload() isHealthCheck_Payload_Payload {
	if m != nil {
		return m.Payload
	}
	return nil
}

func (m *HealthCheck_Payload) GetText() string {
	if x, ok := m.GetPayload().(*HealthCheck_Payload_Text); ok {
		return x.Text
	}
	return ""
}

// XXX_OneofWrappers is for the internal use of the proto package.
func (*HealthCheck_Payload) XXX_OneofWrappers() []interface{} {
	return []interface{}{
		(*HealthCheck_Payload_Text)(nil),
	}
}

// [#comment:next free field: 10]
type HealthCheck_HttpHealthCheck struct {
	// The value of the host header in the HTTP health check request. If
	// left empty (default value), the name of the cluster this health check is associated
	// with will be used.
	Host string `protobuf:"bytes,1,opt,name=host,proto3" json:"host,omitempty"`
	// Specifies the HTTP path that will be requested during health checking. For example
	// */healthcheck*.
	Path string `protobuf:"bytes,2,opt,name=path,proto3" json:"path,omitempty"`
	// An optional service name parameter which is used to validate the identity of
	// the health checked cluster. See the `architecture overview
	// (arch_overview_health_checking_identity)` for more information.
	ServiceName string `protobuf:"bytes,5,opt,name=service_name,json=serviceName,proto3" json:"service_name,omitempty"`
	// Specifies a list of HTTP headers that should be added to each request that is sent to the
	// health checked cluster. For more information, including details on header value syntax, see
	// the documentation on `custom request headers
	// (config_http_conn_man_headers_custom_request_headers)`.
	RequestHeadersToAdd []*core.HeaderValueOption `protobuf:"bytes,6,rep,name=request_headers_to_add,json=requestHeadersToAdd,proto3" json:"request_headers_to_add,omitempty"`
	// Specifies a list of HTTP headers that should be removed from each request that is sent to the
	// health checked cluster.
	RequestHeadersToRemove []string `protobuf:"bytes,8,rep,name=request_headers_to_remove,json=requestHeadersToRemove,proto3" json:"request_headers_to_remove,omitempty"`
	// If set, health checks will be made using http/2.
	UseHttp2 bool `protobuf:"varint,7,opt,name=use_http2,json=useHttp2,proto3" json:"use_http2,omitempty"`
	// Specifies a list of HTTP response statuses considered healthy. If provided, replaces default
	// 200-only policy - 200 must be included explicitly as needed. Ranges follow half-open
	// semantics of `Int64Range (envoy_api_msg_type.Int64Range)`.
	ExpectedStatuses     []*_type.Int64Range `protobuf:"bytes,9,rep,name=expected_statuses,json=expectedStatuses,proto3" json:"expected_statuses,omitempty"`
	XXX_NoUnkeyedLiteral struct{}            `json:"-"`
	XXX_unrecognized     []byte              `json:"-"`
	XXX_sizecache        int32               `json:"-"`
}

func (m *HealthCheck_HttpHealthCheck) Reset()         { *m = HealthCheck_HttpHealthCheck{} }
func (m *HealthCheck_HttpHealthCheck) String() string { return proto.CompactTextString(m) }
func (*HealthCheck_HttpHealthCheck) ProtoMessage()    {}
func (*HealthCheck_HttpHealthCheck) Descriptor() ([]byte, []int) {
	return fileDescriptor_2938105d5c824354, []int{0, 1}
}
func (m *HealthCheck_HttpHealthCheck) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_HealthCheck_HttpHealthCheck.Unmarshal(m, b)
}
func (m *HealthCheck_HttpHealthCheck) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_HealthCheck_HttpHealthCheck.Marshal(b, m, deterministic)
}
func (m *HealthCheck_HttpHealthCheck) XXX_Merge(src proto.Message) {
	xxx_messageInfo_HealthCheck_HttpHealthCheck.Merge(m, src)
}
func (m *HealthCheck_HttpHealthCheck) XXX_Size() int {
	return xxx_messageInfo_HealthCheck_HttpHealthCheck.Size(m)
}
func (m *HealthCheck_HttpHealthCheck) XXX_DiscardUnknown() {
	xxx_messageInfo_HealthCheck_HttpHealthCheck.DiscardUnknown(m)
}

var xxx_messageInfo_HealthCheck_HttpHealthCheck proto.InternalMessageInfo

func (m *HealthCheck_HttpHealthCheck) GetHost() string {
	if m != nil {
		return m.Host
	}
	return ""
}

func (m *HealthCheck_HttpHealthCheck) GetPath() string {
	if m != nil {
		return m.Path
	}
	return ""
}

func (m *HealthCheck_HttpHealthCheck) GetServiceName() string {
	if m != nil {
		return m.ServiceName
	}
	return ""
}

func (m *HealthCheck_HttpHealthCheck) GetRequestHeadersToAdd() []*core.HeaderValueOption {
	if m != nil {
		return m.RequestHeadersToAdd
	}
	return nil
}

func (m *HealthCheck_HttpHealthCheck) GetRequestHeadersToRemove() []string {
	if m != nil {
		return m.RequestHeadersToRemove
	}
	return nil
}

func (m *HealthCheck_HttpHealthCheck) GetUseHttp2() bool {
	if m != nil {
		return m.UseHttp2
	}
	return false
}

func (m *HealthCheck_HttpHealthCheck) GetExpectedStatuses() []*_type.Int64Range {
	if m != nil {
		return m.ExpectedStatuses
	}
	return nil
}

type HealthCheck_TcpHealthCheck struct {
	// Empty payloads imply a connect-only health check.
	Send *HealthCheck_Payload `protobuf:"bytes,1,opt,name=send,proto3" json:"send,omitempty"`
	// When checking the response, “fuzzy” matching is performed such that each
	// binary block must be found, and in the order specified, but not
	// necessarily contiguous.
	Receive              []*HealthCheck_Payload `protobuf:"bytes,2,rep,name=receive,proto3" json:"receive,omitempty"`
	XXX_NoUnkeyedLiteral struct{}               `json:"-"`
	XXX_unrecognized     []byte                 `json:"-"`
	XXX_sizecache        int32                  `json:"-"`
}

func (m *HealthCheck_TcpHealthCheck) Reset()         { *m = HealthCheck_TcpHealthCheck{} }
func (m *HealthCheck_TcpHealthCheck) String() string { return proto.CompactTextString(m) }
func (*HealthCheck_TcpHealthCheck) ProtoMessage()    {}
func (*HealthCheck_TcpHealthCheck) Descriptor() ([]byte, []int) {
	return fileDescriptor_2938105d5c824354, []int{0, 2}
}
func (m *HealthCheck_TcpHealthCheck) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_HealthCheck_TcpHealthCheck.Unmarshal(m, b)
}
func (m *HealthCheck_TcpHealthCheck) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_HealthCheck_TcpHealthCheck.Marshal(b, m, deterministic)
}
func (m *HealthCheck_TcpHealthCheck) XXX_Merge(src proto.Message) {
	xxx_messageInfo_HealthCheck_TcpHealthCheck.Merge(m, src)
}
func (m *HealthCheck_TcpHealthCheck) XXX_Size() int {
	return xxx_messageInfo_HealthCheck_TcpHealthCheck.Size(m)
}
func (m *HealthCheck_TcpHealthCheck) XXX_DiscardUnknown() {
	xxx_messageInfo_HealthCheck_TcpHealthCheck.DiscardUnknown(m)
}

var xxx_messageInfo_HealthCheck_TcpHealthCheck proto.InternalMessageInfo

func (m *HealthCheck_TcpHealthCheck) GetSend() *HealthCheck_Payload {
	if m != nil {
		return m.Send
	}
	return nil
}

func (m *HealthCheck_TcpHealthCheck) GetReceive() []*HealthCheck_Payload {
	if m != nil {
		return m.Receive
	}
	return nil
}

type HealthCheck_RedisHealthCheck struct {
	// If set, optionally perform ``EXISTS <key>`` instead of ``PING``. A return value
	// from Redis of 0 (does not exist) is considered a passing healthcheck. A return value other
	// than 0 is considered a failure. This allows the user to mark a Redis instance for maintenance
	// by setting the specified key to any value and waiting for traffic to drain.
	Key                  string   `protobuf:"bytes,1,opt,name=key,proto3" json:"key,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *HealthCheck_RedisHealthCheck) Reset()         { *m = HealthCheck_RedisHealthCheck{} }
func (m *HealthCheck_RedisHealthCheck) String() string { return proto.CompactTextString(m) }
func (*HealthCheck_RedisHealthCheck) ProtoMessage()    {}
func (*HealthCheck_RedisHealthCheck) Descriptor() ([]byte, []int) {
	return fileDescriptor_2938105d5c824354, []int{0, 3}
}
func (m *HealthCheck_RedisHealthCheck) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_HealthCheck_RedisHealthCheck.Unmarshal(m, b)
}
func (m *HealthCheck_RedisHealthCheck) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_HealthCheck_RedisHealthCheck.Marshal(b, m, deterministic)
}
func (m *HealthCheck_RedisHealthCheck) XXX_Merge(src proto.Message) {
	xxx_messageInfo_HealthCheck_RedisHealthCheck.Merge(m, src)
}
func (m *HealthCheck_RedisHealthCheck) XXX_Size() int {
	return xxx_messageInfo_HealthCheck_RedisHealthCheck.Size(m)
}
func (m *HealthCheck_RedisHealthCheck) XXX_DiscardUnknown() {
	xxx_messageInfo_HealthCheck_RedisHealthCheck.DiscardUnknown(m)
}

var xxx_messageInfo_HealthCheck_RedisHealthCheck proto.InternalMessageInfo

func (m *HealthCheck_RedisHealthCheck) GetKey() string {
	if m != nil {
		return m.Key
	}
	return ""
}

// `grpc.health.v1.Health
// <https://github.com/grpc/grpc/blob/master/src/proto/grpc/health/v1/health.proto>`_-based
// healthcheck. See `gRPC doc <https://github.com/grpc/grpc/blob/master/doc/health-checking.md>`_
// for details.
type HealthCheck_GrpcHealthCheck struct {
	// An optional service name parameter which will be sent to gRPC service in
	// `grpc.health.v1.HealthCheckRequest
	// <https://github.com/grpc/grpc/blob/master/src/proto/grpc/health/v1/health.proto#L20>`_.
	// message. See `gRPC health-checking overview
	// <https://github.com/grpc/grpc/blob/master/doc/health-checking.md>`_ for more information.
	ServiceName string `protobuf:"bytes,1,opt,name=service_name,json=serviceName,proto3" json:"service_name,omitempty"`
	// The value of the :authority header in the gRPC health check request. If
	// left empty (default value), the name of the cluster this health check is associated
	// with will be used.
	Authority            string   `protobuf:"bytes,2,opt,name=authority,proto3" json:"authority,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *HealthCheck_GrpcHealthCheck) Reset()         { *m = HealthCheck_GrpcHealthCheck{} }
func (m *HealthCheck_GrpcHealthCheck) String() string { return proto.CompactTextString(m) }
func (*HealthCheck_GrpcHealthCheck) ProtoMessage()    {}
func (*HealthCheck_GrpcHealthCheck) Descriptor() ([]byte, []int) {
	return fileDescriptor_2938105d5c824354, []int{0, 4}
}
func (m *HealthCheck_GrpcHealthCheck) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_HealthCheck_GrpcHealthCheck.Unmarshal(m, b)
}
func (m *HealthCheck_GrpcHealthCheck) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_HealthCheck_GrpcHealthCheck.Marshal(b, m, deterministic)
}
func (m *HealthCheck_GrpcHealthCheck) XXX_Merge(src proto.Message) {
	xxx_messageInfo_HealthCheck_GrpcHealthCheck.Merge(m, src)
}
func (m *HealthCheck_GrpcHealthCheck) XXX_Size() int {
	return xxx_messageInfo_HealthCheck_GrpcHealthCheck.Size(m)
}
func (m *HealthCheck_GrpcHealthCheck) XXX_DiscardUnknown() {
	xxx_messageInfo_HealthCheck_GrpcHealthCheck.DiscardUnknown(m)
}

var xxx_messageInfo_HealthCheck_GrpcHealthCheck proto.InternalMessageInfo

func (m *HealthCheck_GrpcHealthCheck) GetServiceName() string {
	if m != nil {
		return m.ServiceName
	}
	return ""
}

func (m *HealthCheck_GrpcHealthCheck) GetAuthority() string {
	if m != nil {
		return m.Authority
	}
	return ""
}

// Custom health check.
type HealthCheck_CustomHealthCheck struct {
	// The registered name of the custom health checker.
	Name string `protobuf:"bytes,1,opt,name=name,proto3" json:"name,omitempty"`
	// A custom health checker specific configuration which depends on the custom health checker
	// being instantiated. See :api:`envoy/config/health_checker` for reference.
	//
	// Types that are valid to be assigned to ConfigType:
	//	*HealthCheck_CustomHealthCheck_Config
	//	*HealthCheck_CustomHealthCheck_TypedConfig
	ConfigType           isHealthCheck_CustomHealthCheck_ConfigType `protobuf_oneof:"config_type"`
	XXX_NoUnkeyedLiteral struct{}                                   `json:"-"`
	XXX_unrecognized     []byte                                     `json:"-"`
	XXX_sizecache        int32                                      `json:"-"`
}

func (m *HealthCheck_CustomHealthCheck) Reset()         { *m = HealthCheck_CustomHealthCheck{} }
func (m *HealthCheck_CustomHealthCheck) String() string { return proto.CompactTextString(m) }
func (*HealthCheck_CustomHealthCheck) ProtoMessage()    {}
func (*HealthCheck_CustomHealthCheck) Descriptor() ([]byte, []int) {
	return fileDescriptor_2938105d5c824354, []int{0, 5}
}
func (m *HealthCheck_CustomHealthCheck) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_HealthCheck_CustomHealthCheck.Unmarshal(m, b)
}
func (m *HealthCheck_CustomHealthCheck) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_HealthCheck_CustomHealthCheck.Marshal(b, m, deterministic)
}
func (m *HealthCheck_CustomHealthCheck) XXX_Merge(src proto.Message) {
	xxx_messageInfo_HealthCheck_CustomHealthCheck.Merge(m, src)
}
func (m *HealthCheck_CustomHealthCheck) XXX_Size() int {
	return xxx_messageInfo_HealthCheck_CustomHealthCheck.Size(m)
}
func (m *HealthCheck_CustomHealthCheck) XXX_DiscardUnknown() {
	xxx_messageInfo_HealthCheck_CustomHealthCheck.DiscardUnknown(m)
}

var xxx_messageInfo_HealthCheck_CustomHealthCheck proto.InternalMessageInfo

type isHealthCheck_CustomHealthCheck_ConfigType interface {
	isHealthCheck_CustomHealthCheck_ConfigType()
	Equal(interface{}) bool
}

type HealthCheck_CustomHealthCheck_Config struct {
	Config *types.Struct `protobuf:"bytes,2,opt,name=config,proto3,oneof" json:"config,omitempty"`
}
type HealthCheck_CustomHealthCheck_TypedConfig struct {
	TypedConfig *types.Any `protobuf:"bytes,3,opt,name=typed_config,json=typedConfig,proto3,oneof" json:"typed_config,omitempty"`
}

func (*HealthCheck_CustomHealthCheck_Config) isHealthCheck_CustomHealthCheck_ConfigType()      {}
func (*HealthCheck_CustomHealthCheck_TypedConfig) isHealthCheck_CustomHealthCheck_ConfigType() {}

func (m *HealthCheck_CustomHealthCheck) GetConfigType() isHealthCheck_CustomHealthCheck_ConfigType {
	if m != nil {
		return m.ConfigType
	}
	return nil
}

func (m *HealthCheck_CustomHealthCheck) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *HealthCheck_CustomHealthCheck) GetConfig() *types.Struct {
	if x, ok := m.GetConfigType().(*HealthCheck_CustomHealthCheck_Config); ok {
		return x.Config
	}
	return nil
}

func (m *HealthCheck_CustomHealthCheck) GetTypedConfig() *types.Any {
	if x, ok := m.GetConfigType().(*HealthCheck_CustomHealthCheck_TypedConfig); ok {
		return x.TypedConfig
	}
	return nil
}

// XXX_OneofWrappers is for the internal use of the proto package.
func (*HealthCheck_CustomHealthCheck) XXX_OneofWrappers() []interface{} {
	return []interface{}{
		(*HealthCheck_CustomHealthCheck_Config)(nil),
		(*HealthCheck_CustomHealthCheck_TypedConfig)(nil),
	}
}

func init() {
	proto.RegisterEnum("envoy.api.v2.core.HealthStatus", HealthStatus_name, HealthStatus_value)
	proto.RegisterType((*HealthCheck)(nil), "envoy.api.v2.core.HealthCheck")
	proto.RegisterType((*HealthCheck_Payload)(nil), "envoy.api.v2.core.HealthCheck.Payload")
	proto.RegisterType((*HealthCheck_HttpHealthCheck)(nil), "envoy.api.v2.core.HealthCheck.HttpHealthCheck")
	proto.RegisterType((*HealthCheck_TcpHealthCheck)(nil), "envoy.api.v2.core.HealthCheck.TcpHealthCheck")
	proto.RegisterType((*HealthCheck_RedisHealthCheck)(nil), "envoy.api.v2.core.HealthCheck.RedisHealthCheck")
	proto.RegisterType((*HealthCheck_GrpcHealthCheck)(nil), "envoy.api.v2.core.HealthCheck.GrpcHealthCheck")
	proto.RegisterType((*HealthCheck_CustomHealthCheck)(nil), "envoy.api.v2.core.HealthCheck.CustomHealthCheck")
}

func init() {
	proto.RegisterFile("github.com/solo-io/gloo/projects/gloo/api/external/envoy/api/v2/core/health_check.proto", fileDescriptor_2938105d5c824354)
}

var fileDescriptor_2938105d5c824354 = []byte{
	// 1216 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x94, 0x96, 0xcd, 0x6e, 0xdb, 0x46,
	0x10, 0xc7, 0x45, 0x49, 0xb1, 0xa4, 0x95, 0x2d, 0x53, 0xeb, 0xd8, 0x66, 0x14, 0x37, 0x51, 0x8b,
	0xa0, 0x30, 0x02, 0x84, 0x6a, 0x95, 0x22, 0x68, 0x7a, 0x8a, 0x69, 0x2b, 0x91, 0xd2, 0x44, 0x31,
	0x36, 0x72, 0x83, 0xb4, 0x05, 0xd8, 0x35, 0x39, 0xa6, 0x18, 0xd3, 0x5c, 0x76, 0xb9, 0x54, 0xac,
	0x27, 0xe8, 0xad, 0x40, 0x7b, 0xea, 0x23, 0x14, 0x01, 0x7a, 0xef, 0xdb, 0x14, 0xe8, 0x29, 0x2f,
	0x50, 0xa0, 0xf0, 0xa9, 0xe0, 0x92, 0x92, 0xf5, 0xe1, 0x42, 0xca, 0x6d, 0x77, 0x66, 0xfe, 0xbf,
	0xfd, 0x98, 0x9d, 0x21, 0xd1, 0x2b, 0xc7, 0x15, 0xfd, 0xe8, 0x58, 0xb7, 0xd8, 0x59, 0x23, 0x64,
	0x1e, 0xbb, 0xe7, 0xb2, 0x86, 0xe3, 0x31, 0xd6, 0x08, 0x38, 0x7b, 0x03, 0x96, 0x08, 0x93, 0x19,
	0x0d, 0xdc, 0x06, 0x9c, 0x0b, 0xe0, 0x3e, 0xf5, 0x1a, 0xe0, 0x0f, 0xd8, 0x50, 0x9a, 0x06, 0xcd,
	0x86, 0xc5, 0x38, 0x34, 0xfa, 0x40, 0x3d, 0xd1, 0x37, 0xad, 0x3e, 0x58, 0xa7, 0x7a, 0xc0, 0x99,
	0x60, 0xb8, 0x2a, 0xa3, 0x74, 0x1a, 0xb8, 0xfa, 0xa0, 0xa9, 0xc7, 0x51, 0xb5, 0x9d, 0x79, 0xe1,
	0x31, 0x0d, 0x21, 0x11, 0xd4, 0xb6, 0x12, 0xaf, 0x18, 0x06, 0xd0, 0xe0, 0xd4, 0x77, 0x46, 0xf6,
	0x1b, 0x0e, 0x63, 0x8e, 0x07, 0x0d, 0x39, 0x3b, 0x8e, 0x4e, 0x1a, 0xd4, 0x1f, 0xa6, 0xae, 0x5b,
	0xb3, 0x2e, 0x3b, 0xe2, 0x54, 0xb8, 0xcc, 0x4f, 0xfd, 0x3b, 0xb3, 0xfe, 0x50, 0xf0, 0xc8, 0x12,
	0xff, 0xa7, 0x7e, 0xcb, 0x69, 0x10, 0x00, 0x0f, 0x53, 0xff, 0xf6, 0x80, 0x7a, 0xae, 0x4d, 0x05,
	0x34, 0x46, 0x83, 0xd4, 0x71, 0xdd, 0x61, 0x0e, 0x93, 0xc3, 0x46, 0x3c, 0x4a, 0xad, 0x18, 0xce,
	0x45, 0x62, 0x84, 0xf3, 0x74, 0x89, 0x4f, 0x7e, 0xc1, 0xa8, 0xdc, 0x96, 0x77, 0xb3, 0x1f, 0x5f,
	0x0d, 0xde, 0x47, 0x05, 0xe1, 0x9e, 0x01, 0x8b, 0x84, 0xa6, 0xd4, 0x95, 0xdd, 0x72, 0xf3, 0x86,
	0x9e, 0x6c, 0x42, 0x1f, 0x6d, 0x42, 0x3f, 0x48, 0x8f, 0x60, 0x54, 0x2e, 0x8c, 0xc2, 0x3b, 0x25,
	0x5f, 0x54, 0xee, 0x66, 0x7e, 0xfb, 0xeb, 0xb6, 0x42, 0x46, 0x4a, 0xdc, 0x42, 0x45, 0xd7, 0x17,
	0xc0, 0x07, 0xd4, 0xd3, 0xb2, 0x1f, 0x4a, 0x19, 0x4b, 0xf1, 0x23, 0x54, 0x71, 0x7d, 0x57, 0xb8,
	0xd4, 0x33, 0xdf, 0xb8, 0x42, 0x00, 0xd7, 0xae, 0x2f, 0x80, 0x91, 0xb5, 0x54, 0xf0, 0x54, 0xc6,
	0x63, 0x03, 0xad, 0x8f, 0x68, 0x23, 0x44, 0x6e, 0x11, 0xa2, 0x32, 0x52, 0xa4, 0x8c, 0x07, 0x68,
	0x7b, 0x86, 0x61, 0x06, 0xc0, 0x2d, 0xf0, 0x85, 0x86, 0xeb, 0xca, 0xee, 0x1a, 0xd9, 0x9c, 0x16,
	0x1c, 0x26, 0x4e, 0xfc, 0x1c, 0x6d, 0x44, 0x7e, 0xf2, 0xec, 0x86, 0xa6, 0xe8, 0x73, 0x08, 0xfb,
	0xcc, 0xb3, 0xb5, 0xbc, 0x5c, 0x7f, 0x67, 0x6e, 0xfd, 0xa3, 0x8e, 0x2f, 0xee, 0x37, 0xbf, 0xa1,
	0x5e, 0x04, 0x04, 0x8f, 0x85, 0xbd, 0x91, 0x0e, 0x77, 0x50, 0x75, 0x1e, 0x76, 0x6d, 0x09, 0x98,
	0x3a, 0x87, 0x6a, 0x21, 0x95, 0x43, 0x14, 0x82, 0x69, 0x31, 0xdf, 0x07, 0x2b, 0x3e, 0xb5, 0x56,
	0x90, 0xa4, 0xda, 0x1c, 0xc9, 0x60, 0xcc, 0x4b, 0x38, 0xeb, 0x52, 0xb3, 0x3f, 0x96, 0xe0, 0xef,
	0x51, 0xb5, 0x2f, 0x44, 0x60, 0x4e, 0x96, 0x96, 0x56, 0x94, 0x1c, 0x5d, 0x9f, 0xab, 0x2d, 0x7d,
	0xe2, 0x95, 0xe9, 0x6d, 0x21, 0x82, 0x89, 0x79, 0x3b, 0x43, 0xd6, 0xfb, 0xd3, 0x26, 0xfc, 0x1a,
	0xa9, 0xc2, 0x9a, 0x81, 0x97, 0x24, 0xfc, 0xde, 0x02, 0x78, 0xcf, 0x9a, 0x61, 0x57, 0xc4, 0x94,
	0x25, 0xde, 0xb8, 0xc3, 0x03, 0x6b, 0x9a, 0x5d, 0x5e, 0x6a, 0xe3, 0x4f, 0x78, 0x60, 0xcd, 0x6c,
	0xdc, 0x99, 0x36, 0xe1, 0x63, 0xb4, 0x61, 0x45, 0xa1, 0x60, 0x67, 0xd3, 0xfc, 0x35, 0xc9, 0xff,
	0x6c, 0x01, 0x7f, 0x5f, 0x2a, 0xa7, 0x57, 0xa8, 0x5a, 0xb3, 0x46, 0xfc, 0x12, 0x6d, 0xf8, 0xcc,
	0x14, 0x9c, 0x9e, 0x9c, 0xb8, 0x96, 0x39, 0xae, 0xb5, 0xd5, 0x45, 0xb5, 0x56, 0xbc, 0x30, 0xae,
	0xbd, 0x53, 0xb2, 0x77, 0x33, 0xa4, 0xea, 0xb3, 0x5e, 0x22, 0xef, 0x8c, 0xca, 0x8d, 0xa0, 0xcb,
	0x77, 0x77, 0xc9, 0xac, 0x7c, 0x00, 0x73, 0x2c, 0x1f, 0x33, 0xbf, 0x43, 0xdb, 0x97, 0x4c, 0xb0,
	0x1d, 0xb8, 0x04, 0xaf, 0x2f, 0x0f, 0xde, 0x1c, 0x33, 0x5a, 0xb6, 0x03, 0x63, 0xf8, 0x2b, 0xb4,
	0x79, 0x35, 0x5a, 0x5d, 0x1e, 0xbd, 0x71, 0x15, 0xf8, 0x0e, 0xaa, 0xc0, 0x00, 0x7c, 0x61, 0x7a,
	0xcc, 0x31, 0x03, 0x2a, 0xfa, 0x5a, 0xb5, 0xae, 0xec, 0x96, 0xc8, 0xaa, 0xb4, 0x3e, 0x63, 0xce,
	0x21, 0x15, 0x7d, 0xfc, 0x18, 0xd5, 0xa9, 0xf7, 0x96, 0x0e, 0x43, 0x19, 0x36, 0x99, 0x6c, 0xf3,
	0x84, 0xba, 0x5e, 0xc4, 0x21, 0xd4, 0x36, 0xea, 0xca, 0x6e, 0x91, 0xec, 0x24, 0x71, 0xcf, 0x98,
	0x33, 0x91, 0xc4, 0xc7, 0x69, 0x4c, 0xed, 0x4b, 0x54, 0x38, 0xa4, 0x43, 0x8f, 0x51, 0x1b, 0x7f,
	0x84, 0xf2, 0x02, 0xce, 0x93, 0xd6, 0x5b, 0x32, 0x0a, 0x17, 0x46, 0x9e, 0x67, 0xeb, 0x4a, 0x3b,
	0x43, 0xa4, 0xd9, 0xa8, 0xa0, 0x42, 0x90, 0x46, 0xe6, 0xfe, 0x35, 0x94, 0xda, 0xfb, 0x2c, 0x5a,
	0x9f, 0x29, 0x25, 0x8c, 0x51, 0xbe, 0xcf, 0xc2, 0x14, 0x41, 0xe4, 0x18, 0xdf, 0x44, 0x79, 0x79,
	0x8a, 0xec, 0x14, 0x96, 0x48, 0x23, 0xfe, 0x18, 0xad, 0x86, 0xc0, 0x07, 0xae, 0x05, 0xa6, 0x4f,
	0xcf, 0x40, 0xf6, 0x94, 0x12, 0x29, 0xa7, 0xb6, 0x2e, 0x3d, 0x03, 0x6c, 0xa3, 0x2d, 0x0e, 0x3f,
	0x46, 0x10, 0x8a, 0xf8, 0x98, 0x36, 0xf0, 0xd0, 0x14, 0xcc, 0xa4, 0xb6, 0xad, 0xad, 0xd4, 0x73,
	0xbb, 0xe5, 0xe6, 0x9d, 0xab, 0x5f, 0xb5, 0x0d, 0x5c, 0xb6, 0x8e, 0x17, 0x81, 0xbc, 0xf4, 0xd2,
	0x85, 0xb1, 0xf2, 0xab, 0x92, 0x53, 0xdf, 0x17, 0xc8, 0x46, 0x8a, 0x4b, 0x82, 0xc2, 0x1e, 0xdb,
	0xb3, 0x6d, 0xfc, 0x10, 0xdd, 0xb8, 0x62, 0x15, 0x0e, 0x67, 0x6c, 0x00, 0x5a, 0xb1, 0x9e, 0xdb,
	0x2d, 0x91, 0xad, 0x59, 0x1d, 0x91, 0x5e, 0x7c, 0x13, 0x95, 0xe2, 0x7e, 0x16, 0xf7, 0x90, 0xa6,
	0x6c, 0x65, 0x45, 0x52, 0x8c, 0x42, 0x88, 0xef, 0xa6, 0x89, 0xf7, 0x51, 0x15, 0xce, 0x03, 0xb0,
	0x04, 0xd8, 0x66, 0x28, 0xa8, 0x88, 0x42, 0x08, 0xb5, 0x92, 0xdc, 0xf8, 0x56, 0xba, 0xf1, 0xf8,
	0x93, 0xae, 0x77, 0x7c, 0xf1, 0xe0, 0x0b, 0x12, 0x7f, 0xd7, 0x89, 0x3a, 0x12, 0xbc, 0x4c, 0xe3,
	0x6b, 0x3f, 0x2b, 0xa8, 0x32, 0xdd, 0x58, 0xf0, 0x57, 0x28, 0x1f, 0x82, 0x6f, 0xa7, 0xdf, 0xc9,
	0x4f, 0x17, 0x54, 0x76, 0x9a, 0x62, 0x22, 0x35, 0xf8, 0x11, 0x2a, 0x70, 0xb0, 0xc0, 0x1d, 0x80,
	0x96, 0x95, 0x3b, 0x59, 0x56, 0x3e, 0x92, 0xd5, 0xee, 0x20, 0x95, 0x80, 0xed, 0x86, 0x93, 0x3b,
	0x52, 0x51, 0xee, 0x14, 0x86, 0x69, 0xea, 0xe3, 0x61, 0x8d, 0xa0, 0xf5, 0x99, 0x96, 0x35, 0x97,
	0x6f, 0x65, 0x3e, 0xdf, 0x3b, 0xa8, 0x44, 0x23, 0xd1, 0x67, 0xdc, 0x15, 0xc3, 0xe4, 0xd1, 0x90,
	0x4b, 0x43, 0xed, 0x0f, 0x05, 0x55, 0xe7, 0xfa, 0x54, 0xfc, 0xc6, 0x2e, 0x71, 0x13, 0x6f, 0x2c,
	0x36, 0xe2, 0xcf, 0xd1, 0x8a, 0xc5, 0xfc, 0x13, 0xd7, 0x49, 0x7f, 0x07, 0xb6, 0xe7, 0x4a, 0xf3,
	0xa5, 0xfc, 0xef, 0x69, 0x67, 0x48, 0x1a, 0x88, 0x1f, 0xa2, 0xd5, 0x38, 0x2b, 0xb6, 0x99, 0x0a,
	0x93, 0xef, 0xf6, 0xf5, 0x39, 0xe1, 0x9e, 0x3f, 0x6c, 0x67, 0x48, 0x59, 0xc6, 0xee, 0xcb, 0x50,
	0x63, 0x0d, 0x95, 0x13, 0x91, 0x19, 0x5b, 0x8d, 0x4d, 0x54, 0x99, 0x2c, 0x4e, 0xe0, 0xb2, 0x78,
	0x9e, 0xe6, 0x8b, 0x48, 0x2d, 0x13, 0xcc, 0xe3, 0x4b, 0x9c, 0xaa, 0xde, 0xbb, 0x3f, 0xa0, 0xd5,
	0xe4, 0x64, 0x49, 0xf6, 0x71, 0x19, 0x15, 0x8e, 0xba, 0x5f, 0x77, 0x5f, 0xbc, 0xea, 0xaa, 0x99,
	0x78, 0xd2, 0x6e, 0xed, 0x3d, 0xeb, 0xb5, 0x5f, 0xab, 0x0a, 0x5e, 0x43, 0xa5, 0xa3, 0xee, 0x68,
	0x9a, 0xc5, 0xab, 0xa8, 0x78, 0x40, 0xf6, 0x3a, 0xdd, 0x4e, 0xf7, 0x89, 0x9a, 0x8b, 0x23, 0x7b,
	0x9d, 0xe7, 0xad, 0x17, 0x47, 0x3d, 0x35, 0x2f, 0x5d, 0xad, 0x27, 0x64, 0xef, 0xa0, 0x75, 0xa0,
	0x5e, 0x33, 0x7e, 0x52, 0xfe, 0xfc, 0x27, 0xaf, 0xfc, 0xfe, 0xf7, 0x2d, 0x05, 0xdd, 0x76, 0x59,
	0x92, 0xfa, 0x80, 0xb3, 0xf3, 0xe1, 0xfc, 0x2b, 0x30, 0xd4, 0x89, 0x5b, 0x3e, 0x8c, 0x4f, 0x7d,
	0xa8, 0x7c, 0xdb, 0x5e, 0xee, 0x9f, 0x38, 0x38, 0x75, 0x16, 0xfc, 0x17, 0x1f, 0xaf, 0xc8, 0x8b,
	0xbc, 0xff, 0x5f, 0x00, 0x00, 0x00, 0xff, 0xff, 0x33, 0x6a, 0xf3, 0x44, 0x66, 0x0b, 0x00, 0x00,
}

func (this *HealthCheck) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HealthCheck)
	if !ok {
		that2, ok := that.(HealthCheck)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Timeout != nil && that1.Timeout != nil {
		if *this.Timeout != *that1.Timeout {
			return false
		}
	} else if this.Timeout != nil {
		return false
	} else if that1.Timeout != nil {
		return false
	}
	if this.Interval != nil && that1.Interval != nil {
		if *this.Interval != *that1.Interval {
			return false
		}
	} else if this.Interval != nil {
		return false
	} else if that1.Interval != nil {
		return false
	}
	if !this.InitialJitter.Equal(that1.InitialJitter) {
		return false
	}
	if !this.IntervalJitter.Equal(that1.IntervalJitter) {
		return false
	}
	if this.IntervalJitterPercent != that1.IntervalJitterPercent {
		return false
	}
	if !this.UnhealthyThreshold.Equal(that1.UnhealthyThreshold) {
		return false
	}
	if !this.HealthyThreshold.Equal(that1.HealthyThreshold) {
		return false
	}
	if !this.ReuseConnection.Equal(that1.ReuseConnection) {
		return false
	}
	if that1.HealthChecker == nil {
		if this.HealthChecker != nil {
			return false
		}
	} else if this.HealthChecker == nil {
		return false
	} else if !this.HealthChecker.Equal(that1.HealthChecker) {
		return false
	}
	if !this.NoTrafficInterval.Equal(that1.NoTrafficInterval) {
		return false
	}
	if !this.UnhealthyInterval.Equal(that1.UnhealthyInterval) {
		return false
	}
	if !this.UnhealthyEdgeInterval.Equal(that1.UnhealthyEdgeInterval) {
		return false
	}
	if !this.HealthyEdgeInterval.Equal(that1.HealthyEdgeInterval) {
		return false
	}
	if this.EventLogPath != that1.EventLogPath {
		return false
	}
	if this.AlwaysLogHealthCheckFailures != that1.AlwaysLogHealthCheckFailures {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *HealthCheck_HttpHealthCheck_) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HealthCheck_HttpHealthCheck_)
	if !ok {
		that2, ok := that.(HealthCheck_HttpHealthCheck_)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.HttpHealthCheck.Equal(that1.HttpHealthCheck) {
		return false
	}
	return true
}
func (this *HealthCheck_TcpHealthCheck_) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HealthCheck_TcpHealthCheck_)
	if !ok {
		that2, ok := that.(HealthCheck_TcpHealthCheck_)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.TcpHealthCheck.Equal(that1.TcpHealthCheck) {
		return false
	}
	return true
}
func (this *HealthCheck_GrpcHealthCheck_) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HealthCheck_GrpcHealthCheck_)
	if !ok {
		that2, ok := that.(HealthCheck_GrpcHealthCheck_)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.GrpcHealthCheck.Equal(that1.GrpcHealthCheck) {
		return false
	}
	return true
}
func (this *HealthCheck_CustomHealthCheck_) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HealthCheck_CustomHealthCheck_)
	if !ok {
		that2, ok := that.(HealthCheck_CustomHealthCheck_)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.CustomHealthCheck.Equal(that1.CustomHealthCheck) {
		return false
	}
	return true
}
func (this *HealthCheck_Payload) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HealthCheck_Payload)
	if !ok {
		that2, ok := that.(HealthCheck_Payload)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if that1.Payload == nil {
		if this.Payload != nil {
			return false
		}
	} else if this.Payload == nil {
		return false
	} else if !this.Payload.Equal(that1.Payload) {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *HealthCheck_Payload_Text) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HealthCheck_Payload_Text)
	if !ok {
		that2, ok := that.(HealthCheck_Payload_Text)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Text != that1.Text {
		return false
	}
	return true
}
func (this *HealthCheck_HttpHealthCheck) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HealthCheck_HttpHealthCheck)
	if !ok {
		that2, ok := that.(HealthCheck_HttpHealthCheck)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Host != that1.Host {
		return false
	}
	if this.Path != that1.Path {
		return false
	}
	if this.ServiceName != that1.ServiceName {
		return false
	}
	if len(this.RequestHeadersToAdd) != len(that1.RequestHeadersToAdd) {
		return false
	}
	for i := range this.RequestHeadersToAdd {
		if !this.RequestHeadersToAdd[i].Equal(that1.RequestHeadersToAdd[i]) {
			return false
		}
	}
	if len(this.RequestHeadersToRemove) != len(that1.RequestHeadersToRemove) {
		return false
	}
	for i := range this.RequestHeadersToRemove {
		if this.RequestHeadersToRemove[i] != that1.RequestHeadersToRemove[i] {
			return false
		}
	}
	if this.UseHttp2 != that1.UseHttp2 {
		return false
	}
	if len(this.ExpectedStatuses) != len(that1.ExpectedStatuses) {
		return false
	}
	for i := range this.ExpectedStatuses {
		if !this.ExpectedStatuses[i].Equal(that1.ExpectedStatuses[i]) {
			return false
		}
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *HealthCheck_TcpHealthCheck) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HealthCheck_TcpHealthCheck)
	if !ok {
		that2, ok := that.(HealthCheck_TcpHealthCheck)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.Send.Equal(that1.Send) {
		return false
	}
	if len(this.Receive) != len(that1.Receive) {
		return false
	}
	for i := range this.Receive {
		if !this.Receive[i].Equal(that1.Receive[i]) {
			return false
		}
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *HealthCheck_RedisHealthCheck) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HealthCheck_RedisHealthCheck)
	if !ok {
		that2, ok := that.(HealthCheck_RedisHealthCheck)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Key != that1.Key {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *HealthCheck_GrpcHealthCheck) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HealthCheck_GrpcHealthCheck)
	if !ok {
		that2, ok := that.(HealthCheck_GrpcHealthCheck)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.ServiceName != that1.ServiceName {
		return false
	}
	if this.Authority != that1.Authority {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *HealthCheck_CustomHealthCheck) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HealthCheck_CustomHealthCheck)
	if !ok {
		that2, ok := that.(HealthCheck_CustomHealthCheck)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Name != that1.Name {
		return false
	}
	if that1.ConfigType == nil {
		if this.ConfigType != nil {
			return false
		}
	} else if this.ConfigType == nil {
		return false
	} else if !this.ConfigType.Equal(that1.ConfigType) {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *HealthCheck_CustomHealthCheck_Config) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HealthCheck_CustomHealthCheck_Config)
	if !ok {
		that2, ok := that.(HealthCheck_CustomHealthCheck_Config)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.Config.Equal(that1.Config) {
		return false
	}
	return true
}
func (this *HealthCheck_CustomHealthCheck_TypedConfig) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HealthCheck_CustomHealthCheck_TypedConfig)
	if !ok {
		that2, ok := that.(HealthCheck_CustomHealthCheck_TypedConfig)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.TypedConfig.Equal(that1.TypedConfig) {
		return false
	}
	return true
}
