// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: github.com/solo-io/gloo/projects/gloo/api/external/envoy/config/core/v3/base.proto

package v3

import (
	bytes "bytes"
	fmt "fmt"
	math "math"

	_ "github.com/envoyproxy/protoc-gen-validate/validate"
	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/gogo/protobuf/proto"
	types "github.com/gogo/protobuf/types"
	v3 "github.com/solo-io/gloo/projects/gloo/pkg/api/external/envoy/type/v3"
	_ "github.com/solo-io/gloo/projects/gloo/pkg/api/external/udpa/annotations"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

// Envoy supports :ref:`upstream priority routing
// <arch_overview_http_routing_priority>` both at the route and the virtual
// cluster level. The current priority implementation uses different connection
// pool and circuit breaking settings for each priority level. This means that
// even for HTTP/2 requests, two physical connections will be used to an
// upstream host. In the future Envoy will likely support true HTTP/2 priority
// over a single upstream connection.
type RoutingPriority int32

const (
	RoutingPriority_DEFAULT RoutingPriority = 0
	RoutingPriority_HIGH    RoutingPriority = 1
)

var RoutingPriority_name = map[int32]string{
	0: "DEFAULT",
	1: "HIGH",
}

var RoutingPriority_value = map[string]int32{
	"DEFAULT": 0,
	"HIGH":    1,
}

func (x RoutingPriority) String() string {
	return proto.EnumName(RoutingPriority_name, int32(x))
}

func (RoutingPriority) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{0}
}

// HTTP request method.
type RequestMethod int32

const (
	RequestMethod_METHOD_UNSPECIFIED RequestMethod = 0
	RequestMethod_GET                RequestMethod = 1
	RequestMethod_HEAD               RequestMethod = 2
	RequestMethod_POST               RequestMethod = 3
	RequestMethod_PUT                RequestMethod = 4
	RequestMethod_DELETE             RequestMethod = 5
	RequestMethod_CONNECT            RequestMethod = 6
	RequestMethod_OPTIONS            RequestMethod = 7
	RequestMethod_TRACE              RequestMethod = 8
	RequestMethod_PATCH              RequestMethod = 9
)

var RequestMethod_name = map[int32]string{
	0: "METHOD_UNSPECIFIED",
	1: "GET",
	2: "HEAD",
	3: "POST",
	4: "PUT",
	5: "DELETE",
	6: "CONNECT",
	7: "OPTIONS",
	8: "TRACE",
	9: "PATCH",
}

var RequestMethod_value = map[string]int32{
	"METHOD_UNSPECIFIED": 0,
	"GET":                1,
	"HEAD":               2,
	"POST":               3,
	"PUT":                4,
	"DELETE":             5,
	"CONNECT":            6,
	"OPTIONS":            7,
	"TRACE":              8,
	"PATCH":              9,
}

func (x RequestMethod) String() string {
	return proto.EnumName(RequestMethod_name, int32(x))
}

func (RequestMethod) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{1}
}

// Identifies the direction of the traffic relative to the local Envoy.
type TrafficDirection int32

const (
	// Default option is unspecified.
	TrafficDirection_UNSPECIFIED TrafficDirection = 0
	// The transport is used for incoming traffic.
	TrafficDirection_INBOUND TrafficDirection = 1
	// The transport is used for outgoing traffic.
	TrafficDirection_OUTBOUND TrafficDirection = 2
)

var TrafficDirection_name = map[int32]string{
	0: "UNSPECIFIED",
	1: "INBOUND",
	2: "OUTBOUND",
}

var TrafficDirection_value = map[string]int32{
	"UNSPECIFIED": 0,
	"INBOUND":     1,
	"OUTBOUND":    2,
}

func (x TrafficDirection) String() string {
	return proto.EnumName(TrafficDirection_name, int32(x))
}

func (TrafficDirection) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{2}
}

// Identifies location of where either Envoy runs or where upstream hosts run.
type Locality struct {
	// Region this :ref:`zone <envoy_api_field_config.core.v3.Locality.zone>` belongs to.
	Region string `protobuf:"bytes,1,opt,name=region,proto3" json:"region,omitempty"`
	// Defines the local service zone where Envoy is running. Though optional, it
	// should be set if discovery service routing is used and the discovery
	// service exposes :ref:`zone data <envoy_api_field_config.endpoint.v3.LocalityLbEndpoints.locality>`,
	// either in this message or via :option:`--service-zone`. The meaning of zone
	// is context dependent, e.g. `Availability Zone (AZ)
	// <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/using-regions-availability-zones.html>`_
	// on AWS, `Zone <https://cloud.google.com/compute/docs/regions-zones/>`_ on
	// GCP, etc.
	Zone string `protobuf:"bytes,2,opt,name=zone,proto3" json:"zone,omitempty"`
	// When used for locality of upstream hosts, this field further splits zone
	// into smaller chunks of sub-zones so they can be load balanced
	// independently.
	SubZone              string   `protobuf:"bytes,3,opt,name=sub_zone,json=subZone,proto3" json:"sub_zone,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *Locality) Reset()         { *m = Locality{} }
func (m *Locality) String() string { return proto.CompactTextString(m) }
func (*Locality) ProtoMessage()    {}
func (*Locality) Descriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{0}
}
func (m *Locality) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Locality.Unmarshal(m, b)
}
func (m *Locality) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Locality.Marshal(b, m, deterministic)
}
func (m *Locality) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Locality.Merge(m, src)
}
func (m *Locality) XXX_Size() int {
	return xxx_messageInfo_Locality.Size(m)
}
func (m *Locality) XXX_DiscardUnknown() {
	xxx_messageInfo_Locality.DiscardUnknown(m)
}

var xxx_messageInfo_Locality proto.InternalMessageInfo

func (m *Locality) GetRegion() string {
	if m != nil {
		return m.Region
	}
	return ""
}

func (m *Locality) GetZone() string {
	if m != nil {
		return m.Zone
	}
	return ""
}

func (m *Locality) GetSubZone() string {
	if m != nil {
		return m.SubZone
	}
	return ""
}

// BuildVersion combines SemVer version of extension with free-form build information
// (i.e. 'alpha', 'private-build') as a set of strings.
type BuildVersion struct {
	// SemVer version of extension.
	Version *v3.SemanticVersion `protobuf:"bytes,1,opt,name=version,proto3" json:"version,omitempty"`
	// Free-form build information.
	// Envoy defines several well known keys in the source/common/common/version.h file
	Metadata             *types.Struct `protobuf:"bytes,2,opt,name=metadata,proto3" json:"metadata,omitempty"`
	XXX_NoUnkeyedLiteral struct{}      `json:"-"`
	XXX_unrecognized     []byte        `json:"-"`
	XXX_sizecache        int32         `json:"-"`
}

func (m *BuildVersion) Reset()         { *m = BuildVersion{} }
func (m *BuildVersion) String() string { return proto.CompactTextString(m) }
func (*BuildVersion) ProtoMessage()    {}
func (*BuildVersion) Descriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{1}
}
func (m *BuildVersion) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_BuildVersion.Unmarshal(m, b)
}
func (m *BuildVersion) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_BuildVersion.Marshal(b, m, deterministic)
}
func (m *BuildVersion) XXX_Merge(src proto.Message) {
	xxx_messageInfo_BuildVersion.Merge(m, src)
}
func (m *BuildVersion) XXX_Size() int {
	return xxx_messageInfo_BuildVersion.Size(m)
}
func (m *BuildVersion) XXX_DiscardUnknown() {
	xxx_messageInfo_BuildVersion.DiscardUnknown(m)
}

var xxx_messageInfo_BuildVersion proto.InternalMessageInfo

func (m *BuildVersion) GetVersion() *v3.SemanticVersion {
	if m != nil {
		return m.Version
	}
	return nil
}

func (m *BuildVersion) GetMetadata() *types.Struct {
	if m != nil {
		return m.Metadata
	}
	return nil
}

// Version and identification for an Envoy extension.
// [#next-free-field: 6]
type Extension struct {
	// This is the name of the Envoy filter as specified in the Envoy
	// configuration, e.g. envoy.filters.http.router, com.acme.widget.
	Name string `protobuf:"bytes,1,opt,name=name,proto3" json:"name,omitempty"`
	// Category of the extension.
	// Extension category names use reverse DNS notation. For instance "envoy.filters.listener"
	// for Envoy's built-in listener filters or "com.acme.filters.http" for HTTP filters from
	// acme.com vendor.
	// [#comment:TODO(yanavlasov): Link to the doc with existing envoy category names.]
	Category string `protobuf:"bytes,2,opt,name=category,proto3" json:"category,omitempty"`
	// [#not-implemented-hide:] Type descriptor of extension configuration proto.
	// [#comment:TODO(yanavlasov): Link to the doc with existing configuration protos.]
	// [#comment:TODO(yanavlasov): Add tests when PR #9391 lands.]
	TypeDescriptor string `protobuf:"bytes,3,opt,name=type_descriptor,json=typeDescriptor,proto3" json:"type_descriptor,omitempty"`
	// The version is a property of the extension and maintained independently
	// of other extensions and the Envoy API.
	// This field is not set when extension did not provide version information.
	Version *BuildVersion `protobuf:"bytes,4,opt,name=version,proto3" json:"version,omitempty"`
	// Indicates that the extension is present but was disabled via dynamic configuration.
	Disabled             bool     `protobuf:"varint,5,opt,name=disabled,proto3" json:"disabled,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *Extension) Reset()         { *m = Extension{} }
func (m *Extension) String() string { return proto.CompactTextString(m) }
func (*Extension) ProtoMessage()    {}
func (*Extension) Descriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{2}
}
func (m *Extension) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Extension.Unmarshal(m, b)
}
func (m *Extension) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Extension.Marshal(b, m, deterministic)
}
func (m *Extension) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Extension.Merge(m, src)
}
func (m *Extension) XXX_Size() int {
	return xxx_messageInfo_Extension.Size(m)
}
func (m *Extension) XXX_DiscardUnknown() {
	xxx_messageInfo_Extension.DiscardUnknown(m)
}

var xxx_messageInfo_Extension proto.InternalMessageInfo

func (m *Extension) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *Extension) GetCategory() string {
	if m != nil {
		return m.Category
	}
	return ""
}

func (m *Extension) GetTypeDescriptor() string {
	if m != nil {
		return m.TypeDescriptor
	}
	return ""
}

func (m *Extension) GetVersion() *BuildVersion {
	if m != nil {
		return m.Version
	}
	return nil
}

func (m *Extension) GetDisabled() bool {
	if m != nil {
		return m.Disabled
	}
	return false
}

// Identifies a specific Envoy instance. The node identifier is presented to the
// management server, which may use this identifier to distinguish per Envoy
// configuration for serving.
// [#next-free-field: 12]
type Node struct {
	// An opaque node identifier for the Envoy node. This also provides the local
	// service node name. It should be set if any of the following features are
	// used: :ref:`statsd <arch_overview_statistics>`, :ref:`CDS
	// <config_cluster_manager_cds>`, and :ref:`HTTP tracing
	// <arch_overview_tracing>`, either in this message or via
	// :option:`--service-node`.
	Id string `protobuf:"bytes,1,opt,name=id,proto3" json:"id,omitempty"`
	// Defines the local service cluster name where Envoy is running. Though
	// optional, it should be set if any of the following features are used:
	// :ref:`statsd <arch_overview_statistics>`, :ref:`health check cluster
	// verification
	// <envoy_api_field_config.core.v3.HealthCheck.HttpHealthCheck.service_name_matcher>`,
	// :ref:`runtime override directory <envoy_api_msg_config.bootstrap.v3.Runtime>`,
	// :ref:`user agent addition
	// <envoy_api_field_extensions.filters.network.http_connection_manager.v3.HttpConnectionManager.add_user_agent>`,
	// :ref:`HTTP global rate limiting <config_http_filters_rate_limit>`,
	// :ref:`CDS <config_cluster_manager_cds>`, and :ref:`HTTP tracing
	// <arch_overview_tracing>`, either in this message or via
	// :option:`--service-cluster`.
	Cluster string `protobuf:"bytes,2,opt,name=cluster,proto3" json:"cluster,omitempty"`
	// Opaque metadata extending the node identifier. Envoy will pass this
	// directly to the management server.
	Metadata *types.Struct `protobuf:"bytes,3,opt,name=metadata,proto3" json:"metadata,omitempty"`
	// Locality specifying where the Envoy instance is running.
	Locality *Locality `protobuf:"bytes,4,opt,name=locality,proto3" json:"locality,omitempty"`
	// Free-form string that identifies the entity requesting config.
	// E.g. "envoy" or "grpc"
	UserAgentName string `protobuf:"bytes,6,opt,name=user_agent_name,json=userAgentName,proto3" json:"user_agent_name,omitempty"`
	// Types that are valid to be assigned to UserAgentVersionType:
	//	*Node_UserAgentVersion
	//	*Node_UserAgentBuildVersion
	UserAgentVersionType isNode_UserAgentVersionType `protobuf_oneof:"user_agent_version_type"`
	// List of extensions and their versions supported by the node.
	Extensions []*Extension `protobuf:"bytes,9,rep,name=extensions,proto3" json:"extensions,omitempty"`
	// Client feature support list. These are well known features described
	// in the Envoy API repository for a given major version of an API. Client features
	// use reverse DNS naming scheme, for example `com.acme.feature`.
	// See :ref:`the list of features <client_features>` that xDS client may
	// support.
	ClientFeatures []string `protobuf:"bytes,10,rep,name=client_features,json=clientFeatures,proto3" json:"client_features,omitempty"`
	// Known listening ports on the node as a generic hint to the management server
	// for filtering :ref:`listeners <config_listeners>` to be returned. For example,
	// if there is a listener bound to port 80, the list can optionally contain the
	// SocketAddress `(0.0.0.0,80)`. The field is optional and just a hint.
	ListeningAddresses   []*Address `protobuf:"bytes,11,rep,name=listening_addresses,json=listeningAddresses,proto3" json:"listening_addresses,omitempty"`
	XXX_NoUnkeyedLiteral struct{}   `json:"-"`
	XXX_unrecognized     []byte     `json:"-"`
	XXX_sizecache        int32      `json:"-"`
}

func (m *Node) Reset()         { *m = Node{} }
func (m *Node) String() string { return proto.CompactTextString(m) }
func (*Node) ProtoMessage()    {}
func (*Node) Descriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{3}
}
func (m *Node) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Node.Unmarshal(m, b)
}
func (m *Node) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Node.Marshal(b, m, deterministic)
}
func (m *Node) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Node.Merge(m, src)
}
func (m *Node) XXX_Size() int {
	return xxx_messageInfo_Node.Size(m)
}
func (m *Node) XXX_DiscardUnknown() {
	xxx_messageInfo_Node.DiscardUnknown(m)
}

var xxx_messageInfo_Node proto.InternalMessageInfo

type isNode_UserAgentVersionType interface {
	isNode_UserAgentVersionType()
	Equal(interface{}) bool
}

type Node_UserAgentVersion struct {
	UserAgentVersion string `protobuf:"bytes,7,opt,name=user_agent_version,json=userAgentVersion,proto3,oneof" json:"user_agent_version,omitempty"`
}
type Node_UserAgentBuildVersion struct {
	UserAgentBuildVersion *BuildVersion `protobuf:"bytes,8,opt,name=user_agent_build_version,json=userAgentBuildVersion,proto3,oneof" json:"user_agent_build_version,omitempty"`
}

func (*Node_UserAgentVersion) isNode_UserAgentVersionType()      {}
func (*Node_UserAgentBuildVersion) isNode_UserAgentVersionType() {}

func (m *Node) GetUserAgentVersionType() isNode_UserAgentVersionType {
	if m != nil {
		return m.UserAgentVersionType
	}
	return nil
}

func (m *Node) GetId() string {
	if m != nil {
		return m.Id
	}
	return ""
}

func (m *Node) GetCluster() string {
	if m != nil {
		return m.Cluster
	}
	return ""
}

func (m *Node) GetMetadata() *types.Struct {
	if m != nil {
		return m.Metadata
	}
	return nil
}

func (m *Node) GetLocality() *Locality {
	if m != nil {
		return m.Locality
	}
	return nil
}

func (m *Node) GetUserAgentName() string {
	if m != nil {
		return m.UserAgentName
	}
	return ""
}

func (m *Node) GetUserAgentVersion() string {
	if x, ok := m.GetUserAgentVersionType().(*Node_UserAgentVersion); ok {
		return x.UserAgentVersion
	}
	return ""
}

func (m *Node) GetUserAgentBuildVersion() *BuildVersion {
	if x, ok := m.GetUserAgentVersionType().(*Node_UserAgentBuildVersion); ok {
		return x.UserAgentBuildVersion
	}
	return nil
}

func (m *Node) GetExtensions() []*Extension {
	if m != nil {
		return m.Extensions
	}
	return nil
}

func (m *Node) GetClientFeatures() []string {
	if m != nil {
		return m.ClientFeatures
	}
	return nil
}

func (m *Node) GetListeningAddresses() []*Address {
	if m != nil {
		return m.ListeningAddresses
	}
	return nil
}

// XXX_OneofWrappers is for the internal use of the proto package.
func (*Node) XXX_OneofWrappers() []interface{} {
	return []interface{}{
		(*Node_UserAgentVersion)(nil),
		(*Node_UserAgentBuildVersion)(nil),
	}
}

// Metadata provides additional inputs to filters based on matched listeners,
// filter chains, routes and endpoints. It is structured as a map, usually from
// filter name (in reverse DNS format) to metadata specific to the filter. Metadata
// key-values for a filter are merged as connection and request handling occurs,
// with later values for the same key overriding earlier values.
//
// An example use of metadata is providing additional values to
// http_connection_manager in the envoy.http_connection_manager.access_log
// namespace.
//
// Another example use of metadata is to per service config info in cluster metadata, which may get
// consumed by multiple filters.
//
// For load balancing, Metadata provides a means to subset cluster endpoints.
// Endpoints have a Metadata object associated and routes contain a Metadata
// object to match against. There are some well defined metadata used today for
// this purpose:
//
// * ``{"envoy.lb": {"canary": <bool> }}`` This indicates the canary status of an
//   endpoint and is also used during header processing
//   (x-envoy-upstream-canary) and for stats purposes.
// [#next-major-version: move to type/metadata/v2]
type Metadata struct {
	// Key is the reverse DNS filter name, e.g. com.acme.widget. The envoy.*
	// namespace is reserved for Envoy's built-in filters.
	FilterMetadata       map[string]*types.Struct `protobuf:"bytes,1,rep,name=filter_metadata,json=filterMetadata,proto3" json:"filter_metadata,omitempty" protobuf_key:"bytes,1,opt,name=key,proto3" protobuf_val:"bytes,2,opt,name=value,proto3"`
	XXX_NoUnkeyedLiteral struct{}                 `json:"-"`
	XXX_unrecognized     []byte                   `json:"-"`
	XXX_sizecache        int32                    `json:"-"`
}

func (m *Metadata) Reset()         { *m = Metadata{} }
func (m *Metadata) String() string { return proto.CompactTextString(m) }
func (*Metadata) ProtoMessage()    {}
func (*Metadata) Descriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{4}
}
func (m *Metadata) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Metadata.Unmarshal(m, b)
}
func (m *Metadata) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Metadata.Marshal(b, m, deterministic)
}
func (m *Metadata) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Metadata.Merge(m, src)
}
func (m *Metadata) XXX_Size() int {
	return xxx_messageInfo_Metadata.Size(m)
}
func (m *Metadata) XXX_DiscardUnknown() {
	xxx_messageInfo_Metadata.DiscardUnknown(m)
}

var xxx_messageInfo_Metadata proto.InternalMessageInfo

func (m *Metadata) GetFilterMetadata() map[string]*types.Struct {
	if m != nil {
		return m.FilterMetadata
	}
	return nil
}

// Runtime derived uint32 with a default when not specified.
type RuntimeUInt32 struct {
	// Default value if runtime value is not available.
	DefaultValue uint32 `protobuf:"varint,2,opt,name=default_value,json=defaultValue,proto3" json:"default_value,omitempty"`
	// Runtime key to get value for comparison. This value is used if defined.
	RuntimeKey           string   `protobuf:"bytes,3,opt,name=runtime_key,json=runtimeKey,proto3" json:"runtime_key,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *RuntimeUInt32) Reset()         { *m = RuntimeUInt32{} }
func (m *RuntimeUInt32) String() string { return proto.CompactTextString(m) }
func (*RuntimeUInt32) ProtoMessage()    {}
func (*RuntimeUInt32) Descriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{5}
}
func (m *RuntimeUInt32) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_RuntimeUInt32.Unmarshal(m, b)
}
func (m *RuntimeUInt32) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_RuntimeUInt32.Marshal(b, m, deterministic)
}
func (m *RuntimeUInt32) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RuntimeUInt32.Merge(m, src)
}
func (m *RuntimeUInt32) XXX_Size() int {
	return xxx_messageInfo_RuntimeUInt32.Size(m)
}
func (m *RuntimeUInt32) XXX_DiscardUnknown() {
	xxx_messageInfo_RuntimeUInt32.DiscardUnknown(m)
}

var xxx_messageInfo_RuntimeUInt32 proto.InternalMessageInfo

func (m *RuntimeUInt32) GetDefaultValue() uint32 {
	if m != nil {
		return m.DefaultValue
	}
	return 0
}

func (m *RuntimeUInt32) GetRuntimeKey() string {
	if m != nil {
		return m.RuntimeKey
	}
	return ""
}

// Runtime derived double with a default when not specified.
type RuntimeDouble struct {
	// Default value if runtime value is not available.
	DefaultValue float64 `protobuf:"fixed64,1,opt,name=default_value,json=defaultValue,proto3" json:"default_value,omitempty"`
	// Runtime key to get value for comparison. This value is used if defined.
	RuntimeKey           string   `protobuf:"bytes,2,opt,name=runtime_key,json=runtimeKey,proto3" json:"runtime_key,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *RuntimeDouble) Reset()         { *m = RuntimeDouble{} }
func (m *RuntimeDouble) String() string { return proto.CompactTextString(m) }
func (*RuntimeDouble) ProtoMessage()    {}
func (*RuntimeDouble) Descriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{6}
}
func (m *RuntimeDouble) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_RuntimeDouble.Unmarshal(m, b)
}
func (m *RuntimeDouble) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_RuntimeDouble.Marshal(b, m, deterministic)
}
func (m *RuntimeDouble) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RuntimeDouble.Merge(m, src)
}
func (m *RuntimeDouble) XXX_Size() int {
	return xxx_messageInfo_RuntimeDouble.Size(m)
}
func (m *RuntimeDouble) XXX_DiscardUnknown() {
	xxx_messageInfo_RuntimeDouble.DiscardUnknown(m)
}

var xxx_messageInfo_RuntimeDouble proto.InternalMessageInfo

func (m *RuntimeDouble) GetDefaultValue() float64 {
	if m != nil {
		return m.DefaultValue
	}
	return 0
}

func (m *RuntimeDouble) GetRuntimeKey() string {
	if m != nil {
		return m.RuntimeKey
	}
	return ""
}

// Runtime derived bool with a default when not specified.
type RuntimeFeatureFlag struct {
	// Default value if runtime value is not available.
	DefaultValue *types.BoolValue `protobuf:"bytes,1,opt,name=default_value,json=defaultValue,proto3" json:"default_value,omitempty"`
	// Runtime key to get value for comparison. This value is used if defined. The boolean value must
	// be represented via its
	// `canonical JSON encoding <https://developers.google.com/protocol-buffers/docs/proto3#json>`_.
	RuntimeKey           string   `protobuf:"bytes,2,opt,name=runtime_key,json=runtimeKey,proto3" json:"runtime_key,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *RuntimeFeatureFlag) Reset()         { *m = RuntimeFeatureFlag{} }
func (m *RuntimeFeatureFlag) String() string { return proto.CompactTextString(m) }
func (*RuntimeFeatureFlag) ProtoMessage()    {}
func (*RuntimeFeatureFlag) Descriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{7}
}
func (m *RuntimeFeatureFlag) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_RuntimeFeatureFlag.Unmarshal(m, b)
}
func (m *RuntimeFeatureFlag) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_RuntimeFeatureFlag.Marshal(b, m, deterministic)
}
func (m *RuntimeFeatureFlag) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RuntimeFeatureFlag.Merge(m, src)
}
func (m *RuntimeFeatureFlag) XXX_Size() int {
	return xxx_messageInfo_RuntimeFeatureFlag.Size(m)
}
func (m *RuntimeFeatureFlag) XXX_DiscardUnknown() {
	xxx_messageInfo_RuntimeFeatureFlag.DiscardUnknown(m)
}

var xxx_messageInfo_RuntimeFeatureFlag proto.InternalMessageInfo

func (m *RuntimeFeatureFlag) GetDefaultValue() *types.BoolValue {
	if m != nil {
		return m.DefaultValue
	}
	return nil
}

func (m *RuntimeFeatureFlag) GetRuntimeKey() string {
	if m != nil {
		return m.RuntimeKey
	}
	return ""
}

// Header name/value pair.
type HeaderValue struct {
	// Header name.
	Key string `protobuf:"bytes,1,opt,name=key,proto3" json:"key,omitempty"`
	// Header value.
	//
	// The same :ref:`format specifier <config_access_log_format>` as used for
	// :ref:`HTTP access logging <config_access_log>` applies here, however
	// unknown header values are replaced with the empty string instead of `-`.
	Value                string   `protobuf:"bytes,2,opt,name=value,proto3" json:"value,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *HeaderValue) Reset()         { *m = HeaderValue{} }
func (m *HeaderValue) String() string { return proto.CompactTextString(m) }
func (*HeaderValue) ProtoMessage()    {}
func (*HeaderValue) Descriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{8}
}
func (m *HeaderValue) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_HeaderValue.Unmarshal(m, b)
}
func (m *HeaderValue) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_HeaderValue.Marshal(b, m, deterministic)
}
func (m *HeaderValue) XXX_Merge(src proto.Message) {
	xxx_messageInfo_HeaderValue.Merge(m, src)
}
func (m *HeaderValue) XXX_Size() int {
	return xxx_messageInfo_HeaderValue.Size(m)
}
func (m *HeaderValue) XXX_DiscardUnknown() {
	xxx_messageInfo_HeaderValue.DiscardUnknown(m)
}

var xxx_messageInfo_HeaderValue proto.InternalMessageInfo

func (m *HeaderValue) GetKey() string {
	if m != nil {
		return m.Key
	}
	return ""
}

func (m *HeaderValue) GetValue() string {
	if m != nil {
		return m.Value
	}
	return ""
}

// Header name/value pair plus option to control append behavior.
type HeaderValueOption struct {
	// Header name/value pair that this option applies to.
	Header *HeaderValue `protobuf:"bytes,1,opt,name=header,proto3" json:"header,omitempty"`
	// Should the value be appended? If true (default), the value is appended to
	// existing values.
	Append               *types.BoolValue `protobuf:"bytes,2,opt,name=append,proto3" json:"append,omitempty"`
	XXX_NoUnkeyedLiteral struct{}         `json:"-"`
	XXX_unrecognized     []byte           `json:"-"`
	XXX_sizecache        int32            `json:"-"`
}

func (m *HeaderValueOption) Reset()         { *m = HeaderValueOption{} }
func (m *HeaderValueOption) String() string { return proto.CompactTextString(m) }
func (*HeaderValueOption) ProtoMessage()    {}
func (*HeaderValueOption) Descriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{9}
}
func (m *HeaderValueOption) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_HeaderValueOption.Unmarshal(m, b)
}
func (m *HeaderValueOption) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_HeaderValueOption.Marshal(b, m, deterministic)
}
func (m *HeaderValueOption) XXX_Merge(src proto.Message) {
	xxx_messageInfo_HeaderValueOption.Merge(m, src)
}
func (m *HeaderValueOption) XXX_Size() int {
	return xxx_messageInfo_HeaderValueOption.Size(m)
}
func (m *HeaderValueOption) XXX_DiscardUnknown() {
	xxx_messageInfo_HeaderValueOption.DiscardUnknown(m)
}

var xxx_messageInfo_HeaderValueOption proto.InternalMessageInfo

func (m *HeaderValueOption) GetHeader() *HeaderValue {
	if m != nil {
		return m.Header
	}
	return nil
}

func (m *HeaderValueOption) GetAppend() *types.BoolValue {
	if m != nil {
		return m.Append
	}
	return nil
}

// Wrapper for a set of headers.
type HeaderMap struct {
	Headers              []*HeaderValue `protobuf:"bytes,1,rep,name=headers,proto3" json:"headers,omitempty"`
	XXX_NoUnkeyedLiteral struct{}       `json:"-"`
	XXX_unrecognized     []byte         `json:"-"`
	XXX_sizecache        int32          `json:"-"`
}

func (m *HeaderMap) Reset()         { *m = HeaderMap{} }
func (m *HeaderMap) String() string { return proto.CompactTextString(m) }
func (*HeaderMap) ProtoMessage()    {}
func (*HeaderMap) Descriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{10}
}
func (m *HeaderMap) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_HeaderMap.Unmarshal(m, b)
}
func (m *HeaderMap) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_HeaderMap.Marshal(b, m, deterministic)
}
func (m *HeaderMap) XXX_Merge(src proto.Message) {
	xxx_messageInfo_HeaderMap.Merge(m, src)
}
func (m *HeaderMap) XXX_Size() int {
	return xxx_messageInfo_HeaderMap.Size(m)
}
func (m *HeaderMap) XXX_DiscardUnknown() {
	xxx_messageInfo_HeaderMap.DiscardUnknown(m)
}

var xxx_messageInfo_HeaderMap proto.InternalMessageInfo

func (m *HeaderMap) GetHeaders() []*HeaderValue {
	if m != nil {
		return m.Headers
	}
	return nil
}

// Data source consisting of either a file or an inline value.
type DataSource struct {
	// Types that are valid to be assigned to Specifier:
	//	*DataSource_Filename
	//	*DataSource_InlineBytes
	//	*DataSource_InlineString
	Specifier            isDataSource_Specifier `protobuf_oneof:"specifier"`
	XXX_NoUnkeyedLiteral struct{}               `json:"-"`
	XXX_unrecognized     []byte                 `json:"-"`
	XXX_sizecache        int32                  `json:"-"`
}

func (m *DataSource) Reset()         { *m = DataSource{} }
func (m *DataSource) String() string { return proto.CompactTextString(m) }
func (*DataSource) ProtoMessage()    {}
func (*DataSource) Descriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{11}
}
func (m *DataSource) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_DataSource.Unmarshal(m, b)
}
func (m *DataSource) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_DataSource.Marshal(b, m, deterministic)
}
func (m *DataSource) XXX_Merge(src proto.Message) {
	xxx_messageInfo_DataSource.Merge(m, src)
}
func (m *DataSource) XXX_Size() int {
	return xxx_messageInfo_DataSource.Size(m)
}
func (m *DataSource) XXX_DiscardUnknown() {
	xxx_messageInfo_DataSource.DiscardUnknown(m)
}

var xxx_messageInfo_DataSource proto.InternalMessageInfo

type isDataSource_Specifier interface {
	isDataSource_Specifier()
	Equal(interface{}) bool
}

type DataSource_Filename struct {
	Filename string `protobuf:"bytes,1,opt,name=filename,proto3,oneof" json:"filename,omitempty"`
}
type DataSource_InlineBytes struct {
	InlineBytes []byte `protobuf:"bytes,2,opt,name=inline_bytes,json=inlineBytes,proto3,oneof" json:"inline_bytes,omitempty"`
}
type DataSource_InlineString struct {
	InlineString string `protobuf:"bytes,3,opt,name=inline_string,json=inlineString,proto3,oneof" json:"inline_string,omitempty"`
}

func (*DataSource_Filename) isDataSource_Specifier()     {}
func (*DataSource_InlineBytes) isDataSource_Specifier()  {}
func (*DataSource_InlineString) isDataSource_Specifier() {}

func (m *DataSource) GetSpecifier() isDataSource_Specifier {
	if m != nil {
		return m.Specifier
	}
	return nil
}

func (m *DataSource) GetFilename() string {
	if x, ok := m.GetSpecifier().(*DataSource_Filename); ok {
		return x.Filename
	}
	return ""
}

func (m *DataSource) GetInlineBytes() []byte {
	if x, ok := m.GetSpecifier().(*DataSource_InlineBytes); ok {
		return x.InlineBytes
	}
	return nil
}

func (m *DataSource) GetInlineString() string {
	if x, ok := m.GetSpecifier().(*DataSource_InlineString); ok {
		return x.InlineString
	}
	return ""
}

// XXX_OneofWrappers is for the internal use of the proto package.
func (*DataSource) XXX_OneofWrappers() []interface{} {
	return []interface{}{
		(*DataSource_Filename)(nil),
		(*DataSource_InlineBytes)(nil),
		(*DataSource_InlineString)(nil),
	}
}

// The message specifies the retry policy of remote data source when fetching fails.
type RetryPolicy struct {
	// Specifies parameters that control :ref:`retry backoff strategy <envoy_api_msg_config.core.v3.BackoffStrategy>`.
	// This parameter is optional, in which case the default base interval is 1000 milliseconds. The
	// default maximum interval is 10 times the base interval.
	RetryBackOff *BackoffStrategy `protobuf:"bytes,1,opt,name=retry_back_off,json=retryBackOff,proto3" json:"retry_back_off,omitempty"`
	// Specifies the allowed number of retries. This parameter is optional and
	// defaults to 1.
	NumRetries           *types.UInt32Value `protobuf:"bytes,2,opt,name=num_retries,json=numRetries,proto3" json:"num_retries,omitempty"`
	XXX_NoUnkeyedLiteral struct{}           `json:"-"`
	XXX_unrecognized     []byte             `json:"-"`
	XXX_sizecache        int32              `json:"-"`
}

func (m *RetryPolicy) Reset()         { *m = RetryPolicy{} }
func (m *RetryPolicy) String() string { return proto.CompactTextString(m) }
func (*RetryPolicy) ProtoMessage()    {}
func (*RetryPolicy) Descriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{12}
}
func (m *RetryPolicy) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_RetryPolicy.Unmarshal(m, b)
}
func (m *RetryPolicy) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_RetryPolicy.Marshal(b, m, deterministic)
}
func (m *RetryPolicy) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RetryPolicy.Merge(m, src)
}
func (m *RetryPolicy) XXX_Size() int {
	return xxx_messageInfo_RetryPolicy.Size(m)
}
func (m *RetryPolicy) XXX_DiscardUnknown() {
	xxx_messageInfo_RetryPolicy.DiscardUnknown(m)
}

var xxx_messageInfo_RetryPolicy proto.InternalMessageInfo

func (m *RetryPolicy) GetRetryBackOff() *BackoffStrategy {
	if m != nil {
		return m.RetryBackOff
	}
	return nil
}

func (m *RetryPolicy) GetNumRetries() *types.UInt32Value {
	if m != nil {
		return m.NumRetries
	}
	return nil
}

// The message specifies how to fetch data from remote and how to verify it.
type RemoteDataSource struct {
	// The HTTP URI to fetch the remote data.
	HttpUri *HttpUri `protobuf:"bytes,1,opt,name=http_uri,json=httpUri,proto3" json:"http_uri,omitempty"`
	// SHA256 string for verifying data.
	Sha256 string `protobuf:"bytes,2,opt,name=sha256,proto3" json:"sha256,omitempty"`
	// Retry policy for fetching remote data.
	RetryPolicy          *RetryPolicy `protobuf:"bytes,3,opt,name=retry_policy,json=retryPolicy,proto3" json:"retry_policy,omitempty"`
	XXX_NoUnkeyedLiteral struct{}     `json:"-"`
	XXX_unrecognized     []byte       `json:"-"`
	XXX_sizecache        int32        `json:"-"`
}

func (m *RemoteDataSource) Reset()         { *m = RemoteDataSource{} }
func (m *RemoteDataSource) String() string { return proto.CompactTextString(m) }
func (*RemoteDataSource) ProtoMessage()    {}
func (*RemoteDataSource) Descriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{13}
}
func (m *RemoteDataSource) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_RemoteDataSource.Unmarshal(m, b)
}
func (m *RemoteDataSource) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_RemoteDataSource.Marshal(b, m, deterministic)
}
func (m *RemoteDataSource) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RemoteDataSource.Merge(m, src)
}
func (m *RemoteDataSource) XXX_Size() int {
	return xxx_messageInfo_RemoteDataSource.Size(m)
}
func (m *RemoteDataSource) XXX_DiscardUnknown() {
	xxx_messageInfo_RemoteDataSource.DiscardUnknown(m)
}

var xxx_messageInfo_RemoteDataSource proto.InternalMessageInfo

func (m *RemoteDataSource) GetHttpUri() *HttpUri {
	if m != nil {
		return m.HttpUri
	}
	return nil
}

func (m *RemoteDataSource) GetSha256() string {
	if m != nil {
		return m.Sha256
	}
	return ""
}

func (m *RemoteDataSource) GetRetryPolicy() *RetryPolicy {
	if m != nil {
		return m.RetryPolicy
	}
	return nil
}

// Async data source which support async data fetch.
type AsyncDataSource struct {
	// Types that are valid to be assigned to Specifier:
	//	*AsyncDataSource_Local
	//	*AsyncDataSource_Remote
	Specifier            isAsyncDataSource_Specifier `protobuf_oneof:"specifier"`
	XXX_NoUnkeyedLiteral struct{}                    `json:"-"`
	XXX_unrecognized     []byte                      `json:"-"`
	XXX_sizecache        int32                       `json:"-"`
}

func (m *AsyncDataSource) Reset()         { *m = AsyncDataSource{} }
func (m *AsyncDataSource) String() string { return proto.CompactTextString(m) }
func (*AsyncDataSource) ProtoMessage()    {}
func (*AsyncDataSource) Descriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{14}
}
func (m *AsyncDataSource) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_AsyncDataSource.Unmarshal(m, b)
}
func (m *AsyncDataSource) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_AsyncDataSource.Marshal(b, m, deterministic)
}
func (m *AsyncDataSource) XXX_Merge(src proto.Message) {
	xxx_messageInfo_AsyncDataSource.Merge(m, src)
}
func (m *AsyncDataSource) XXX_Size() int {
	return xxx_messageInfo_AsyncDataSource.Size(m)
}
func (m *AsyncDataSource) XXX_DiscardUnknown() {
	xxx_messageInfo_AsyncDataSource.DiscardUnknown(m)
}

var xxx_messageInfo_AsyncDataSource proto.InternalMessageInfo

type isAsyncDataSource_Specifier interface {
	isAsyncDataSource_Specifier()
	Equal(interface{}) bool
}

type AsyncDataSource_Local struct {
	Local *DataSource `protobuf:"bytes,1,opt,name=local,proto3,oneof" json:"local,omitempty"`
}
type AsyncDataSource_Remote struct {
	Remote *RemoteDataSource `protobuf:"bytes,2,opt,name=remote,proto3,oneof" json:"remote,omitempty"`
}

func (*AsyncDataSource_Local) isAsyncDataSource_Specifier()  {}
func (*AsyncDataSource_Remote) isAsyncDataSource_Specifier() {}

func (m *AsyncDataSource) GetSpecifier() isAsyncDataSource_Specifier {
	if m != nil {
		return m.Specifier
	}
	return nil
}

func (m *AsyncDataSource) GetLocal() *DataSource {
	if x, ok := m.GetSpecifier().(*AsyncDataSource_Local); ok {
		return x.Local
	}
	return nil
}

func (m *AsyncDataSource) GetRemote() *RemoteDataSource {
	if x, ok := m.GetSpecifier().(*AsyncDataSource_Remote); ok {
		return x.Remote
	}
	return nil
}

// XXX_OneofWrappers is for the internal use of the proto package.
func (*AsyncDataSource) XXX_OneofWrappers() []interface{} {
	return []interface{}{
		(*AsyncDataSource_Local)(nil),
		(*AsyncDataSource_Remote)(nil),
	}
}

// Configuration for transport socket in :ref:`listeners <config_listeners>` and
// :ref:`clusters <envoy_api_msg_config.cluster.v3.Cluster>`. If the configuration is
// empty, a default transport socket implementation and configuration will be
// chosen based on the platform and existence of tls_context.
type TransportSocket struct {
	// The name of the transport socket to instantiate. The name must match a supported transport
	// socket implementation.
	Name string `protobuf:"bytes,1,opt,name=name,proto3" json:"name,omitempty"`
	// Implementation specific configuration which depends on the implementation being instantiated.
	// See the supported transport socket implementations for further documentation.
	//
	// Types that are valid to be assigned to ConfigType:
	//	*TransportSocket_TypedConfig
	ConfigType           isTransportSocket_ConfigType `protobuf_oneof:"config_type"`
	XXX_NoUnkeyedLiteral struct{}                     `json:"-"`
	XXX_unrecognized     []byte                       `json:"-"`
	XXX_sizecache        int32                        `json:"-"`
}

func (m *TransportSocket) Reset()         { *m = TransportSocket{} }
func (m *TransportSocket) String() string { return proto.CompactTextString(m) }
func (*TransportSocket) ProtoMessage()    {}
func (*TransportSocket) Descriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{15}
}
func (m *TransportSocket) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_TransportSocket.Unmarshal(m, b)
}
func (m *TransportSocket) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_TransportSocket.Marshal(b, m, deterministic)
}
func (m *TransportSocket) XXX_Merge(src proto.Message) {
	xxx_messageInfo_TransportSocket.Merge(m, src)
}
func (m *TransportSocket) XXX_Size() int {
	return xxx_messageInfo_TransportSocket.Size(m)
}
func (m *TransportSocket) XXX_DiscardUnknown() {
	xxx_messageInfo_TransportSocket.DiscardUnknown(m)
}

var xxx_messageInfo_TransportSocket proto.InternalMessageInfo

type isTransportSocket_ConfigType interface {
	isTransportSocket_ConfigType()
	Equal(interface{}) bool
}

type TransportSocket_TypedConfig struct {
	TypedConfig *types.Any `protobuf:"bytes,3,opt,name=typed_config,json=typedConfig,proto3,oneof" json:"typed_config,omitempty"`
}

func (*TransportSocket_TypedConfig) isTransportSocket_ConfigType() {}

func (m *TransportSocket) GetConfigType() isTransportSocket_ConfigType {
	if m != nil {
		return m.ConfigType
	}
	return nil
}

func (m *TransportSocket) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *TransportSocket) GetTypedConfig() *types.Any {
	if x, ok := m.GetConfigType().(*TransportSocket_TypedConfig); ok {
		return x.TypedConfig
	}
	return nil
}

// XXX_OneofWrappers is for the internal use of the proto package.
func (*TransportSocket) XXX_OneofWrappers() []interface{} {
	return []interface{}{
		(*TransportSocket_TypedConfig)(nil),
	}
}

// Runtime derived FractionalPercent with defaults for when the numerator or denominator is not
// specified via a runtime key.
//
// .. note::
//
//   Parsing of the runtime key's data is implemented such that it may be represented as a
//   :ref:`FractionalPercent <envoy_api_msg_type.v3.FractionalPercent>` proto represented as JSON/YAML
//   and may also be represented as an integer with the assumption that the value is an integral
//   percentage out of 100. For instance, a runtime key lookup returning the value "42" would parse
//   as a `FractionalPercent` whose numerator is 42 and denominator is HUNDRED.
type RuntimeFractionalPercent struct {
	// Default value if the runtime value's for the numerator/denominator keys are not available.
	DefaultValue *v3.FractionalPercent `protobuf:"bytes,1,opt,name=default_value,json=defaultValue,proto3" json:"default_value,omitempty"`
	// Runtime key for a YAML representation of a FractionalPercent.
	RuntimeKey           string   `protobuf:"bytes,2,opt,name=runtime_key,json=runtimeKey,proto3" json:"runtime_key,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *RuntimeFractionalPercent) Reset()         { *m = RuntimeFractionalPercent{} }
func (m *RuntimeFractionalPercent) String() string { return proto.CompactTextString(m) }
func (*RuntimeFractionalPercent) ProtoMessage()    {}
func (*RuntimeFractionalPercent) Descriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{16}
}
func (m *RuntimeFractionalPercent) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_RuntimeFractionalPercent.Unmarshal(m, b)
}
func (m *RuntimeFractionalPercent) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_RuntimeFractionalPercent.Marshal(b, m, deterministic)
}
func (m *RuntimeFractionalPercent) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RuntimeFractionalPercent.Merge(m, src)
}
func (m *RuntimeFractionalPercent) XXX_Size() int {
	return xxx_messageInfo_RuntimeFractionalPercent.Size(m)
}
func (m *RuntimeFractionalPercent) XXX_DiscardUnknown() {
	xxx_messageInfo_RuntimeFractionalPercent.DiscardUnknown(m)
}

var xxx_messageInfo_RuntimeFractionalPercent proto.InternalMessageInfo

func (m *RuntimeFractionalPercent) GetDefaultValue() *v3.FractionalPercent {
	if m != nil {
		return m.DefaultValue
	}
	return nil
}

func (m *RuntimeFractionalPercent) GetRuntimeKey() string {
	if m != nil {
		return m.RuntimeKey
	}
	return ""
}

// Identifies a specific ControlPlane instance that Envoy is connected to.
type ControlPlane struct {
	// An opaque control plane identifier that uniquely identifies an instance
	// of control plane. This can be used to identify which control plane instance,
	// the Envoy is connected to.
	Identifier           string   `protobuf:"bytes,1,opt,name=identifier,proto3" json:"identifier,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *ControlPlane) Reset()         { *m = ControlPlane{} }
func (m *ControlPlane) String() string { return proto.CompactTextString(m) }
func (*ControlPlane) ProtoMessage()    {}
func (*ControlPlane) Descriptor() ([]byte, []int) {
	return fileDescriptor_de9a9432f7042a04, []int{17}
}
func (m *ControlPlane) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_ControlPlane.Unmarshal(m, b)
}
func (m *ControlPlane) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_ControlPlane.Marshal(b, m, deterministic)
}
func (m *ControlPlane) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ControlPlane.Merge(m, src)
}
func (m *ControlPlane) XXX_Size() int {
	return xxx_messageInfo_ControlPlane.Size(m)
}
func (m *ControlPlane) XXX_DiscardUnknown() {
	xxx_messageInfo_ControlPlane.DiscardUnknown(m)
}

var xxx_messageInfo_ControlPlane proto.InternalMessageInfo

func (m *ControlPlane) GetIdentifier() string {
	if m != nil {
		return m.Identifier
	}
	return ""
}

func init() {
	proto.RegisterEnum("envoy.config.core.v3.RoutingPriority", RoutingPriority_name, RoutingPriority_value)
	proto.RegisterEnum("envoy.config.core.v3.RequestMethod", RequestMethod_name, RequestMethod_value)
	proto.RegisterEnum("envoy.config.core.v3.TrafficDirection", TrafficDirection_name, TrafficDirection_value)
	proto.RegisterType((*Locality)(nil), "envoy.config.core.v3.Locality")
	proto.RegisterType((*BuildVersion)(nil), "envoy.config.core.v3.BuildVersion")
	proto.RegisterType((*Extension)(nil), "envoy.config.core.v3.Extension")
	proto.RegisterType((*Node)(nil), "envoy.config.core.v3.Node")
	proto.RegisterType((*Metadata)(nil), "envoy.config.core.v3.Metadata")
	proto.RegisterMapType((map[string]*types.Struct)(nil), "envoy.config.core.v3.Metadata.FilterMetadataEntry")
	proto.RegisterType((*RuntimeUInt32)(nil), "envoy.config.core.v3.RuntimeUInt32")
	proto.RegisterType((*RuntimeDouble)(nil), "envoy.config.core.v3.RuntimeDouble")
	proto.RegisterType((*RuntimeFeatureFlag)(nil), "envoy.config.core.v3.RuntimeFeatureFlag")
	proto.RegisterType((*HeaderValue)(nil), "envoy.config.core.v3.HeaderValue")
	proto.RegisterType((*HeaderValueOption)(nil), "envoy.config.core.v3.HeaderValueOption")
	proto.RegisterType((*HeaderMap)(nil), "envoy.config.core.v3.HeaderMap")
	proto.RegisterType((*DataSource)(nil), "envoy.config.core.v3.DataSource")
	proto.RegisterType((*RetryPolicy)(nil), "envoy.config.core.v3.RetryPolicy")
	proto.RegisterType((*RemoteDataSource)(nil), "envoy.config.core.v3.RemoteDataSource")
	proto.RegisterType((*AsyncDataSource)(nil), "envoy.config.core.v3.AsyncDataSource")
	proto.RegisterType((*TransportSocket)(nil), "envoy.config.core.v3.TransportSocket")
	proto.RegisterType((*RuntimeFractionalPercent)(nil), "envoy.config.core.v3.RuntimeFractionalPercent")
	proto.RegisterType((*ControlPlane)(nil), "envoy.config.core.v3.ControlPlane")
}

func init() {
	proto.RegisterFile("github.com/solo-io/gloo/projects/gloo/api/external/envoy/config/core/v3/base.proto", fileDescriptor_de9a9432f7042a04)
}

var fileDescriptor_de9a9432f7042a04 = []byte{
	// 1840 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xa4, 0x58, 0xcd, 0x73, 0x1b, 0x49,
	0x15, 0xf7, 0xc8, 0xb6, 0x24, 0x3f, 0xc9, 0xf1, 0x6c, 0x27, 0x24, 0x8a, 0x13, 0x7f, 0x8d, 0xe3,
	0x60, 0xcc, 0xae, 0x54, 0xc8, 0x05, 0x15, 0x04, 0x05, 0x78, 0x2c, 0x79, 0x65, 0x92, 0x58, 0xaa,
	0xb1, 0xbc, 0x87, 0x50, 0x94, 0xaa, 0x35, 0xd3, 0x92, 0x9b, 0x8c, 0xa6, 0x87, 0x9e, 0x1e, 0x13,
	0xed, 0x85, 0x9c, 0x28, 0xd8, 0x0b, 0x57, 0x8a, 0x33, 0x07, 0x8e, 0x9c, 0x28, 0x8a, 0x0b, 0x5c,
	0xa8, 0x0a, 0x47, 0xaa, 0xf8, 0x07, 0xd8, 0x03, 0xc5, 0x99, 0x13, 0x95, 0x03, 0x45, 0xf5, 0x4c,
	0x8f, 0x3c, 0xb2, 0x64, 0x27, 0xc5, 0xde, 0xba, 0xdf, 0xc7, 0xbc, 0xdf, 0x7b, 0xef, 0xd7, 0xdd,
	0x4f, 0x02, 0x6b, 0x40, 0xc5, 0x79, 0xd8, 0x2b, 0xdb, 0x6c, 0x58, 0x09, 0x98, 0xcb, 0x3e, 0xa2,
	0xac, 0x32, 0x70, 0x19, 0xab, 0xf8, 0x9c, 0xfd, 0x88, 0xd8, 0x22, 0x88, 0x77, 0xd8, 0xa7, 0x15,
	0xf2, 0x4a, 0x10, 0xee, 0x61, 0xb7, 0x42, 0xbc, 0x0b, 0x36, 0xaa, 0xd8, 0xcc, 0xeb, 0xd3, 0x41,
	0xc5, 0x66, 0x9c, 0x54, 0x2e, 0xf6, 0x2b, 0x3d, 0x1c, 0x90, 0xb2, 0xcf, 0x99, 0x60, 0xe8, 0x4e,
	0x64, 0x50, 0x8e, 0x0d, 0xca, 0xd2, 0xa0, 0x7c, 0xb1, 0xbf, 0x6a, 0xcc, 0x74, 0xc3, 0x8e, 0xc3,
	0x49, 0x10, 0xc4, 0x9e, 0xd7, 0xd8, 0xf4, 0xb0, 0xfd, 0x92, 0xf5, 0xfb, 0xca, 0x66, 0x7b, 0xa6,
	0xcd, 0xb9, 0x10, 0x7e, 0x37, 0xe4, 0x54, 0x19, 0x3d, 0x88, 0x8d, 0xc4, 0xc8, 0x8f, 0xb4, 0x3e,
	0xe1, 0x36, 0xf1, 0x84, 0x52, 0x3e, 0x9a, 0x54, 0x06, 0x64, 0x88, 0x3d, 0x41, 0xed, 0xee, 0x05,
	0xe1, 0x01, 0x65, 0x9e, 0xb2, 0xba, 0x3f, 0x60, 0x6c, 0xe0, 0x92, 0x4a, 0xb4, 0xeb, 0x85, 0xfd,
	0x0a, 0xf6, 0x46, 0x4a, 0xb5, 0x7e, 0x55, 0xe5, 0x84, 0x1c, 0x8b, 0x4b, 0xd7, 0x87, 0x57, 0xf5,
	0x81, 0xe0, 0xa1, 0x2d, 0xae, 0xf3, 0xfe, 0x09, 0xc7, 0xbe, 0x4f, 0x78, 0x52, 0x84, 0xf5, 0xd0,
	0xf1, 0x71, 0x05, 0x7b, 0x1e, 0x13, 0xd1, 0x47, 0x83, 0xca, 0x90, 0x0e, 0x38, 0x16, 0xaa, 0xbc,
	0xab, 0x6b, 0x53, 0xfa, 0x40, 0x60, 0x11, 0x26, 0xee, 0x5b, 0x53, 0x6a, 0x95, 0x17, 0xf5, 0x06,
	0xca, 0xe4, 0xde, 0x05, 0x76, 0xa9, 0x83, 0x05, 0xa9, 0x24, 0x0b, 0xa5, 0xb8, 0x33, 0x60, 0x03,
	0x16, 0x2d, 0x2b, 0x72, 0x15, 0x4b, 0x0d, 0x01, 0xf9, 0x67, 0xcc, 0xc6, 0x2e, 0x15, 0x23, 0x74,
	0x17, 0xb2, 0x9c, 0x0c, 0x28, 0xf3, 0x4a, 0xda, 0xa6, 0xb6, 0xbb, 0x64, 0xa9, 0x1d, 0x42, 0xb0,
	0xf0, 0x29, 0xf3, 0x48, 0x29, 0x13, 0x49, 0xa3, 0x35, 0xba, 0x0f, 0xf9, 0x20, 0xec, 0x75, 0x23,
	0xf9, 0x7c, 0x24, 0xcf, 0x05, 0x61, 0xef, 0x05, 0xf3, 0x48, 0x6d, 0xeb, 0xd7, 0x7f, 0xf9, 0xf9,
	0xfa, 0x43, 0x58, 0x8d, 0x99, 0x82, 0x7d, 0x5a, 0xbe, 0xa8, 0xc6, 0x4c, 0x49, 0x22, 0x19, 0xbf,
	0xd1, 0xa0, 0x68, 0x86, 0xd4, 0x75, 0x3e, 0x89, 0xe1, 0xa3, 0x27, 0x90, 0x53, 0x99, 0x44, 0xb1,
	0x0b, 0xd5, 0xf5, 0x72, 0xec, 0x2e, 0x1b, 0x59, 0xbe, 0xd8, 0x2f, 0x9f, 0xaa, 0x46, 0x2a, 0x07,
	0x2b, 0x31, 0x47, 0xfb, 0x90, 0x1f, 0x12, 0x81, 0x1d, 0x2c, 0x70, 0x04, 0xb0, 0x50, 0xbd, 0x57,
	0x8e, 0x9b, 0x50, 0x4e, 0x9a, 0x50, 0x3e, 0x8d, 0x5a, 0x64, 0x8d, 0x0d, 0x6b, 0x3b, 0x12, 0xe2,
	0x26, 0xac, 0x4f, 0x43, 0x4c, 0xa3, 0x32, 0x3e, 0xd7, 0x60, 0xa9, 0xf1, 0x4a, 0x10, 0x2f, 0x50,
	0x65, 0xf0, 0xf0, 0x90, 0xa8, 0xe2, 0x44, 0x6b, 0xb4, 0x0a, 0x79, 0x1b, 0x0b, 0x32, 0x60, 0x7c,
	0xa4, 0xca, 0x33, 0xde, 0xa3, 0x2f, 0xc3, 0x8a, 0x44, 0xdf, 0x75, 0x48, 0x60, 0x73, 0xea, 0x0b,
	0xc6, 0x55, 0xa5, 0x6e, 0x49, 0x71, 0x7d, 0x2c, 0x45, 0xdf, 0xbe, 0x4c, 0x7e, 0x21, 0xca, 0xc0,
	0x28, 0xcf, 0x3a, 0x65, 0x13, 0xd8, 0x2e, 0x0b, 0xb0, 0x0a, 0x79, 0x87, 0x06, 0xb8, 0xe7, 0x12,
	0xa7, 0xb4, 0xb8, 0xa9, 0xed, 0xe6, 0xad, 0xf1, 0xbe, 0x66, 0xc8, 0x3c, 0xd7, 0xe0, 0xc1, 0x74,
	0x9e, 0xe3, 0xb4, 0x8c, 0x7f, 0x2c, 0xc0, 0xc2, 0x09, 0x73, 0x08, 0xba, 0x05, 0x19, 0xea, 0xa8,
	0xec, 0x32, 0xd4, 0x41, 0x25, 0xc8, 0xd9, 0x6e, 0x18, 0x08, 0xc2, 0x55, 0x6a, 0xc9, 0x76, 0xa2,
	0xe6, 0xf3, 0xef, 0x59, 0x73, 0x54, 0x83, 0xbc, 0xab, 0xfa, 0xaf, 0xd2, 0x5c, 0x9f, 0x9d, 0x66,
	0xc2, 0x12, 0x6b, 0x6c, 0x8f, 0x1e, 0xc3, 0x4a, 0x18, 0x10, 0xde, 0xc5, 0x03, 0xe2, 0x89, 0x6e,
	0xd4, 0x85, 0x6c, 0x04, 0x69, 0x59, 0x8a, 0x0f, 0xa4, 0xf4, 0x44, 0xb6, 0xa3, 0x0c, 0x28, 0x65,
	0x97, 0x14, 0x35, 0x27, 0x4d, 0x9b, 0x73, 0x96, 0x3e, 0x36, 0x4e, 0x68, 0xf7, 0x43, 0x28, 0xa5,
	0xec, 0x7b, 0xb2, 0xbe, 0x63, 0xaf, 0xfc, 0xfb, 0xb6, 0xa2, 0x39, 0x67, 0x7d, 0x69, 0xfc, 0xe5,
	0x09, 0x56, 0x7f, 0x17, 0x80, 0x24, 0x75, 0x0e, 0x4a, 0x4b, 0x9b, 0xf3, 0xbb, 0x85, 0xea, 0xc6,
	0xec, 0x0f, 0x8e, 0xfb, 0x61, 0xa5, 0x5c, 0x24, 0x85, 0x6c, 0x97, 0x4a, 0x6c, 0x7d, 0x82, 0x45,
	0xc8, 0x49, 0x50, 0x82, 0xcd, 0x79, 0x49, 0xa1, 0x58, 0x7c, 0xa4, 0xa4, 0xe8, 0x04, 0x6e, 0xbb,
	0x34, 0x10, 0x44, 0x5e, 0x04, 0x5d, 0x75, 0xef, 0x92, 0xa0, 0x54, 0x88, 0x42, 0xae, 0xcd, 0x0e,
	0x79, 0x10, 0x9b, 0x59, 0x68, 0xec, 0x79, 0x90, 0x38, 0xd6, 0xd6, 0x24, 0x71, 0x4a, 0x70, 0x77,
	0x9a, 0x38, 0x92, 0x2a, 0xe6, 0x7d, 0xb8, 0x37, 0x5d, 0xe7, 0xae, 0xa4, 0xf5, 0xf7, 0x17, 0xf2,
	0x8b, 0x7a, 0xd6, 0x5a, 0x9e, 0xa8, 0xa5, 0xf1, 0x4f, 0x0d, 0xf2, 0xcf, 0x13, 0x22, 0xfc, 0x00,
	0x56, 0xfa, 0xd4, 0x15, 0x84, 0x77, 0xc7, 0x24, 0xd2, 0x22, 0x9c, 0xd5, 0xd9, 0x38, 0x13, 0xc7,
	0xf2, 0x51, 0xe4, 0x95, 0x6c, 0x1b, 0x9e, 0xe0, 0x23, 0xeb, 0x56, 0x7f, 0x42, 0xb8, 0xfa, 0x02,
	0x6e, 0xcf, 0x30, 0x43, 0x3a, 0xcc, 0xbf, 0x24, 0x23, 0x45, 0x6e, 0xb9, 0x44, 0x1f, 0xc1, 0xe2,
	0x05, 0x76, 0x43, 0xf2, 0xae, 0x4b, 0x23, 0xb6, 0xaa, 0x65, 0x9e, 0x68, 0x37, 0x5c, 0x6c, 0x49,
	0x30, 0xe3, 0x67, 0x1a, 0x2c, 0x5b, 0xa1, 0x27, 0xe8, 0x90, 0x9c, 0x1d, 0x7b, 0x62, 0xbf, 0x8a,
	0xb6, 0x61, 0xd9, 0x21, 0x7d, 0x1c, 0xba, 0xa2, 0x7b, 0x19, 0x6f, 0xd9, 0x2a, 0x2a, 0xe1, 0x27,
	0x52, 0x86, 0x76, 0xa1, 0xc0, 0x63, 0xaf, 0xae, 0x84, 0x19, 0x5d, 0x13, 0x66, 0xee, 0xad, 0xb9,
	0xc0, 0x33, 0x9b, 0x9a, 0x05, 0x4a, 0xf7, 0x94, 0x8c, 0x6a, 0x8f, 0x25, 0x86, 0x2d, 0xd8, 0x98,
	0xc6, 0x30, 0x11, 0x36, 0x0d, 0xa4, 0xce, 0xc2, 0x9e, 0x4b, 0xa6, 0x81, 0xc8, 0x62, 0x68, 0x37,
	0x03, 0xc9, 0x7c, 0x01, 0x20, 0x71, 0x58, 0xe3, 0xf7, 0x1a, 0x20, 0x25, 0x51, 0x6c, 0x3d, 0x72,
	0xf1, 0x00, 0x1d, 0xcf, 0x42, 0x53, 0xa8, 0xae, 0x4e, 0xb5, 0xc1, 0x64, 0xcc, 0x8d, 0xb0, 0x99,
	0xf9, 0xb7, 0xe6, 0xe2, 0x67, 0x5a, 0x46, 0xff, 0xff, 0x31, 0x7f, 0x55, 0x62, 0x7e, 0x0c, 0x8f,
	0xae, 0xc5, 0x9c, 0x42, 0x68, 0xfc, 0x14, 0x0a, 0x4d, 0x82, 0x1d, 0xc2, 0xe3, 0x28, 0xdb, 0x29,
	0x06, 0x99, 0x1f, 0xbc, 0x35, 0x6f, 0xf1, 0xe2, 0xa6, 0xb6, 0xfb, 0xfa, 0xb5, 0xf6, 0x67, 0x4d,
	0x7b, 0xa3, 0xcd, 0xc5, 0xa4, 0xda, 0x49, 0x93, 0x6a, 0xc9, 0x5c, 0x79, 0x6b, 0x16, 0x39, 0xc4,
	0x46, 0x19, 0x69, 0xa4, 0xc8, 0xf4, 0x48, 0xe2, 0xd8, 0x80, 0xb5, 0x69, 0x1c, 0xa9, 0x88, 0xc6,
	0x1f, 0x34, 0xf8, 0x20, 0xb5, 0x6f, 0xf9, 0xf2, 0xc5, 0x47, 0x87, 0x90, 0x3d, 0x8f, 0x84, 0xaa,
	0x62, 0x5b, 0xb3, 0x0f, 0x4d, 0xca, 0x31, 0x55, 0x38, 0xe5, 0x8a, 0xaa, 0x90, 0x95, 0x63, 0x89,
	0xe7, 0x28, 0xf6, 0xdf, 0x50, 0x76, 0x4b, 0x59, 0xd6, 0xf6, 0x24, 0xe8, 0x1d, 0xd8, 0xbe, 0x11,
	0x74, 0x0c, 0xd2, 0x70, 0x61, 0x29, 0x16, 0x3e, 0xc7, 0x3e, 0xfa, 0x16, 0xe4, 0xe2, 0xb0, 0x81,
	0x3a, 0xe7, 0xef, 0x86, 0x6c, 0x25, 0x1e, 0x37, 0xbc, 0x60, 0xe3, 0x00, 0xc6, 0x1b, 0x0d, 0xa0,
	0x8e, 0x05, 0x3e, 0x65, 0x21, 0xb7, 0x09, 0xda, 0x81, 0x7c, 0x9f, 0xba, 0xe4, 0xf2, 0xad, 0x1e,
	0x93, 0xa1, 0x39, 0x67, 0x8d, 0x55, 0xe8, 0x43, 0x28, 0x52, 0xcf, 0xa5, 0x1e, 0xe9, 0xf6, 0x46,
	0x82, 0x04, 0x51, 0x25, 0x8a, 0x91, 0xe9, 0xa7, 0x19, 0x5d, 0x9a, 0x16, 0x62, 0xb5, 0x29, 0xb5,
	0xa8, 0x0c, 0xcb, 0xca, 0x3a, 0x10, 0x9c, 0x7a, 0x83, 0x2b, 0x67, 0xb4, 0x39, 0x67, 0xa9, 0xaf,
	0x9d, 0x46, 0xea, 0xda, 0xb6, 0xc4, 0xbd, 0x0e, 0x0f, 0xa7, 0x71, 0x5f, 0x22, 0x35, 0x75, 0x58,
	0x0a, 0x7c, 0x62, 0xd3, 0x3e, 0x25, 0x1c, 0xcd, 0xff, 0xc7, 0xd4, 0x8c, 0xbf, 0x6b, 0x50, 0xb0,
	0x88, 0xe0, 0xa3, 0x36, 0x73, 0xa9, 0x3d, 0x42, 0x4f, 0xe1, 0x16, 0x97, 0xdb, 0xae, 0x9c, 0x93,
	0xbb, 0xac, 0xdf, 0x57, 0x5d, 0xdf, 0xb9, 0xe6, 0x59, 0x8a, 0xa7, 0xe9, 0x53, 0x21, 0x47, 0xca,
	0xc1, 0xc8, 0x2a, 0x46, 0xce, 0x52, 0xda, 0xea, 0xf7, 0x91, 0x05, 0x05, 0x2f, 0x1c, 0x76, 0xa5,
	0x8c, 0xaa, 0x84, 0x0b, 0xd5, 0x87, 0x53, 0xad, 0x8f, 0x6f, 0x90, 0x98, 0x3a, 0xb7, 0xff, 0xfd,
	0xab, 0xff, 0xfe, 0x72, 0x71, 0x19, 0x0a, 0x43, 0xfc, 0x2a, 0x71, 0xb4, 0xc0, 0x0b, 0x87, 0x56,
	0xbc, 0xbe, 0x81, 0xca, 0xa9, 0x34, 0x8c, 0x7f, 0x69, 0xa0, 0x5b, 0x64, 0xc8, 0x04, 0x49, 0xf5,
	0xc9, 0x84, 0x7c, 0x32, 0xd9, 0xab, 0xac, 0xae, 0x79, 0xa8, 0x9a, 0x42, 0xf8, 0x67, 0x9c, 0xa6,
	0x78, 0x9c, 0x3b, 0x8f, 0x45, 0x68, 0x03, 0xb2, 0xc1, 0x39, 0xae, 0x7e, 0xfd, 0x1b, 0x57, 0x8f,
	0xbd, 0x12, 0xa3, 0x3a, 0xc4, 0x35, 0xe8, 0xfa, 0x11, 0x12, 0x35, 0xae, 0x5c, 0xc3, 0xc0, 0x14,
	0x64, 0xab, 0xc0, 0x2f, 0x37, 0xb5, 0xaf, 0xc8, 0x2c, 0x1f, 0x81, 0x31, 0x2b, 0xcb, 0xc9, 0xac,
	0x8c, 0xbf, 0x6a, 0xb0, 0x72, 0x10, 0x8c, 0x3c, 0x3b, 0x95, 0xe9, 0x13, 0x58, 0x8c, 0x46, 0x19,
	0x95, 0xe6, 0xe6, 0xec, 0xe8, 0x97, 0x0e, 0xcd, 0x39, 0x2b, 0x76, 0x40, 0xdf, 0x93, 0x23, 0xb9,
	0x8c, 0xa0, 0xba, 0xf5, 0xf8, 0x3a, 0xe0, 0x93, 0x28, 0x9a, 0x73, 0x96, 0xf2, 0xab, 0xed, 0x4a,
	0xe8, 0xdb, 0xb0, 0x35, 0x0d, 0xfd, 0x0a, 0xca, 0x19, 0x6c, 0xfc, 0x9d, 0x06, 0x2b, 0x1d, 0x8e,
	0xbd, 0xc0, 0x67, 0x5c, 0x9c, 0x32, 0xfb, 0x25, 0x11, 0xe8, 0x41, 0x7a, 0x0a, 0xbe, 0xac, 0x77,
	0x3c, 0x0e, 0x7f, 0x13, 0x8a, 0x72, 0x08, 0x70, 0xba, 0x31, 0x3e, 0x55, 0xed, 0x3b, 0x53, 0x14,
	0x3b, 0xf0, 0x46, 0xf2, 0x80, 0x45, 0xb6, 0x87, 0x91, 0xe9, 0x0d, 0x38, 0xaf, 0x20, 0x30, 0x97,
	0xa1, 0x10, 0x7f, 0x3e, 0x19, 0x38, 0x32, 0xfa, 0xbc, 0x95, 0x8d, 0x45, 0xc6, 0x9f, 0x34, 0x28,
	0x25, 0x97, 0x39, 0xc7, 0xb6, 0xbc, 0x8d, 0xb0, 0xdb, 0x8e, 0x7f, 0x22, 0xa2, 0xd6, 0xec, 0x47,
	0x67, 0xf3, 0xca, 0x6f, 0x8d, 0x29, 0xc7, 0x6b, 0x9f, 0x9e, 0x8d, 0x19, 0x4f, 0xcf, 0xc4, 0x8b,
	0xf3, 0x35, 0x99, 0xd5, 0x87, 0xb0, 0x77, 0xfd, 0x8b, 0x73, 0x35, 0x96, 0x71, 0x06, 0xc5, 0x43,
	0xe6, 0x09, 0xce, 0xdc, 0xb6, 0x8b, 0x3d, 0x82, 0xd6, 0x01, 0xa8, 0x43, 0x3c, 0x11, 0xf5, 0x45,
	0x4d, 0x30, 0x29, 0xc9, 0x0d, 0xbf, 0x65, 0xd2, 0x9f, 0xd9, 0xdb, 0x85, 0x15, 0x8b, 0x85, 0x82,
	0x7a, 0x83, 0x36, 0xa7, 0x8c, 0xcb, 0xa9, 0xba, 0x00, 0xb9, 0x7a, 0xe3, 0xe8, 0xe0, 0xec, 0x59,
	0x47, 0x9f, 0x43, 0x79, 0x58, 0x68, 0x1e, 0x7f, 0xdc, 0xd4, 0xb5, 0xbd, 0x5f, 0xc8, 0xd1, 0x81,
	0xfc, 0x38, 0x24, 0x81, 0x78, 0x4e, 0xc4, 0x39, 0x73, 0xd0, 0x5d, 0x40, 0xcf, 0x1b, 0x9d, 0x66,
	0xab, 0xde, 0x3d, 0x3b, 0x39, 0x6d, 0x37, 0x0e, 0x8f, 0x8f, 0x8e, 0x1b, 0x75, 0x7d, 0x0e, 0xe5,
	0x60, 0xfe, 0xe3, 0x46, 0x47, 0xd7, 0x22, 0xe7, 0xc6, 0x41, 0x5d, 0xcf, 0xc8, 0x55, 0xbb, 0x75,
	0xda, 0xd1, 0xe7, 0xa5, 0xb2, 0x7d, 0xd6, 0xd1, 0x17, 0x10, 0x40, 0xb6, 0xde, 0x78, 0xd6, 0xe8,
	0x34, 0xf4, 0x45, 0x19, 0xf2, 0xb0, 0x75, 0x72, 0xd2, 0x38, 0xec, 0xe8, 0x59, 0xb9, 0x69, 0xb5,
	0x3b, 0xc7, 0xad, 0x93, 0x53, 0x3d, 0x87, 0x96, 0x60, 0xb1, 0x63, 0x1d, 0x1c, 0x36, 0xf4, 0xbc,
	0x5c, 0xb6, 0x0f, 0x3a, 0x87, 0x4d, 0x7d, 0x69, 0xef, 0x3b, 0xa0, 0x77, 0x38, 0xee, 0xf7, 0xa9,
	0x5d, 0xa7, 0x9c, 0x44, 0x95, 0x42, 0x2b, 0x50, 0x98, 0x84, 0x51, 0x80, 0xdc, 0xf1, 0x89, 0xd9,
	0x3a, 0x3b, 0xa9, 0xeb, 0x1a, 0x2a, 0x42, 0xbe, 0x75, 0xd6, 0x89, 0x77, 0x19, 0xf3, 0x33, 0xed,
	0xb7, 0x9f, 0xaf, 0x6b, 0x7f, 0x7c, 0xfd, 0xe6, 0x6f, 0xd9, 0x8c, 0x9e, 0x01, 0x83, 0xb2, 0xb8,
	0xd7, 0x3e, 0x67, 0xaf, 0x46, 0x33, 0xcf, 0x92, 0xb9, 0x64, 0xe2, 0x80, 0xb4, 0x25, 0x53, 0xdb,
	0xda, 0x8b, 0xa7, 0xef, 0xf7, 0x17, 0x8a, 0xff, 0x72, 0xf0, 0xee, 0xbf, 0x51, 0x7a, 0xd9, 0x88,
	0xff, 0xfb, 0xff, 0x0b, 0x00, 0x00, 0xff, 0xff, 0x67, 0xbc, 0x34, 0x02, 0x98, 0x11, 0x00, 0x00,
}

func (this *Locality) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*Locality)
	if !ok {
		that2, ok := that.(Locality)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Region != that1.Region {
		return false
	}
	if this.Zone != that1.Zone {
		return false
	}
	if this.SubZone != that1.SubZone {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *BuildVersion) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*BuildVersion)
	if !ok {
		that2, ok := that.(BuildVersion)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.Version.Equal(that1.Version) {
		return false
	}
	if !this.Metadata.Equal(that1.Metadata) {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *Extension) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*Extension)
	if !ok {
		that2, ok := that.(Extension)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Name != that1.Name {
		return false
	}
	if this.Category != that1.Category {
		return false
	}
	if this.TypeDescriptor != that1.TypeDescriptor {
		return false
	}
	if !this.Version.Equal(that1.Version) {
		return false
	}
	if this.Disabled != that1.Disabled {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *Node) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*Node)
	if !ok {
		that2, ok := that.(Node)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Id != that1.Id {
		return false
	}
	if this.Cluster != that1.Cluster {
		return false
	}
	if !this.Metadata.Equal(that1.Metadata) {
		return false
	}
	if !this.Locality.Equal(that1.Locality) {
		return false
	}
	if this.UserAgentName != that1.UserAgentName {
		return false
	}
	if that1.UserAgentVersionType == nil {
		if this.UserAgentVersionType != nil {
			return false
		}
	} else if this.UserAgentVersionType == nil {
		return false
	} else if !this.UserAgentVersionType.Equal(that1.UserAgentVersionType) {
		return false
	}
	if len(this.Extensions) != len(that1.Extensions) {
		return false
	}
	for i := range this.Extensions {
		if !this.Extensions[i].Equal(that1.Extensions[i]) {
			return false
		}
	}
	if len(this.ClientFeatures) != len(that1.ClientFeatures) {
		return false
	}
	for i := range this.ClientFeatures {
		if this.ClientFeatures[i] != that1.ClientFeatures[i] {
			return false
		}
	}
	if len(this.ListeningAddresses) != len(that1.ListeningAddresses) {
		return false
	}
	for i := range this.ListeningAddresses {
		if !this.ListeningAddresses[i].Equal(that1.ListeningAddresses[i]) {
			return false
		}
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *Node_UserAgentVersion) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*Node_UserAgentVersion)
	if !ok {
		that2, ok := that.(Node_UserAgentVersion)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.UserAgentVersion != that1.UserAgentVersion {
		return false
	}
	return true
}
func (this *Node_UserAgentBuildVersion) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*Node_UserAgentBuildVersion)
	if !ok {
		that2, ok := that.(Node_UserAgentBuildVersion)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.UserAgentBuildVersion.Equal(that1.UserAgentBuildVersion) {
		return false
	}
	return true
}
func (this *Metadata) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*Metadata)
	if !ok {
		that2, ok := that.(Metadata)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if len(this.FilterMetadata) != len(that1.FilterMetadata) {
		return false
	}
	for i := range this.FilterMetadata {
		if !this.FilterMetadata[i].Equal(that1.FilterMetadata[i]) {
			return false
		}
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *RuntimeUInt32) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*RuntimeUInt32)
	if !ok {
		that2, ok := that.(RuntimeUInt32)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.DefaultValue != that1.DefaultValue {
		return false
	}
	if this.RuntimeKey != that1.RuntimeKey {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *RuntimeDouble) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*RuntimeDouble)
	if !ok {
		that2, ok := that.(RuntimeDouble)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.DefaultValue != that1.DefaultValue {
		return false
	}
	if this.RuntimeKey != that1.RuntimeKey {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *RuntimeFeatureFlag) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*RuntimeFeatureFlag)
	if !ok {
		that2, ok := that.(RuntimeFeatureFlag)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.DefaultValue.Equal(that1.DefaultValue) {
		return false
	}
	if this.RuntimeKey != that1.RuntimeKey {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *HeaderValue) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HeaderValue)
	if !ok {
		that2, ok := that.(HeaderValue)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Key != that1.Key {
		return false
	}
	if this.Value != that1.Value {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *HeaderValueOption) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HeaderValueOption)
	if !ok {
		that2, ok := that.(HeaderValueOption)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.Header.Equal(that1.Header) {
		return false
	}
	if !this.Append.Equal(that1.Append) {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *HeaderMap) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HeaderMap)
	if !ok {
		that2, ok := that.(HeaderMap)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if len(this.Headers) != len(that1.Headers) {
		return false
	}
	for i := range this.Headers {
		if !this.Headers[i].Equal(that1.Headers[i]) {
			return false
		}
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *DataSource) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*DataSource)
	if !ok {
		that2, ok := that.(DataSource)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if that1.Specifier == nil {
		if this.Specifier != nil {
			return false
		}
	} else if this.Specifier == nil {
		return false
	} else if !this.Specifier.Equal(that1.Specifier) {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *DataSource_Filename) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*DataSource_Filename)
	if !ok {
		that2, ok := that.(DataSource_Filename)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Filename != that1.Filename {
		return false
	}
	return true
}
func (this *DataSource_InlineBytes) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*DataSource_InlineBytes)
	if !ok {
		that2, ok := that.(DataSource_InlineBytes)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !bytes.Equal(this.InlineBytes, that1.InlineBytes) {
		return false
	}
	return true
}
func (this *DataSource_InlineString) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*DataSource_InlineString)
	if !ok {
		that2, ok := that.(DataSource_InlineString)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.InlineString != that1.InlineString {
		return false
	}
	return true
}
func (this *RetryPolicy) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*RetryPolicy)
	if !ok {
		that2, ok := that.(RetryPolicy)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.RetryBackOff.Equal(that1.RetryBackOff) {
		return false
	}
	if !this.NumRetries.Equal(that1.NumRetries) {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *RemoteDataSource) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*RemoteDataSource)
	if !ok {
		that2, ok := that.(RemoteDataSource)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.HttpUri.Equal(that1.HttpUri) {
		return false
	}
	if this.Sha256 != that1.Sha256 {
		return false
	}
	if !this.RetryPolicy.Equal(that1.RetryPolicy) {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *AsyncDataSource) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*AsyncDataSource)
	if !ok {
		that2, ok := that.(AsyncDataSource)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if that1.Specifier == nil {
		if this.Specifier != nil {
			return false
		}
	} else if this.Specifier == nil {
		return false
	} else if !this.Specifier.Equal(that1.Specifier) {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *AsyncDataSource_Local) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*AsyncDataSource_Local)
	if !ok {
		that2, ok := that.(AsyncDataSource_Local)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.Local.Equal(that1.Local) {
		return false
	}
	return true
}
func (this *AsyncDataSource_Remote) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*AsyncDataSource_Remote)
	if !ok {
		that2, ok := that.(AsyncDataSource_Remote)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.Remote.Equal(that1.Remote) {
		return false
	}
	return true
}
func (this *TransportSocket) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*TransportSocket)
	if !ok {
		that2, ok := that.(TransportSocket)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Name != that1.Name {
		return false
	}
	if that1.ConfigType == nil {
		if this.ConfigType != nil {
			return false
		}
	} else if this.ConfigType == nil {
		return false
	} else if !this.ConfigType.Equal(that1.ConfigType) {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *TransportSocket_TypedConfig) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*TransportSocket_TypedConfig)
	if !ok {
		that2, ok := that.(TransportSocket_TypedConfig)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.TypedConfig.Equal(that1.TypedConfig) {
		return false
	}
	return true
}
func (this *RuntimeFractionalPercent) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*RuntimeFractionalPercent)
	if !ok {
		that2, ok := that.(RuntimeFractionalPercent)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.DefaultValue.Equal(that1.DefaultValue) {
		return false
	}
	if this.RuntimeKey != that1.RuntimeKey {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *ControlPlane) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*ControlPlane)
	if !ok {
		that2, ok := that.(ControlPlane)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Identifier != that1.Identifier {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
