// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: github.com/solo-io/gloo/projects/gloo/api/external/envoy/config/core/v3/http_uri.proto

package v3

import (
	bytes "bytes"
	fmt "fmt"
	math "math"

	_ "github.com/envoyproxy/protoc-gen-validate/validate"
	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/gogo/protobuf/proto"
	types "github.com/gogo/protobuf/types"
	_ "github.com/solo-io/gloo/projects/gloo/pkg/api/external/udpa/annotations"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

// Envoy external URI descriptor
type HttpUri struct {
	// The HTTP server URI. It should be a full FQDN with protocol, host and path.
	//
	// Example:
	//
	// .. code-block:: yaml
	//
	//    uri: https://www.googleapis.com/oauth2/v1/certs
	//
	Uri string `protobuf:"bytes,1,opt,name=uri,proto3" json:"uri,omitempty"`
	// Specify how `uri` is to be fetched. Today, this requires an explicit
	// cluster, but in the future we may support dynamic cluster creation or
	// inline DNS resolution. See `issue
	// <https://github.com/envoyproxy/envoy/issues/1606>`_.
	//
	// Types that are valid to be assigned to HttpUpstreamType:
	//	*HttpUri_Cluster
	HttpUpstreamType isHttpUri_HttpUpstreamType `protobuf_oneof:"http_upstream_type"`
	// Sets the maximum duration in milliseconds that a response can take to arrive upon request.
	Timeout              *types.Duration `protobuf:"bytes,3,opt,name=timeout,proto3" json:"timeout,omitempty"`
	XXX_NoUnkeyedLiteral struct{}        `json:"-"`
	XXX_unrecognized     []byte          `json:"-"`
	XXX_sizecache        int32           `json:"-"`
}

func (m *HttpUri) Reset()         { *m = HttpUri{} }
func (m *HttpUri) String() string { return proto.CompactTextString(m) }
func (*HttpUri) ProtoMessage()    {}
func (*HttpUri) Descriptor() ([]byte, []int) {
	return fileDescriptor_89038522e4c47ad6, []int{0}
}
func (m *HttpUri) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_HttpUri.Unmarshal(m, b)
}
func (m *HttpUri) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_HttpUri.Marshal(b, m, deterministic)
}
func (m *HttpUri) XXX_Merge(src proto.Message) {
	xxx_messageInfo_HttpUri.Merge(m, src)
}
func (m *HttpUri) XXX_Size() int {
	return xxx_messageInfo_HttpUri.Size(m)
}
func (m *HttpUri) XXX_DiscardUnknown() {
	xxx_messageInfo_HttpUri.DiscardUnknown(m)
}

var xxx_messageInfo_HttpUri proto.InternalMessageInfo

type isHttpUri_HttpUpstreamType interface {
	isHttpUri_HttpUpstreamType()
	Equal(interface{}) bool
}

type HttpUri_Cluster struct {
	Cluster string `protobuf:"bytes,2,opt,name=cluster,proto3,oneof" json:"cluster,omitempty"`
}

func (*HttpUri_Cluster) isHttpUri_HttpUpstreamType() {}

func (m *HttpUri) GetHttpUpstreamType() isHttpUri_HttpUpstreamType {
	if m != nil {
		return m.HttpUpstreamType
	}
	return nil
}

func (m *HttpUri) GetUri() string {
	if m != nil {
		return m.Uri
	}
	return ""
}

func (m *HttpUri) GetCluster() string {
	if x, ok := m.GetHttpUpstreamType().(*HttpUri_Cluster); ok {
		return x.Cluster
	}
	return ""
}

func (m *HttpUri) GetTimeout() *types.Duration {
	if m != nil {
		return m.Timeout
	}
	return nil
}

// XXX_OneofWrappers is for the internal use of the proto package.
func (*HttpUri) XXX_OneofWrappers() []interface{} {
	return []interface{}{
		(*HttpUri_Cluster)(nil),
	}
}

func init() {
	proto.RegisterType((*HttpUri)(nil), "envoy.config.core.v3.HttpUri")
}

func init() {
	proto.RegisterFile("github.com/solo-io/gloo/projects/gloo/api/external/envoy/config/core/v3/http_uri.proto", fileDescriptor_89038522e4c47ad6)
}

var fileDescriptor_89038522e4c47ad6 = []byte{
	// 394 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x8c, 0x52, 0xb1, 0x6e, 0x14, 0x31,
	0x10, 0x8d, 0xf7, 0xa2, 0x2c, 0x18, 0x0a, 0xb4, 0x8a, 0xc4, 0x6d, 0x10, 0xa7, 0x25, 0x34, 0x69,
	0xb0, 0xa5, 0xbb, 0x8e, 0x06, 0xc9, 0xa2, 0x88, 0x44, 0x13, 0x9d, 0x04, 0x05, 0x4d, 0xe4, 0xdb,
	0x73, 0x1c, 0xc3, 0x9e, 0xc7, 0xb2, 0xc7, 0xab, 0xbb, 0x8e, 0x92, 0x86, 0x1f, 0xe0, 0x0b, 0x10,
	0x9f, 0x40, 0x8f, 0xa0, 0xe5, 0x17, 0xf8, 0x0a, 0x74, 0x15, 0xda, 0xf5, 0x6e, 0x81, 0x40, 0x22,
	0xdd, 0xf8, 0xbd, 0x37, 0xa3, 0x79, 0xcf, 0x43, 0x5f, 0x69, 0x83, 0xd7, 0x71, 0xc5, 0x6a, 0xd8,
	0xf0, 0x00, 0x0d, 0x3c, 0x31, 0xc0, 0x75, 0x03, 0xc0, 0x9d, 0x87, 0x37, 0xaa, 0xc6, 0x90, 0x5e,
	0xd2, 0x19, 0xae, 0xb6, 0xa8, 0xbc, 0x95, 0x0d, 0x57, 0xb6, 0x85, 0x1d, 0xaf, 0xc1, 0x5e, 0x19,
	0xcd, 0x6b, 0xf0, 0x8a, 0xb7, 0x0b, 0x7e, 0x8d, 0xe8, 0x2e, 0xa3, 0x37, 0xcc, 0x79, 0x40, 0x28,
	0x8e, 0x7b, 0x11, 0x4b, 0x22, 0xd6, 0x89, 0x58, 0xbb, 0x38, 0x99, 0x69, 0x00, 0xdd, 0x28, 0xde,
	0x6b, 0x56, 0xf1, 0x8a, 0xaf, 0xa3, 0x97, 0x68, 0xc0, 0xa6, 0xae, 0x93, 0x87, 0x71, 0xed, 0x24,
	0x97, 0xd6, 0x02, 0xf6, 0x70, 0xe0, 0x01, 0x25, 0xc6, 0x30, 0xd0, 0x8f, 0xfe, 0xa2, 0x5b, 0xe5,
	0x83, 0x01, 0x6b, 0xac, 0x1e, 0x24, 0xf7, 0x5b, 0xd9, 0x98, 0xb5, 0x44, 0xc5, 0xc7, 0x62, 0x20,
	0x8e, 0x35, 0x68, 0xe8, 0x4b, 0xde, 0x55, 0x09, 0x3d, 0xfd, 0x46, 0x68, 0x7e, 0x8e, 0xe8, 0x5e,
	0x7a, 0x53, 0x94, 0x74, 0x12, 0xbd, 0x99, 0x92, 0x8a, 0x9c, 0xdd, 0x16, 0xf9, 0x5e, 0x1c, 0xfa,
	0xac, 0x22, 0xcb, 0x0e, 0x2b, 0x1e, 0xd3, 0xbc, 0x6e, 0x62, 0x40, 0xe5, 0xa7, 0xd9, 0x1f, 0xf4,
	0xf9, 0xc1, 0x72, 0x64, 0x8a, 0x67, 0x34, 0x47, 0xb3, 0x51, 0x10, 0x71, 0x3a, 0xa9, 0xc8, 0xd9,
	0x9d, 0x79, 0xc9, 0x92, 0x5d, 0x36, 0xda, 0x65, 0xcf, 0x07, 0xbb, 0x82, 0xee, 0x45, 0xfe, 0x99,
	0x1c, 0xde, 0x22, 0xf3, 0x83, 0xe5, 0xd8, 0xf5, 0xb4, 0xfa, 0xf8, 0xf5, 0xfd, 0xec, 0x01, 0x2d,
	0x53, 0x74, 0xd2, 0x19, 0xd6, 0xce, 0x53, 0x74, 0xc3, 0x8a, 0xa2, 0xa4, 0x45, 0xca, 0xd9, 0x05,
	0xf4, 0x4a, 0x6e, 0x2e, 0x71, 0xe7, 0x54, 0x31, 0xf9, 0x25, 0x88, 0xf8, 0x40, 0x3e, 0xfd, 0x9c,
	0x91, 0x2f, 0xef, 0xbe, 0xff, 0x38, 0xca, 0xee, 0x65, 0xf4, 0xd4, 0x00, 0xeb, 0xe7, 0x38, 0x0f,
	0xdb, 0x1d, 0xfb, 0xd7, 0x6f, 0x88, 0xbb, 0xc3, 0xd8, 0x8b, 0x6e, 0xbd, 0x0b, 0xf2, 0xfa, 0xc5,
	0xcd, 0x6e, 0xc1, 0xbd, 0xd5, 0xff, 0xbf, 0x87, 0xd5, 0x51, 0x6f, 0x7a, 0xf1, 0x3b, 0x00, 0x00,
	0xff, 0xff, 0x11, 0x60, 0x8f, 0x35, 0x61, 0x02, 0x00, 0x00,
}

func (this *HttpUri) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HttpUri)
	if !ok {
		that2, ok := that.(HttpUri)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Uri != that1.Uri {
		return false
	}
	if that1.HttpUpstreamType == nil {
		if this.HttpUpstreamType != nil {
			return false
		}
	} else if this.HttpUpstreamType == nil {
		return false
	} else if !this.HttpUpstreamType.Equal(that1.HttpUpstreamType) {
		return false
	}
	if !this.Timeout.Equal(that1.Timeout) {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *HttpUri_Cluster) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HttpUri_Cluster)
	if !ok {
		that2, ok := that.(HttpUri_Cluster)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Cluster != that1.Cluster {
		return false
	}
	return true
}
