// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: github.com/solo-io/gloo/projects/gloo/api/external/envoy/extensions/proxylatency/proxylatency.proto

package proxylatency

import (
	bytes "bytes"
	fmt "fmt"
	math "math"

	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/gogo/protobuf/proto"
	types "github.com/gogo/protobuf/types"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

// How to perform the latency measurement. Given an incoming request from downstream and
// outging request to upstream; or incoming response from upstream and outgoing repsonse to
// downstream, This outlines how to measure the latency used by the proxy.
type ProxyLatency_Measurement int32

const (
	// Count from the last byte of the incoming request\response to the first byte of the outgoing request\response.
	ProxyLatency_LAST_INCOMING_FIRST_OUTGOING ProxyLatency_Measurement = 0
	// Count from the first byte of the incoming request\response to the first byte of the outgoing request\response.
	ProxyLatency_FIRST_INCOMING_FIRST_OUTGOING ProxyLatency_Measurement = 1
	// Count from the last byte of the incoming request\response to the last byte of the outgoing request\response.
	ProxyLatency_LAST_INCOMING_LAST_OUTGOING ProxyLatency_Measurement = 2
	// Count from the first byte of the incoming request\response to the last byte of the outgoing request\response.
	ProxyLatency_FIRST_INCOMING_LAST_OUTGOING ProxyLatency_Measurement = 3
)

var ProxyLatency_Measurement_name = map[int32]string{
	0: "LAST_INCOMING_FIRST_OUTGOING",
	1: "FIRST_INCOMING_FIRST_OUTGOING",
	2: "LAST_INCOMING_LAST_OUTGOING",
	3: "FIRST_INCOMING_LAST_OUTGOING",
}

var ProxyLatency_Measurement_value = map[string]int32{
	"LAST_INCOMING_FIRST_OUTGOING":  0,
	"FIRST_INCOMING_FIRST_OUTGOING": 1,
	"LAST_INCOMING_LAST_OUTGOING":   2,
	"FIRST_INCOMING_LAST_OUTGOING":  3,
}

func (x ProxyLatency_Measurement) String() string {
	return proto.EnumName(ProxyLatency_Measurement_name, int32(x))
}

func (ProxyLatency_Measurement) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_b72148e2a3523d34, []int{0, 0}
}

// Configure the proxy latency filter. This filter measures the latency
// incurred by the filter chain in a histogram.
type ProxyLatency struct {
	// How to measure the request.
	Request ProxyLatency_Measurement `protobuf:"varint,1,opt,name=request,proto3,enum=envoy.config.filter.http.proxylatency.v2.ProxyLatency_Measurement" json:"request,omitempty"`
	// When FIRST_OUTGOING (i.e. LAST_INCOMING_FIRST_OUTGOING or FIRST_INCOMING_FIRST_OUTGOING) is
	// instead of when the first byte is sent upstream. This has the advantage of not measuring the time
	// selected for request measurment, finish measuring proxy latency when decodeHeader for this
	// it takes a connection to form, which may skew the P99.
	// filter is hit instead of when the first byte is sent upstream. This has the advantage of not
	// for this to work the filter should be inserted last, just before the router filter.
	// measuring the time it takes a connection to form, which may skew the P99. For this to work
	// this filter should be inserted last, just before the router filter. This has no effect if
	// other measurement type is selected, and has no effect on how response is measured.
	MeasureRequestInternally bool `protobuf:"varint,5,opt,name=measure_request_internally,json=measureRequestInternally,proto3" json:"measure_request_internally,omitempty"`
	// How measure the response.
	Response ProxyLatency_Measurement `protobuf:"varint,2,opt,name=response,proto3,enum=envoy.config.filter.http.proxylatency.v2.ProxyLatency_Measurement" json:"response,omitempty"`
	// Charge a stat per upstream cluster. If not specified, defaults to true.
	ChargeClusterStat *types.BoolValue `protobuf:"bytes,3,opt,name=charge_cluster_stat,json=chargeClusterStat,proto3" json:"charge_cluster_stat,omitempty"`
	// Charge a stat per listener. If not specified, defaults to true.
	ChargeListenerStat *types.BoolValue `protobuf:"bytes,4,opt,name=charge_listener_stat,json=chargeListenerStat,proto3" json:"charge_listener_stat,omitempty"`
	// Should we emit request timing to dynamic metadata. defaults to true.
	EmitDynamicMetadata  *types.BoolValue `protobuf:"bytes,6,opt,name=emit_dynamic_metadata,json=emitDynamicMetadata,proto3" json:"emit_dynamic_metadata,omitempty"`
	XXX_NoUnkeyedLiteral struct{}         `json:"-"`
	XXX_unrecognized     []byte           `json:"-"`
	XXX_sizecache        int32            `json:"-"`
}

func (m *ProxyLatency) Reset()         { *m = ProxyLatency{} }
func (m *ProxyLatency) String() string { return proto.CompactTextString(m) }
func (*ProxyLatency) ProtoMessage()    {}
func (*ProxyLatency) Descriptor() ([]byte, []int) {
	return fileDescriptor_b72148e2a3523d34, []int{0}
}
func (m *ProxyLatency) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_ProxyLatency.Unmarshal(m, b)
}
func (m *ProxyLatency) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_ProxyLatency.Marshal(b, m, deterministic)
}
func (m *ProxyLatency) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ProxyLatency.Merge(m, src)
}
func (m *ProxyLatency) XXX_Size() int {
	return xxx_messageInfo_ProxyLatency.Size(m)
}
func (m *ProxyLatency) XXX_DiscardUnknown() {
	xxx_messageInfo_ProxyLatency.DiscardUnknown(m)
}

var xxx_messageInfo_ProxyLatency proto.InternalMessageInfo

func (m *ProxyLatency) GetRequest() ProxyLatency_Measurement {
	if m != nil {
		return m.Request
	}
	return ProxyLatency_LAST_INCOMING_FIRST_OUTGOING
}

func (m *ProxyLatency) GetMeasureRequestInternally() bool {
	if m != nil {
		return m.MeasureRequestInternally
	}
	return false
}

func (m *ProxyLatency) GetResponse() ProxyLatency_Measurement {
	if m != nil {
		return m.Response
	}
	return ProxyLatency_LAST_INCOMING_FIRST_OUTGOING
}

func (m *ProxyLatency) GetChargeClusterStat() *types.BoolValue {
	if m != nil {
		return m.ChargeClusterStat
	}
	return nil
}

func (m *ProxyLatency) GetChargeListenerStat() *types.BoolValue {
	if m != nil {
		return m.ChargeListenerStat
	}
	return nil
}

func (m *ProxyLatency) GetEmitDynamicMetadata() *types.BoolValue {
	if m != nil {
		return m.EmitDynamicMetadata
	}
	return nil
}

func init() {
	proto.RegisterEnum("envoy.config.filter.http.proxylatency.v2.ProxyLatency_Measurement", ProxyLatency_Measurement_name, ProxyLatency_Measurement_value)
	proto.RegisterType((*ProxyLatency)(nil), "envoy.config.filter.http.proxylatency.v2.ProxyLatency")
}

func init() {
	proto.RegisterFile("github.com/solo-io/gloo/projects/gloo/api/external/envoy/extensions/proxylatency/proxylatency.proto", fileDescriptor_b72148e2a3523d34)
}

var fileDescriptor_b72148e2a3523d34 = []byte{
	// 454 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xac, 0x93, 0xdf, 0x6e, 0xd3, 0x30,
	0x14, 0xc6, 0xc9, 0xc6, 0xc6, 0xe4, 0x21, 0x04, 0xde, 0x90, 0xa2, 0x02, 0xa3, 0xec, 0xaa, 0x37,
	0x38, 0xd2, 0xb8, 0xe5, 0x86, 0x0e, 0x51, 0x15, 0xf5, 0x0f, 0x6a, 0x0b, 0x17, 0x13, 0x22, 0x72,
	0xb3, 0xd3, 0xd4, 0xe0, 0xf8, 0x04, 0xfb, 0x64, 0x2c, 0xef, 0xc0, 0x2d, 0xef, 0xc0, 0x73, 0xf1,
	0x24, 0x28, 0x71, 0x5a, 0xad, 0x48, 0x68, 0x43, 0xe2, 0xce, 0xe7, 0xe4, 0xfb, 0xfd, 0x62, 0x7d,
	0x92, 0x59, 0x92, 0x2a, 0x5a, 0x16, 0x73, 0x91, 0x60, 0x16, 0x39, 0xd4, 0xf8, 0x5c, 0x61, 0x94,
	0x6a, 0xc4, 0x28, 0xb7, 0xf8, 0x19, 0x12, 0x72, 0x7e, 0x92, 0xb9, 0x8a, 0xe0, 0x92, 0xc0, 0x1a,
	0xa9, 0x23, 0x30, 0x17, 0x58, 0xd6, 0xa3, 0x71, 0x0a, 0x8d, 0xab, 0xb2, 0x97, 0xa5, 0x96, 0x04,
	0x26, 0x29, 0x37, 0x06, 0x91, 0x5b, 0x24, 0xe4, 0x9d, 0x9a, 0x10, 0x09, 0x9a, 0x85, 0x4a, 0xc5,
	0x42, 0x69, 0x02, 0x2b, 0x96, 0x44, 0xb9, 0xd8, 0x08, 0x5f, 0x9c, 0xb4, 0x8e, 0x52, 0xc4, 0x54,
	0x43, 0x54, 0x73, 0xf3, 0x62, 0x11, 0x7d, 0xb3, 0x32, 0xcf, 0xc1, 0x3a, 0x6f, 0x6a, 0x1d, 0xa6,
	0x98, 0x62, 0x7d, 0x8c, 0xaa, 0x93, 0xdf, 0x1e, 0x7f, 0xdf, 0x61, 0x77, 0xdf, 0x55, 0xa6, 0x81,
	0x37, 0xf1, 0x8f, 0xec, 0x8e, 0x85, 0xaf, 0x05, 0x38, 0x0a, 0x83, 0x76, 0xd0, 0xb9, 0x77, 0xd2,
	0x15, 0x37, 0xbd, 0x82, 0xb8, 0x2a, 0x12, 0x43, 0x90, 0xae, 0xb0, 0x90, 0x81, 0xa1, 0xc9, 0x4a,
	0xc9, 0x5f, 0xb2, 0x56, 0xe6, 0xf7, 0x71, 0xb3, 0x8a, 0x95, 0xf1, 0xdd, 0xe8, 0x32, 0xdc, 0x69,
	0x07, 0x9d, 0xbd, 0x49, 0xd8, 0x24, 0x26, 0x3e, 0xd0, 0x5f, 0x7f, 0xe7, 0x9f, 0xd8, 0x9e, 0x05,
	0x97, 0xa3, 0x71, 0x10, 0x6e, 0xfd, 0xb7, 0xcb, 0xad, 0x9d, 0xfc, 0x2d, 0x3b, 0x48, 0x96, 0xd2,
	0xa6, 0x10, 0x27, 0xba, 0x70, 0x04, 0x36, 0x76, 0x24, 0x29, 0xdc, 0x6e, 0x07, 0x9d, 0xfd, 0x93,
	0x96, 0xf0, 0x05, 0x8b, 0x55, 0xc1, 0xa2, 0x8b, 0xa8, 0x3f, 0x48, 0x5d, 0xc0, 0xe4, 0x81, 0xc7,
	0x4e, 0x3d, 0x35, 0x25, 0x49, 0x7c, 0xc0, 0x0e, 0x1b, 0x97, 0x56, 0x8e, 0xc0, 0xac, 0x64, 0xb7,
	0xaf, 0x95, 0x71, 0xcf, 0x0d, 0x1a, 0xac, 0xb6, 0x8d, 0xd8, 0x43, 0xc8, 0x14, 0xc5, 0xe7, 0xa5,
	0x91, 0x99, 0x4a, 0xe2, 0x0c, 0x48, 0x9e, 0x4b, 0x92, 0xe1, 0xee, 0xb5, 0xba, 0x83, 0x0a, 0x7c,
	0xed, 0xb9, 0x61, 0x83, 0x1d, 0xff, 0x08, 0xd8, 0xfe, 0x95, 0x0e, 0x78, 0x9b, 0x3d, 0x1e, 0xbc,
	0x9a, 0xce, 0xe2, 0xfe, 0xe8, 0x74, 0x3c, 0xec, 0x8f, 0x7a, 0xf1, 0x9b, 0xfe, 0x64, 0x3a, 0x8b,
	0xc7, 0xef, 0x67, 0xbd, 0x71, 0x7f, 0xd4, 0xbb, 0x7f, 0x8b, 0x3f, 0x63, 0x4f, 0xfc, 0xee, 0x6f,
	0x91, 0x80, 0x3f, 0x65, 0x8f, 0x36, 0x25, 0xf5, 0xb4, 0x0e, 0x6c, 0x55, 0x7f, 0xf9, 0xc3, 0xb1,
	0x99, 0xd8, 0xee, 0x9e, 0xfd, 0xfc, 0x75, 0x14, 0x9c, 0xcd, 0x6e, 0xf6, 0xb2, 0xf2, 0x2f, 0xe9,
	0x3f, 0xbc, 0xae, 0xf9, 0x6e, 0x5d, 0xce, 0x8b, 0xdf, 0x01, 0x00, 0x00, 0xff, 0xff, 0xaf, 0xf2,
	0x0a, 0x9b, 0xb8, 0x03, 0x00, 0x00,
}

func (this *ProxyLatency) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*ProxyLatency)
	if !ok {
		that2, ok := that.(ProxyLatency)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Request != that1.Request {
		return false
	}
	if this.MeasureRequestInternally != that1.MeasureRequestInternally {
		return false
	}
	if this.Response != that1.Response {
		return false
	}
	if !this.ChargeClusterStat.Equal(that1.ChargeClusterStat) {
		return false
	}
	if !this.ChargeListenerStat.Equal(that1.ChargeListenerStat) {
		return false
	}
	if !this.EmitDynamicMetadata.Equal(that1.EmitDynamicMetadata) {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
