// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: github.com/solo-io/gloo/projects/gloo/api/external/envoy/type/v3/percent.proto

package v3

import (
	bytes "bytes"
	fmt "fmt"
	math "math"

	_ "github.com/envoyproxy/protoc-gen-validate/validate"
	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/gogo/protobuf/proto"
	_ "github.com/solo-io/gloo/projects/gloo/pkg/api/external/udpa/annotations"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

// Fraction percentages support several fixed denominator values.
type FractionalPercent_DenominatorType int32

const (
	// 100.
	//
	// **Example**: 1/100 = 1%.
	FractionalPercent_HUNDRED FractionalPercent_DenominatorType = 0
	// 10,000.
	//
	// **Example**: 1/10000 = 0.01%.
	FractionalPercent_TEN_THOUSAND FractionalPercent_DenominatorType = 1
	// 1,000,000.
	//
	// **Example**: 1/1000000 = 0.0001%.
	FractionalPercent_MILLION FractionalPercent_DenominatorType = 2
)

var FractionalPercent_DenominatorType_name = map[int32]string{
	0: "HUNDRED",
	1: "TEN_THOUSAND",
	2: "MILLION",
}

var FractionalPercent_DenominatorType_value = map[string]int32{
	"HUNDRED":      0,
	"TEN_THOUSAND": 1,
	"MILLION":      2,
}

func (x FractionalPercent_DenominatorType) String() string {
	return proto.EnumName(FractionalPercent_DenominatorType_name, int32(x))
}

func (FractionalPercent_DenominatorType) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_d543f86d3b33bc60, []int{1, 0}
}

// Identifies a percentage, in the range [0.0, 100.0].
type Percent struct {
	Value                float64  `protobuf:"fixed64,1,opt,name=value,proto3" json:"value,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *Percent) Reset()         { *m = Percent{} }
func (m *Percent) String() string { return proto.CompactTextString(m) }
func (*Percent) ProtoMessage()    {}
func (*Percent) Descriptor() ([]byte, []int) {
	return fileDescriptor_d543f86d3b33bc60, []int{0}
}
func (m *Percent) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Percent.Unmarshal(m, b)
}
func (m *Percent) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Percent.Marshal(b, m, deterministic)
}
func (m *Percent) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Percent.Merge(m, src)
}
func (m *Percent) XXX_Size() int {
	return xxx_messageInfo_Percent.Size(m)
}
func (m *Percent) XXX_DiscardUnknown() {
	xxx_messageInfo_Percent.DiscardUnknown(m)
}

var xxx_messageInfo_Percent proto.InternalMessageInfo

func (m *Percent) GetValue() float64 {
	if m != nil {
		return m.Value
	}
	return 0
}

// A fractional percentage is used in cases in which for performance reasons performing floating
// point to integer conversions during randomness calculations is undesirable. The message includes
// both a numerator and denominator that together determine the final fractional value.
//
// * **Example**: 1/100 = 1%.
// * **Example**: 3/10000 = 0.03%.
type FractionalPercent struct {
	// Specifies the numerator. Defaults to 0.
	Numerator uint32 `protobuf:"varint,1,opt,name=numerator,proto3" json:"numerator,omitempty"`
	// Specifies the denominator. If the denominator specified is less than the numerator, the final
	// fractional percentage is capped at 1 (100%).
	Denominator          FractionalPercent_DenominatorType `protobuf:"varint,2,opt,name=denominator,proto3,enum=envoy.type.v3.FractionalPercent_DenominatorType" json:"denominator,omitempty"`
	XXX_NoUnkeyedLiteral struct{}                          `json:"-"`
	XXX_unrecognized     []byte                            `json:"-"`
	XXX_sizecache        int32                             `json:"-"`
}

func (m *FractionalPercent) Reset()         { *m = FractionalPercent{} }
func (m *FractionalPercent) String() string { return proto.CompactTextString(m) }
func (*FractionalPercent) ProtoMessage()    {}
func (*FractionalPercent) Descriptor() ([]byte, []int) {
	return fileDescriptor_d543f86d3b33bc60, []int{1}
}
func (m *FractionalPercent) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_FractionalPercent.Unmarshal(m, b)
}
func (m *FractionalPercent) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_FractionalPercent.Marshal(b, m, deterministic)
}
func (m *FractionalPercent) XXX_Merge(src proto.Message) {
	xxx_messageInfo_FractionalPercent.Merge(m, src)
}
func (m *FractionalPercent) XXX_Size() int {
	return xxx_messageInfo_FractionalPercent.Size(m)
}
func (m *FractionalPercent) XXX_DiscardUnknown() {
	xxx_messageInfo_FractionalPercent.DiscardUnknown(m)
}

var xxx_messageInfo_FractionalPercent proto.InternalMessageInfo

func (m *FractionalPercent) GetNumerator() uint32 {
	if m != nil {
		return m.Numerator
	}
	return 0
}

func (m *FractionalPercent) GetDenominator() FractionalPercent_DenominatorType {
	if m != nil {
		return m.Denominator
	}
	return FractionalPercent_HUNDRED
}

func init() {
	proto.RegisterEnum("envoy.type.v3.FractionalPercent_DenominatorType", FractionalPercent_DenominatorType_name, FractionalPercent_DenominatorType_value)
	proto.RegisterType((*Percent)(nil), "envoy.type.v3.Percent")
	proto.RegisterType((*FractionalPercent)(nil), "envoy.type.v3.FractionalPercent")
}

func init() {
	proto.RegisterFile("github.com/solo-io/gloo/projects/gloo/api/external/envoy/type/v3/percent.proto", fileDescriptor_d543f86d3b33bc60)
}

var fileDescriptor_d543f86d3b33bc60 = []byte{
	// 426 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x8c, 0x52, 0xcd, 0x6e, 0xd3, 0x40,
	0x10, 0xce, 0x5a, 0x6a, 0x0b, 0xdb, 0x16, 0xcc, 0x2a, 0x52, 0x69, 0x29, 0x51, 0x09, 0x97, 0x72,
	0xa8, 0x17, 0x91, 0x5b, 0x25, 0x24, 0xb0, 0x5c, 0xd4, 0x4a, 0xc1, 0x89, 0x9c, 0xe4, 0x00, 0x42,
	0x42, 0x1b, 0x67, 0x65, 0x16, 0x9c, 0x9d, 0xd5, 0x7a, 0x6d, 0xc5, 0x27, 0x10, 0x27, 0x9e, 0x81,
	0x27, 0xe0, 0x19, 0xb8, 0x23, 0x71, 0xe5, 0x15, 0x78, 0x05, 0x6e, 0x39, 0x21, 0xff, 0x44, 0x49,
	0x88, 0x84, 0x3a, 0xa7, 0xf1, 0x7c, 0xdf, 0x7c, 0xfe, 0x66, 0x67, 0xb0, 0x1f, 0x09, 0xf3, 0x2e,
	0x1d, 0x3b, 0x21, 0x4c, 0x69, 0x02, 0x31, 0x9c, 0x09, 0xa0, 0x51, 0x0c, 0x40, 0x95, 0x86, 0xf7,
	0x3c, 0x34, 0x49, 0xf5, 0xc5, 0x94, 0xa0, 0x7c, 0x66, 0xb8, 0x96, 0x2c, 0xa6, 0x5c, 0x66, 0x90,
	0x53, 0x93, 0x2b, 0x4e, 0xb3, 0x0e, 0x55, 0x5c, 0x87, 0x5c, 0x1a, 0x47, 0x69, 0x30, 0x40, 0xf6,
	0x4b, 0xd0, 0x29, 0x40, 0x27, 0xeb, 0x1c, 0xdd, 0x4f, 0x27, 0x8a, 0x51, 0x26, 0x25, 0x18, 0x66,
	0x04, 0xc8, 0x84, 0x26, 0x86, 0x99, 0x34, 0xa9, 0xd8, 0x47, 0x0f, 0x36, 0xe0, 0x8c, 0xeb, 0x44,
	0x80, 0x14, 0x32, 0xaa, 0x29, 0x07, 0x19, 0x8b, 0xc5, 0x84, 0x19, 0x4e, 0x17, 0x49, 0x0d, 0x34,
	0x23, 0x88, 0xa0, 0x4c, 0x69, 0x91, 0x55, 0xd5, 0xf6, 0x00, 0xef, 0xf4, 0x2b, 0x43, 0xe4, 0x0c,
	0x6f, 0x65, 0x2c, 0x4e, 0xf9, 0x5d, 0x74, 0x82, 0x4e, 0x91, 0x7b, 0x30, 0x77, 0x9b, 0x84, 0x1c,
	0x36, 0xca, 0x78, 0xf5, 0xec, 0x51, 0xa3, 0x8e, 0xa0, 0x62, 0x9d, 0x1f, 0x7e, 0xfd, 0xf1, 0xa5,
	0xd5, 0xc4, 0x64, 0x65, 0x80, 0x5a, 0xa9, 0xfd, 0x07, 0xe1, 0x3b, 0x2f, 0x34, 0x0b, 0x0b, 0x8b,
	0x2c, 0x5e, 0xe8, 0x1f, 0xe3, 0x9b, 0x32, 0x9d, 0x72, 0xcd, 0x0c, 0xe8, 0xf2, 0x1f, 0xfb, 0xc1,
	0xb2, 0x40, 0xde, 0xe0, 0xdd, 0x09, 0x97, 0x30, 0x15, 0xb2, 0xc4, 0xad, 0x13, 0x74, 0x7a, 0xeb,
	0xc9, 0x63, 0x67, 0xed, 0x79, 0x9c, 0x0d, 0x51, 0xc7, 0x5b, 0xf6, 0x0c, 0x73, 0xc5, 0xdd, 0x1b,
	0x73, 0x77, 0xeb, 0x33, 0xb2, 0x6c, 0x14, 0xac, 0xca, 0xb5, 0x9f, 0xe2, 0xdb, 0xff, 0x30, 0xc9,
	0x2e, 0xde, 0xb9, 0x1c, 0xf9, 0x5e, 0x70, 0xe1, 0xd9, 0x0d, 0x62, 0xe3, 0xbd, 0xe1, 0x85, 0xff,
	0x76, 0x78, 0xd9, 0x1b, 0x0d, 0x9e, 0xfb, 0x9e, 0x8d, 0x0a, 0xf8, 0xe5, 0x55, 0xb7, 0x7b, 0xd5,
	0xf3, 0x6d, 0xeb, 0xfc, 0x61, 0x31, 0x6b, 0x0b, 0x1f, 0xaf, 0xb8, 0xd9, 0xb0, 0xe2, 0x7e, 0xfc,
	0xf6, 0xbb, 0x85, 0xbe, 0x7f, 0xfa, 0xf9, 0x6b, 0xdb, 0xb2, 0x2d, 0x7c, 0x4f, 0x40, 0x65, 0x5e,
	0x69, 0x98, 0xe5, 0xeb, 0x73, 0xb8, 0x7b, 0x75, 0x4f, 0xbf, 0xd8, 0x41, 0x1f, 0xbd, 0xf6, 0xae,
	0x77, 0x55, 0xea, 0x43, 0xf4, 0x9f, 0xcb, 0x1a, 0x6f, 0x97, 0x2b, 0xed, 0xfc, 0x0d, 0x00, 0x00,
	0xff, 0xff, 0xe2, 0x32, 0x5a, 0x60, 0xa4, 0x02, 0x00, 0x00,
}

func (this *Percent) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*Percent)
	if !ok {
		that2, ok := that.(Percent)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Value != that1.Value {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *FractionalPercent) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*FractionalPercent)
	if !ok {
		that2, ok := that.(FractionalPercent)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Numerator != that1.Numerator {
		return false
	}
	if this.Denominator != that1.Denominator {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
