// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: github.com/solo-io/gloo/projects/gloo/api/v1/connection.proto

package v1

import (
	bytes "bytes"
	fmt "fmt"
	math "math"
	time "time"

	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/gogo/protobuf/proto"
	types "github.com/gogo/protobuf/types"
	_ "github.com/solo-io/protoc-gen-ext/extproto"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf
var _ = time.Kitchen

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

// Fine tune the settings for connections to an upstream
type ConnectionConfig struct {
	// Maximum requests for a single upstream connection (unspecified or zero = no limit)
	MaxRequestsPerConnection uint32 `protobuf:"varint,1,opt,name=max_requests_per_connection,json=maxRequestsPerConnection,proto3" json:"max_requests_per_connection,omitempty"`
	// The timeout for new network connections to hosts in the cluster
	ConnectTimeout *time.Duration `protobuf:"bytes,2,opt,name=connect_timeout,json=connectTimeout,proto3,stdduration" json:"connect_timeout,omitempty"`
	// Configure OS-level tcp keepalive checks
	TcpKeepalive *ConnectionConfig_TcpKeepAlive `protobuf:"bytes,3,opt,name=tcp_keepalive,json=tcpKeepalive,proto3" json:"tcp_keepalive,omitempty"`
	// Soft limit on size of the cluster’s connections read and write buffers. If unspecified, an implementation defined default is applied (1MiB).
	// For more info, see the [envoy docs](https://www.envoyproxy.io/docs/envoy/v1.14.1/api-v2/api/v2/cluster.proto#cluster)
	PerConnectionBufferLimitBytes *types.UInt32Value `protobuf:"bytes,4,opt,name=per_connection_buffer_limit_bytes,json=perConnectionBufferLimitBytes,proto3" json:"per_connection_buffer_limit_bytes,omitempty"`
	XXX_NoUnkeyedLiteral          struct{}           `json:"-"`
	XXX_unrecognized              []byte             `json:"-"`
	XXX_sizecache                 int32              `json:"-"`
}

func (m *ConnectionConfig) Reset()         { *m = ConnectionConfig{} }
func (m *ConnectionConfig) String() string { return proto.CompactTextString(m) }
func (*ConnectionConfig) ProtoMessage()    {}
func (*ConnectionConfig) Descriptor() ([]byte, []int) {
	return fileDescriptor_56610fe13cf10c84, []int{0}
}
func (m *ConnectionConfig) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_ConnectionConfig.Unmarshal(m, b)
}
func (m *ConnectionConfig) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_ConnectionConfig.Marshal(b, m, deterministic)
}
func (m *ConnectionConfig) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ConnectionConfig.Merge(m, src)
}
func (m *ConnectionConfig) XXX_Size() int {
	return xxx_messageInfo_ConnectionConfig.Size(m)
}
func (m *ConnectionConfig) XXX_DiscardUnknown() {
	xxx_messageInfo_ConnectionConfig.DiscardUnknown(m)
}

var xxx_messageInfo_ConnectionConfig proto.InternalMessageInfo

func (m *ConnectionConfig) GetMaxRequestsPerConnection() uint32 {
	if m != nil {
		return m.MaxRequestsPerConnection
	}
	return 0
}

func (m *ConnectionConfig) GetConnectTimeout() *time.Duration {
	if m != nil {
		return m.ConnectTimeout
	}
	return nil
}

func (m *ConnectionConfig) GetTcpKeepalive() *ConnectionConfig_TcpKeepAlive {
	if m != nil {
		return m.TcpKeepalive
	}
	return nil
}

func (m *ConnectionConfig) GetPerConnectionBufferLimitBytes() *types.UInt32Value {
	if m != nil {
		return m.PerConnectionBufferLimitBytes
	}
	return nil
}

// If set then set SO_KEEPALIVE on the socket to enable TCP Keepalives.
// see more info here: https://www.envoyproxy.io/docs/envoy/latest/api-v2/api/v2/core/address.proto#envoy-api-msg-core-tcpkeepalive
type ConnectionConfig_TcpKeepAlive struct {
	// Maximum number of keepalive probes to send without response before deciding the connection is dead.
	KeepaliveProbes uint32 `protobuf:"varint,1,opt,name=keepalive_probes,json=keepaliveProbes,proto3" json:"keepalive_probes,omitempty"`
	// The number of seconds a connection needs to be idle before keep-alive probes start being sent. This is rounded up to the second.
	KeepaliveTime *time.Duration `protobuf:"bytes,2,opt,name=keepalive_time,json=keepaliveTime,proto3,stdduration" json:"keepalive_time,omitempty"`
	// The number of seconds between keep-alive probes. This is rounded up to the second.
	KeepaliveInterval    *time.Duration `protobuf:"bytes,3,opt,name=keepalive_interval,json=keepaliveInterval,proto3,stdduration" json:"keepalive_interval,omitempty"`
	XXX_NoUnkeyedLiteral struct{}       `json:"-"`
	XXX_unrecognized     []byte         `json:"-"`
	XXX_sizecache        int32          `json:"-"`
}

func (m *ConnectionConfig_TcpKeepAlive) Reset()         { *m = ConnectionConfig_TcpKeepAlive{} }
func (m *ConnectionConfig_TcpKeepAlive) String() string { return proto.CompactTextString(m) }
func (*ConnectionConfig_TcpKeepAlive) ProtoMessage()    {}
func (*ConnectionConfig_TcpKeepAlive) Descriptor() ([]byte, []int) {
	return fileDescriptor_56610fe13cf10c84, []int{0, 0}
}
func (m *ConnectionConfig_TcpKeepAlive) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_ConnectionConfig_TcpKeepAlive.Unmarshal(m, b)
}
func (m *ConnectionConfig_TcpKeepAlive) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_ConnectionConfig_TcpKeepAlive.Marshal(b, m, deterministic)
}
func (m *ConnectionConfig_TcpKeepAlive) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ConnectionConfig_TcpKeepAlive.Merge(m, src)
}
func (m *ConnectionConfig_TcpKeepAlive) XXX_Size() int {
	return xxx_messageInfo_ConnectionConfig_TcpKeepAlive.Size(m)
}
func (m *ConnectionConfig_TcpKeepAlive) XXX_DiscardUnknown() {
	xxx_messageInfo_ConnectionConfig_TcpKeepAlive.DiscardUnknown(m)
}

var xxx_messageInfo_ConnectionConfig_TcpKeepAlive proto.InternalMessageInfo

func (m *ConnectionConfig_TcpKeepAlive) GetKeepaliveProbes() uint32 {
	if m != nil {
		return m.KeepaliveProbes
	}
	return 0
}

func (m *ConnectionConfig_TcpKeepAlive) GetKeepaliveTime() *time.Duration {
	if m != nil {
		return m.KeepaliveTime
	}
	return nil
}

func (m *ConnectionConfig_TcpKeepAlive) GetKeepaliveInterval() *time.Duration {
	if m != nil {
		return m.KeepaliveInterval
	}
	return nil
}

func init() {
	proto.RegisterType((*ConnectionConfig)(nil), "gloo.solo.io.ConnectionConfig")
	proto.RegisterType((*ConnectionConfig_TcpKeepAlive)(nil), "gloo.solo.io.ConnectionConfig.TcpKeepAlive")
}

func init() {
	proto.RegisterFile("github.com/solo-io/gloo/projects/gloo/api/v1/connection.proto", fileDescriptor_56610fe13cf10c84)
}

var fileDescriptor_56610fe13cf10c84 = []byte{
	// 431 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x8c, 0x92, 0x4f, 0x6e, 0xd4, 0x30,
	0x14, 0xc6, 0x15, 0x18, 0xb1, 0x30, 0x33, 0x6d, 0xb1, 0x58, 0x84, 0x01, 0x4a, 0x61, 0x55, 0x84,
	0x70, 0xa0, 0xdd, 0x21, 0x75, 0xc1, 0x14, 0x21, 0x2a, 0x10, 0x1a, 0x45, 0x85, 0x05, 0x1b, 0xcb,
	0x09, 0x2f, 0xc6, 0x34, 0xc9, 0x33, 0x8e, 0x33, 0x84, 0x9b, 0x70, 0x04, 0xb8, 0x01, 0xd7, 0xe0,
	0x04, 0x48, 0xdc, 0x81, 0x3d, 0xb2, 0x63, 0x92, 0x81, 0x2e, 0x98, 0x5d, 0xde, 0x9f, 0xef, 0x97,
	0xef, 0x7d, 0x32, 0x39, 0x92, 0xca, 0xbe, 0x6b, 0x33, 0x96, 0x63, 0x95, 0x34, 0x58, 0xe2, 0x7d,
	0x85, 0x89, 0x2c, 0x11, 0x13, 0x6d, 0xf0, 0x3d, 0xe4, 0xb6, 0xe9, 0x2b, 0xa1, 0x55, 0xb2, 0x7a,
	0x98, 0xe4, 0x58, 0xd7, 0x90, 0x5b, 0x85, 0x35, 0xd3, 0x06, 0x2d, 0xd2, 0xa9, 0x9b, 0x32, 0x27,
	0x64, 0x0a, 0xe7, 0x57, 0x25, 0x4a, 0xf4, 0x83, 0xc4, 0x7d, 0xf5, 0x3b, 0xf3, 0x5d, 0x89, 0x28,
	0x4b, 0x48, 0x7c, 0x95, 0xb5, 0x45, 0xf2, 0xb6, 0x35, 0x62, 0x64, 0x9c, 0x9f, 0x7f, 0x34, 0x42,
	0x6b, 0x30, 0x4d, 0x98, 0x53, 0xe8, 0x6c, 0x0f, 0x85, 0xce, 0xf6, 0xbd, 0x3b, 0x5f, 0x27, 0x64,
	0xe7, 0x78, 0x30, 0x73, 0x8c, 0x75, 0xa1, 0x24, 0x3d, 0x22, 0xd7, 0x2b, 0xd1, 0x71, 0x03, 0x1f,
	0x5a, 0x68, 0x6c, 0xc3, 0x35, 0x18, 0x3e, 0x3a, 0x8e, 0xa3, 0xbd, 0x68, 0x7f, 0x96, 0xc6, 0x95,
	0xe8, 0xd2, 0xb0, 0xb1, 0x04, 0x33, 0x42, 0xe8, 0x33, 0xb2, 0x1d, 0xb6, 0xb9, 0x55, 0x15, 0x60,
	0x6b, 0xe3, 0x0b, 0x7b, 0xd1, 0xfe, 0xe5, 0x83, 0x6b, 0xac, 0x77, 0xc8, 0xfe, 0x38, 0x64, 0x4f,
	0xc2, 0x05, 0x8b, 0xc9, 0xe7, 0x1f, 0xb7, 0xa2, 0x74, 0x2b, 0xe8, 0x4e, 0x7b, 0x19, 0x5d, 0x92,
	0x99, 0xcd, 0x35, 0x3f, 0x03, 0xd0, 0xa2, 0x54, 0x2b, 0x88, 0x2f, 0x7a, 0xce, 0x3d, 0xb6, 0x9e,
	0x16, 0xfb, 0xd7, 0x3f, 0x3b, 0xcd, 0xf5, 0x73, 0x00, 0xfd, 0xd8, 0x49, 0xd2, 0xa9, 0xed, 0x2b,
	0x0f, 0xa0, 0x05, 0xb9, 0xfd, 0xf7, 0x35, 0x3c, 0x6b, 0x8b, 0x02, 0x0c, 0x2f, 0x55, 0xa5, 0x2c,
	0xcf, 0x3e, 0x59, 0x68, 0xe2, 0x89, 0xff, 0xcb, 0x8d, 0x73, 0x6e, 0x5f, 0x9d, 0xd4, 0xf6, 0xf0,
	0xe0, 0xb5, 0x28, 0x5b, 0x48, 0x6f, 0xea, 0xf5, 0x9b, 0x17, 0x1e, 0xf2, 0xc2, 0x31, 0x16, 0x0e,
	0x31, 0xff, 0x1e, 0x91, 0xe9, 0xba, 0x0d, 0x7a, 0x97, 0xec, 0x0c, 0x67, 0x70, 0x6d, 0x30, 0x83,
	0x26, 0x04, 0xb9, 0x3d, 0xf4, 0x97, 0xbe, 0x4d, 0x9f, 0x92, 0xad, 0x71, 0xd5, 0x25, 0xb8, 0x69,
	0x7c, 0xb3, 0x41, 0xe6, 0x02, 0xa4, 0x2f, 0x09, 0x1d, 0x39, 0xaa, 0xb6, 0x60, 0x56, 0xa2, 0x0c,
	0x11, 0xfe, 0x97, 0x75, 0x65, 0x90, 0x9e, 0x04, 0xe5, 0xe2, 0xd1, 0xb7, 0x5f, 0x93, 0xe8, 0xcb,
	0xcf, 0xdd, 0xe8, 0xcd, 0x83, 0xcd, 0x1e, 0xbb, 0x3e, 0x93, 0xe1, 0xc1, 0x67, 0x97, 0xfc, 0x7f,
	0x0e, 0x7f, 0x07, 0x00, 0x00, 0xff, 0xff, 0x4d, 0x37, 0x2f, 0xf0, 0x27, 0x03, 0x00, 0x00,
}

func (this *ConnectionConfig) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*ConnectionConfig)
	if !ok {
		that2, ok := that.(ConnectionConfig)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.MaxRequestsPerConnection != that1.MaxRequestsPerConnection {
		return false
	}
	if this.ConnectTimeout != nil && that1.ConnectTimeout != nil {
		if *this.ConnectTimeout != *that1.ConnectTimeout {
			return false
		}
	} else if this.ConnectTimeout != nil {
		return false
	} else if that1.ConnectTimeout != nil {
		return false
	}
	if !this.TcpKeepalive.Equal(that1.TcpKeepalive) {
		return false
	}
	if !this.PerConnectionBufferLimitBytes.Equal(that1.PerConnectionBufferLimitBytes) {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *ConnectionConfig_TcpKeepAlive) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*ConnectionConfig_TcpKeepAlive)
	if !ok {
		that2, ok := that.(ConnectionConfig_TcpKeepAlive)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.KeepaliveProbes != that1.KeepaliveProbes {
		return false
	}
	if this.KeepaliveTime != nil && that1.KeepaliveTime != nil {
		if *this.KeepaliveTime != *that1.KeepaliveTime {
			return false
		}
	} else if this.KeepaliveTime != nil {
		return false
	} else if that1.KeepaliveTime != nil {
		return false
	}
	if this.KeepaliveInterval != nil && that1.KeepaliveInterval != nil {
		if *this.KeepaliveInterval != *that1.KeepaliveInterval {
			return false
		}
	} else if this.KeepaliveInterval != nil {
		return false
	} else if that1.KeepaliveInterval != nil {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
