// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: github.com/solo-io/gloo/projects/gloo/api/v1/endpoint.proto

package v1

import (
	bytes "bytes"
	fmt "fmt"
	math "math"

	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/gogo/protobuf/proto"
	_ "github.com/solo-io/protoc-gen-ext/extproto"
	core "github.com/solo-io/solo-kit/pkg/api/v1/resources/core"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

//
//
//Endpoints represent dynamically discovered address/ports where an upstream service is listening
type Endpoint struct {
	// List of the upstreams the endpoint belongs to
	Upstreams []*core.ResourceRef `protobuf:"bytes,1,rep,name=upstreams,proto3" json:"upstreams,omitempty"`
	// Address of the endpoint (ip or hostname)
	Address string `protobuf:"bytes,2,opt,name=address,proto3" json:"address,omitempty"`
	// listening port for the endpoint
	Port uint32 `protobuf:"varint,3,opt,name=port,proto3" json:"port,omitempty"`
	// hostname to use for the endpoint (e.g., auto host rewrite) if provided.
	Hostname string `protobuf:"bytes,4,opt,name=hostname,proto3" json:"hostname,omitempty"`
	// configuration for health checking the endpoint.
	HealthCheck *HealthCheckConfig `protobuf:"bytes,5,opt,name=health_check,json=healthCheck,proto3" json:"health_check,omitempty"`
	// Metadata contains the object metadata for this resource
	Metadata             core.Metadata `protobuf:"bytes,7,opt,name=metadata,proto3" json:"metadata"`
	XXX_NoUnkeyedLiteral struct{}      `json:"-"`
	XXX_unrecognized     []byte        `json:"-"`
	XXX_sizecache        int32         `json:"-"`
}

func (m *Endpoint) Reset()         { *m = Endpoint{} }
func (m *Endpoint) String() string { return proto.CompactTextString(m) }
func (*Endpoint) ProtoMessage()    {}
func (*Endpoint) Descriptor() ([]byte, []int) {
	return fileDescriptor_f7969f9617648787, []int{0}
}
func (m *Endpoint) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Endpoint.Unmarshal(m, b)
}
func (m *Endpoint) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Endpoint.Marshal(b, m, deterministic)
}
func (m *Endpoint) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Endpoint.Merge(m, src)
}
func (m *Endpoint) XXX_Size() int {
	return xxx_messageInfo_Endpoint.Size(m)
}
func (m *Endpoint) XXX_DiscardUnknown() {
	xxx_messageInfo_Endpoint.DiscardUnknown(m)
}

var xxx_messageInfo_Endpoint proto.InternalMessageInfo

func (m *Endpoint) GetUpstreams() []*core.ResourceRef {
	if m != nil {
		return m.Upstreams
	}
	return nil
}

func (m *Endpoint) GetAddress() string {
	if m != nil {
		return m.Address
	}
	return ""
}

func (m *Endpoint) GetPort() uint32 {
	if m != nil {
		return m.Port
	}
	return 0
}

func (m *Endpoint) GetHostname() string {
	if m != nil {
		return m.Hostname
	}
	return ""
}

func (m *Endpoint) GetHealthCheck() *HealthCheckConfig {
	if m != nil {
		return m.HealthCheck
	}
	return nil
}

func (m *Endpoint) GetMetadata() core.Metadata {
	if m != nil {
		return m.Metadata
	}
	return core.Metadata{}
}

type HealthCheckConfig struct {
	// hostname to use for the endpoint health checks if provided.
	Hostname             string   `protobuf:"bytes,1,opt,name=hostname,proto3" json:"hostname,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *HealthCheckConfig) Reset()         { *m = HealthCheckConfig{} }
func (m *HealthCheckConfig) String() string { return proto.CompactTextString(m) }
func (*HealthCheckConfig) ProtoMessage()    {}
func (*HealthCheckConfig) Descriptor() ([]byte, []int) {
	return fileDescriptor_f7969f9617648787, []int{1}
}
func (m *HealthCheckConfig) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_HealthCheckConfig.Unmarshal(m, b)
}
func (m *HealthCheckConfig) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_HealthCheckConfig.Marshal(b, m, deterministic)
}
func (m *HealthCheckConfig) XXX_Merge(src proto.Message) {
	xxx_messageInfo_HealthCheckConfig.Merge(m, src)
}
func (m *HealthCheckConfig) XXX_Size() int {
	return xxx_messageInfo_HealthCheckConfig.Size(m)
}
func (m *HealthCheckConfig) XXX_DiscardUnknown() {
	xxx_messageInfo_HealthCheckConfig.DiscardUnknown(m)
}

var xxx_messageInfo_HealthCheckConfig proto.InternalMessageInfo

func (m *HealthCheckConfig) GetHostname() string {
	if m != nil {
		return m.Hostname
	}
	return ""
}

func init() {
	proto.RegisterType((*Endpoint)(nil), "gloo.solo.io.Endpoint")
	proto.RegisterType((*HealthCheckConfig)(nil), "gloo.solo.io.HealthCheckConfig")
}

func init() {
	proto.RegisterFile("github.com/solo-io/gloo/projects/gloo/api/v1/endpoint.proto", fileDescriptor_f7969f9617648787)
}

var fileDescriptor_f7969f9617648787 = []byte{
	// 373 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x8c, 0x52, 0xbd, 0xce, 0xd3, 0x30,
	0x14, 0xc5, 0xf9, 0x0c, 0x5f, 0xeb, 0x94, 0x01, 0x0b, 0xa1, 0x34, 0x12, 0x6d, 0xd4, 0x29, 0x0b,
	0x0e, 0x94, 0x01, 0x54, 0xb6, 0x56, 0x48, 0x2c, 0x2c, 0x19, 0x59, 0x90, 0x9b, 0xdc, 0x26, 0xa1,
	0x4d, 0xae, 0x65, 0xbb, 0xa8, 0x73, 0x9f, 0x06, 0xf1, 0x04, 0x3c, 0x02, 0x4f, 0xc1, 0xc0, 0x1b,
	0x74, 0x60, 0x47, 0xf9, 0x6b, 0x29, 0x08, 0xe9, 0xdb, 0xee, 0xb9, 0xe7, 0x1c, 0xdf, 0x3f, 0xb3,
	0x37, 0x59, 0x61, 0xf3, 0xfd, 0x5a, 0x24, 0x58, 0x46, 0x06, 0x77, 0xf8, 0xac, 0xc0, 0x28, 0xdb,
	0x21, 0x46, 0x4a, 0xe3, 0x27, 0x48, 0xac, 0x69, 0x91, 0x54, 0x45, 0xf4, 0xf9, 0x45, 0x04, 0x55,
	0xaa, 0xb0, 0xa8, 0xac, 0x50, 0x1a, 0x2d, 0xf2, 0x51, 0xcd, 0x89, 0xda, 0x26, 0x0a, 0xf4, 0x1f,
	0x67, 0x98, 0x61, 0x43, 0x44, 0x75, 0xd4, 0x6a, 0x7c, 0x0e, 0x07, 0xdb, 0x26, 0xe1, 0xd0, 0xf9,
	0xfc, 0x49, 0x53, 0x69, 0x5b, 0xd8, 0xfe, 0xdd, 0x12, 0xac, 0x4c, 0xa5, 0x95, 0x1d, 0x3f, 0xfe,
	0x9b, 0xd7, 0xb0, 0xf9, 0x9f, 0xb5, 0xc7, 0x2d, 0x3f, 0xfb, 0xea, 0xb0, 0xc1, 0xdb, 0xae, 0x4b,
	0xfe, 0x8a, 0x0d, 0xf7, 0xca, 0x58, 0x0d, 0xb2, 0x34, 0x1e, 0x09, 0x6e, 0x42, 0x77, 0x3e, 0x16,
	0x09, 0x6a, 0xe8, 0x7b, 0x16, 0x31, 0x18, 0xdc, 0xeb, 0x04, 0x62, 0xd8, 0xc4, 0x17, 0x2d, 0xf7,
	0xd8, 0xad, 0x4c, 0x53, 0x0d, 0xc6, 0x78, 0x4e, 0x40, 0xc2, 0x61, 0xdc, 0x43, 0xce, 0x19, 0x55,
	0xa8, 0xad, 0x77, 0x13, 0x90, 0xf0, 0x61, 0xdc, 0xc4, 0xdc, 0x67, 0x83, 0x1c, 0x8d, 0xad, 0x64,
	0x09, 0x1e, 0x6d, 0xe4, 0x67, 0xcc, 0x97, 0x6c, 0x94, 0x83, 0xdc, 0xd9, 0xfc, 0x63, 0x92, 0x43,
	0xb2, 0xf5, 0xee, 0x07, 0x24, 0x74, 0xe7, 0x53, 0xf1, 0xe7, 0xe6, 0xc4, 0xbb, 0x46, 0xb1, 0xaa,
	0x05, 0x2b, 0xac, 0x36, 0x45, 0x16, 0xbb, 0xf9, 0x25, 0xc5, 0x5f, 0xb3, 0x41, 0xbf, 0x20, 0xef,
	0xb6, 0xf1, 0x3f, 0xb9, 0x9e, 0xe2, 0x7d, 0xc7, 0x2e, 0xe9, 0xf7, 0x1f, 0xd3, 0x7b, 0xf1, 0x59,
	0xbd, 0x78, 0x7a, 0x3c, 0x51, 0xca, 0x1c, 0x50, 0xc7, 0x13, 0x75, 0xf9, 0xb0, 0x3f, 0x9f, 0x39,
	0x9e, 0xa8, 0x13, 0x92, 0x59, 0xc4, 0x1e, 0xfd, 0x53, 0xfa, 0x6a, 0x1a, 0x72, 0x3d, 0xcd, 0x72,
	0xf1, 0xed, 0x17, 0x25, 0x5f, 0x7e, 0x4e, 0xc8, 0x87, 0xe7, 0x77, 0xfb, 0x37, 0x6a, 0x9b, 0x75,
	0x87, 0x5a, 0x3f, 0x68, 0x0e, 0xf4, 0xf2, 0x77, 0x00, 0x00, 0x00, 0xff, 0xff, 0x94, 0x49, 0xb7,
	0xa1, 0x72, 0x02, 0x00, 0x00,
}

func (this *Endpoint) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*Endpoint)
	if !ok {
		that2, ok := that.(Endpoint)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if len(this.Upstreams) != len(that1.Upstreams) {
		return false
	}
	for i := range this.Upstreams {
		if !this.Upstreams[i].Equal(that1.Upstreams[i]) {
			return false
		}
	}
	if this.Address != that1.Address {
		return false
	}
	if this.Port != that1.Port {
		return false
	}
	if this.Hostname != that1.Hostname {
		return false
	}
	if !this.HealthCheck.Equal(that1.HealthCheck) {
		return false
	}
	if !this.Metadata.Equal(&that1.Metadata) {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *HealthCheckConfig) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HealthCheckConfig)
	if !ok {
		that2, ok := that.(HealthCheckConfig)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Hostname != that1.Hostname {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
