// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: github.com/solo-io/gloo/projects/gloo/api/v1/options/consul/consul.proto

package consul

import (
	bytes "bytes"
	fmt "fmt"
	math "math"

	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/gogo/protobuf/proto"
	options "github.com/solo-io/gloo/projects/gloo/pkg/api/v1/options"
	_ "github.com/solo-io/protoc-gen-ext/extproto"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

// Upstream Spec for Consul Upstreams
// consul Upstreams represent a set of one or more addressable pods for a consul Service
// the Gloo consul Upstream maps to a single service port. Because consul Services support multiple ports,
// Gloo requires that a different upstream be created for each port
// consul Upstreams are typically generated automatically by Gloo from the consul API
type UpstreamSpec struct {
	// The name of the Consul Service
	ServiceName string `protobuf:"bytes,1,opt,name=service_name,json=serviceName,proto3" json:"service_name,omitempty"`
	// Deprecated: This field was renamed to subset_tags. If subset_tags is used, this field is
	// ignored. Otherwise, the behavior is the same as subset_tags field below.
	ServiceTags []string `protobuf:"bytes,2,rep,name=service_tags,json=serviceTags,proto3" json:"service_tags,omitempty"`
	// Gloo will segment instances based off of these tags. This allows you to set routes that route
	// to a subset of the instances of the service
	SubsetTags []string `protobuf:"bytes,6,rep,name=subset_tags,json=subsetTags,proto3" json:"subset_tags,omitempty"`
	// The list of service tags Gloo should search for on a service instance
	// before deciding whether or not to include the instance as part of this
	// upstream. Empty list means that all service instances with the same service name will be
	// included. When not empty, only service instances that match all of the tags will be selected
	// for this upstream.
	InstanceTags []string `protobuf:"bytes,7,rep,name=instance_tags,json=instanceTags,proto3" json:"instance_tags,omitempty"`
	// An optional Service Spec describing the service listening at this address
	ServiceSpec *options.ServiceSpec `protobuf:"bytes,3,opt,name=service_spec,json=serviceSpec,proto3" json:"service_spec,omitempty"`
	// Is this consul service connect enabled.
	ConnectEnabled bool `protobuf:"varint,4,opt,name=connect_enabled,json=connectEnabled,proto3" json:"connect_enabled,omitempty"`
	// The data centers in which the service instance represented by this upstream is registered.
	DataCenters          []string `protobuf:"bytes,5,rep,name=data_centers,json=dataCenters,proto3" json:"data_centers,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *UpstreamSpec) Reset()         { *m = UpstreamSpec{} }
func (m *UpstreamSpec) String() string { return proto.CompactTextString(m) }
func (*UpstreamSpec) ProtoMessage()    {}
func (*UpstreamSpec) Descriptor() ([]byte, []int) {
	return fileDescriptor_3c5077911f8bc0ad, []int{0}
}
func (m *UpstreamSpec) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_UpstreamSpec.Unmarshal(m, b)
}
func (m *UpstreamSpec) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_UpstreamSpec.Marshal(b, m, deterministic)
}
func (m *UpstreamSpec) XXX_Merge(src proto.Message) {
	xxx_messageInfo_UpstreamSpec.Merge(m, src)
}
func (m *UpstreamSpec) XXX_Size() int {
	return xxx_messageInfo_UpstreamSpec.Size(m)
}
func (m *UpstreamSpec) XXX_DiscardUnknown() {
	xxx_messageInfo_UpstreamSpec.DiscardUnknown(m)
}

var xxx_messageInfo_UpstreamSpec proto.InternalMessageInfo

func (m *UpstreamSpec) GetServiceName() string {
	if m != nil {
		return m.ServiceName
	}
	return ""
}

func (m *UpstreamSpec) GetServiceTags() []string {
	if m != nil {
		return m.ServiceTags
	}
	return nil
}

func (m *UpstreamSpec) GetSubsetTags() []string {
	if m != nil {
		return m.SubsetTags
	}
	return nil
}

func (m *UpstreamSpec) GetInstanceTags() []string {
	if m != nil {
		return m.InstanceTags
	}
	return nil
}

func (m *UpstreamSpec) GetServiceSpec() *options.ServiceSpec {
	if m != nil {
		return m.ServiceSpec
	}
	return nil
}

func (m *UpstreamSpec) GetConnectEnabled() bool {
	if m != nil {
		return m.ConnectEnabled
	}
	return false
}

func (m *UpstreamSpec) GetDataCenters() []string {
	if m != nil {
		return m.DataCenters
	}
	return nil
}

func init() {
	proto.RegisterType((*UpstreamSpec)(nil), "consul.options.gloo.solo.io.UpstreamSpec")
}

func init() {
	proto.RegisterFile("github.com/solo-io/gloo/projects/gloo/api/v1/options/consul/consul.proto", fileDescriptor_3c5077911f8bc0ad)
}

var fileDescriptor_3c5077911f8bc0ad = []byte{
	// 334 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x8c, 0x92, 0xbd, 0x4e, 0xf3, 0x30,
	0x14, 0x86, 0x95, 0xb6, 0x5f, 0x3f, 0x70, 0x0b, 0x48, 0x11, 0x43, 0x54, 0x24, 0x48, 0x61, 0xa0,
	0x0b, 0xb1, 0xf8, 0xd9, 0x91, 0xf8, 0x91, 0x60, 0x61, 0x68, 0x61, 0x61, 0xa9, 0x1c, 0xf7, 0xc8,
	0x18, 0x12, 0x1f, 0x2b, 0x76, 0xab, 0x5e, 0x12, 0x03, 0x17, 0xc0, 0xf5, 0x70, 0x0f, 0xec, 0xc8,
	0x76, 0x0a, 0x1d, 0x2a, 0xc1, 0x94, 0xf8, 0xd1, 0x73, 0x7c, 0xce, 0x9b, 0x13, 0x72, 0x23, 0xa4,
	0x7d, 0x9a, 0xe6, 0x19, 0xc7, 0x92, 0x1a, 0x2c, 0xf0, 0x48, 0x22, 0x15, 0x05, 0x22, 0xd5, 0x15,
	0x3e, 0x03, 0xb7, 0x26, 0x9c, 0x98, 0x96, 0x74, 0x76, 0x4c, 0x51, 0x5b, 0x89, 0xca, 0x50, 0x8e,
	0xca, 0x4c, 0x8b, 0xfa, 0x91, 0xe9, 0x0a, 0x2d, 0xc6, 0x3b, 0xf5, 0xa9, 0x76, 0x32, 0x57, 0x97,
	0xb9, 0x2b, 0x33, 0x89, 0xbd, 0x6d, 0x81, 0x02, 0xbd, 0x47, 0xdd, 0x5b, 0x28, 0xe9, 0xc5, 0x30,
	0xb7, 0x01, 0xc2, 0xdc, 0xd6, 0xec, 0xec, 0xf7, 0xee, 0x06, 0xaa, 0x99, 0xe4, 0x30, 0x36, 0x1a,
	0x78, 0xa8, 0xda, 0x7f, 0x6b, 0x90, 0xee, 0x83, 0x36, 0xb6, 0x02, 0x56, 0x8e, 0x34, 0xf0, 0xb8,
	0x4f, 0xba, 0x0b, 0x4d, 0xb1, 0x12, 0x92, 0x28, 0x8d, 0x06, 0xeb, 0xc3, 0x4e, 0xcd, 0xee, 0x58,
	0x09, 0xcb, 0x8a, 0x65, 0xc2, 0x24, 0x8d, 0xb4, 0xb9, 0xa4, 0xdc, 0x33, 0x61, 0xe2, 0x3d, 0xd2,
	0x31, 0xd3, 0xdc, 0x80, 0x0d, 0x46, 0xdb, 0x1b, 0x24, 0x20, 0x2f, 0x1c, 0x90, 0x0d, 0xa9, 0x8c,
	0x65, 0x6a, 0x71, 0xc9, 0x7f, 0xaf, 0x74, 0x17, 0xd0, 0x4b, 0x57, 0x3f, 0x8d, 0xdc, 0xc8, 0x49,
	0x33, 0x8d, 0x06, 0x9d, 0x93, 0xfe, 0xca, 0x2f, 0x95, 0x8d, 0x82, 0xe9, 0x42, 0x7c, 0xcf, 0xe2,
	0x13, 0x1d, 0x92, 0x2d, 0x8e, 0x4a, 0x01, 0xb7, 0x63, 0x50, 0x2c, 0x2f, 0x60, 0x92, 0xb4, 0xd2,
	0x68, 0xb0, 0x36, 0xdc, 0xac, 0xf1, 0x75, 0xa0, 0x2e, 0xd7, 0x84, 0x59, 0x36, 0xe6, 0xa0, 0x2c,
	0x54, 0x26, 0xf9, 0x17, 0x72, 0x39, 0x76, 0x19, 0xd0, 0xc5, 0xed, 0xfb, 0x67, 0x2b, 0x7a, 0xfd,
	0xd8, 0x8d, 0x1e, 0xcf, 0xff, 0xb6, 0x7f, 0xfd, 0x22, 0x56, 0xff, 0x03, 0x79, 0xdb, 0x2f, 0xe0,
	0xf4, 0x2b, 0x00, 0x00, 0xff, 0xff, 0x35, 0x9e, 0xf1, 0x87, 0x49, 0x02, 0x00, 0x00,
}

func (this *UpstreamSpec) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*UpstreamSpec)
	if !ok {
		that2, ok := that.(UpstreamSpec)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.ServiceName != that1.ServiceName {
		return false
	}
	if len(this.ServiceTags) != len(that1.ServiceTags) {
		return false
	}
	for i := range this.ServiceTags {
		if this.ServiceTags[i] != that1.ServiceTags[i] {
			return false
		}
	}
	if len(this.SubsetTags) != len(that1.SubsetTags) {
		return false
	}
	for i := range this.SubsetTags {
		if this.SubsetTags[i] != that1.SubsetTags[i] {
			return false
		}
	}
	if len(this.InstanceTags) != len(that1.InstanceTags) {
		return false
	}
	for i := range this.InstanceTags {
		if this.InstanceTags[i] != that1.InstanceTags[i] {
			return false
		}
	}
	if !this.ServiceSpec.Equal(that1.ServiceSpec) {
		return false
	}
	if this.ConnectEnabled != that1.ConnectEnabled {
		return false
	}
	if len(this.DataCenters) != len(that1.DataCenters) {
		return false
	}
	for i := range this.DataCenters {
		if this.DataCenters[i] != that1.DataCenters[i] {
			return false
		}
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
