// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: github.com/solo-io/gloo/projects/gloo/api/v1/options/kubernetes/kubernetes.proto

package kubernetes

import (
	bytes "bytes"
	fmt "fmt"
	math "math"

	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/gogo/protobuf/proto"
	options "github.com/solo-io/gloo/projects/gloo/pkg/api/v1/options"
	_ "github.com/solo-io/protoc-gen-ext/extproto"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

// Kubernetes Upstreams represent a set of one or more addressable pods for a Kubernetes Service
// the Gloo Kubernetes Upstream maps to a single service port. Because Kubernetes Services support multiple ports,
// Gloo requires that a different upstream be created for each port
// Kubernetes Upstreams are typically generated automatically by Gloo from the Kubernetes API
type UpstreamSpec struct {
	// The name of the Kubernetes Service
	ServiceName string `protobuf:"bytes,1,opt,name=service_name,json=serviceName,proto3" json:"service_name,omitempty"`
	// The namespace where the Service lives
	ServiceNamespace string `protobuf:"bytes,2,opt,name=service_namespace,json=serviceNamespace,proto3" json:"service_namespace,omitempty"`
	// The access port of the kubernetes service is listening. This port is used by Gloo to look up the corresponding
	// port on the pod for routing.
	ServicePort uint32 `protobuf:"varint,3,opt,name=service_port,json=servicePort,proto3" json:"service_port,omitempty"`
	// Allows finer-grained filtering of pods for the Upstream. Gloo will select pods based on their labels if
	// any are provided here.
	// (see [Kubernetes labels and selectors](https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/)
	Selector map[string]string `protobuf:"bytes,4,rep,name=selector,proto3" json:"selector,omitempty" protobuf_key:"bytes,1,opt,name=key,proto3" protobuf_val:"bytes,2,opt,name=value,proto3"`
	// An optional Service Spec describing the service listening at this address
	ServiceSpec *options.ServiceSpec `protobuf:"bytes,5,opt,name=service_spec,json=serviceSpec,proto3" json:"service_spec,omitempty"`
	// Subset configuration. For discovery sources that has labels (like kubernetes). this
	// configuration allows you to partition the upstream to a set of subsets.
	// for each unique set of keys and values, a subset will be created.
	SubsetSpec           *options.SubsetSpec `protobuf:"bytes,6,opt,name=subset_spec,json=subsetSpec,proto3" json:"subset_spec,omitempty"`
	XXX_NoUnkeyedLiteral struct{}            `json:"-"`
	XXX_unrecognized     []byte              `json:"-"`
	XXX_sizecache        int32               `json:"-"`
}

func (m *UpstreamSpec) Reset()         { *m = UpstreamSpec{} }
func (m *UpstreamSpec) String() string { return proto.CompactTextString(m) }
func (*UpstreamSpec) ProtoMessage()    {}
func (*UpstreamSpec) Descriptor() ([]byte, []int) {
	return fileDescriptor_d321d3096be8ec63, []int{0}
}
func (m *UpstreamSpec) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_UpstreamSpec.Unmarshal(m, b)
}
func (m *UpstreamSpec) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_UpstreamSpec.Marshal(b, m, deterministic)
}
func (m *UpstreamSpec) XXX_Merge(src proto.Message) {
	xxx_messageInfo_UpstreamSpec.Merge(m, src)
}
func (m *UpstreamSpec) XXX_Size() int {
	return xxx_messageInfo_UpstreamSpec.Size(m)
}
func (m *UpstreamSpec) XXX_DiscardUnknown() {
	xxx_messageInfo_UpstreamSpec.DiscardUnknown(m)
}

var xxx_messageInfo_UpstreamSpec proto.InternalMessageInfo

func (m *UpstreamSpec) GetServiceName() string {
	if m != nil {
		return m.ServiceName
	}
	return ""
}

func (m *UpstreamSpec) GetServiceNamespace() string {
	if m != nil {
		return m.ServiceNamespace
	}
	return ""
}

func (m *UpstreamSpec) GetServicePort() uint32 {
	if m != nil {
		return m.ServicePort
	}
	return 0
}

func (m *UpstreamSpec) GetSelector() map[string]string {
	if m != nil {
		return m.Selector
	}
	return nil
}

func (m *UpstreamSpec) GetServiceSpec() *options.ServiceSpec {
	if m != nil {
		return m.ServiceSpec
	}
	return nil
}

func (m *UpstreamSpec) GetSubsetSpec() *options.SubsetSpec {
	if m != nil {
		return m.SubsetSpec
	}
	return nil
}

func init() {
	proto.RegisterType((*UpstreamSpec)(nil), "kubernetes.options.gloo.solo.io.UpstreamSpec")
	proto.RegisterMapType((map[string]string)(nil), "kubernetes.options.gloo.solo.io.UpstreamSpec.SelectorEntry")
}

func init() {
	proto.RegisterFile("github.com/solo-io/gloo/projects/gloo/api/v1/options/kubernetes/kubernetes.proto", fileDescriptor_d321d3096be8ec63)
}

var fileDescriptor_d321d3096be8ec63 = []byte{
	// 373 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x8c, 0x92, 0xcd, 0x6a, 0xdb, 0x40,
	0x14, 0x85, 0x91, 0x65, 0x9b, 0x76, 0x64, 0x83, 0x3b, 0x78, 0x21, 0xbc, 0x68, 0xe5, 0xae, 0x04,
	0xa5, 0x23, 0x6a, 0x77, 0x51, 0xea, 0x55, 0xff, 0x96, 0x2d, 0xc6, 0xa6, 0x04, 0xb2, 0x09, 0x92,
	0xb8, 0x28, 0x8a, 0x25, 0xdd, 0x61, 0x66, 0x64, 0xec, 0xb7, 0xc9, 0x32, 0x8f, 0x90, 0xe7, 0xc9,
	0x3b, 0x64, 0x1f, 0x34, 0x92, 0x95, 0x09, 0xc4, 0xd8, 0xbb, 0x3b, 0x87, 0x73, 0x3e, 0x5d, 0x9d,
	0x19, 0xb2, 0x4c, 0x52, 0x75, 0x5d, 0x46, 0x2c, 0xc6, 0x3c, 0x90, 0x98, 0xe1, 0xe7, 0x14, 0x83,
	0x24, 0x43, 0x0c, 0xb8, 0xc0, 0x1b, 0x88, 0x95, 0xac, 0x4f, 0x21, 0x4f, 0x83, 0xed, 0x97, 0x00,
	0xb9, 0x4a, 0xb1, 0x90, 0xc1, 0xa6, 0x8c, 0x40, 0x14, 0xa0, 0xc0, 0x1c, 0x19, 0x17, 0xa8, 0x90,
	0x7e, 0x30, 0x94, 0xc6, 0xcf, 0x2a, 0x06, 0xab, 0xf0, 0x2c, 0xc5, 0xc9, 0x38, 0xc1, 0x04, 0xb5,
	0x37, 0xa8, 0xa6, 0x3a, 0x36, 0xa1, 0xb0, 0x53, 0xb5, 0x08, 0x3b, 0xd5, 0x68, 0x5f, 0x4f, 0x6f,
	0x22, 0x41, 0x6c, 0xd3, 0x18, 0xae, 0x24, 0x87, 0xb8, 0x49, 0xcd, 0xcf, 0x48, 0x95, 0x91, 0x04,
	0x65, 0x84, 0x3e, 0xde, 0xda, 0x64, 0xf0, 0x9f, 0x4b, 0x25, 0x20, 0xcc, 0xd7, 0x1c, 0x62, 0x3a,
	0x25, 0x83, 0x03, 0xbb, 0x08, 0x73, 0x70, 0x2d, 0xcf, 0xf2, 0xdf, 0xae, 0x9c, 0x46, 0xfb, 0x17,
	0xe6, 0x40, 0x3f, 0x91, 0x77, 0xa6, 0x45, 0xf2, 0x30, 0x06, 0xb7, 0xa3, 0x7d, 0x23, 0xc3, 0xa7,
	0x75, 0x93, 0xc7, 0x51, 0x28, 0xd7, 0xf6, 0x2c, 0x7f, 0xd8, 0xf2, 0x96, 0x28, 0x14, 0xbd, 0x20,
	0x6f, 0x24, 0x64, 0x10, 0x2b, 0x14, 0x6e, 0xd7, 0xb3, 0x7d, 0x67, 0xb6, 0x60, 0x27, 0xca, 0x64,
	0xe6, 0xce, 0x6c, 0xdd, 0xa4, 0xff, 0x14, 0x4a, 0xec, 0x57, 0x2d, 0x8c, 0xfe, 0x7e, 0xfe, 0x76,
	0xf5, 0xcb, 0x6e, 0xcf, 0xb3, 0x7c, 0x67, 0x36, 0x7d, 0x9d, 0xb8, 0xae, 0x9d, 0x15, 0xb0, 0x5d,
	0x4f, 0x37, 0xf2, 0x83, 0x38, 0x46, 0x6f, 0x6e, 0x5f, 0x43, 0xbc, 0x23, 0x10, 0x6d, 0xd4, 0x0c,
	0x22, 0xdb, 0x79, 0xb2, 0x20, 0xc3, 0x17, 0x3b, 0xd2, 0x11, 0xb1, 0x37, 0xb0, 0x6f, 0xca, 0xad,
	0x46, 0x3a, 0x26, 0xbd, 0x6d, 0x98, 0x95, 0x87, 0x22, 0xeb, 0xc3, 0xf7, 0xce, 0x37, 0xeb, 0xe7,
	0xdf, 0xfb, 0xc7, 0xae, 0x75, 0xf7, 0xf0, 0xde, 0xba, 0xfc, 0x75, 0xde, 0xa3, 0xe5, 0x9b, 0xe4,
	0xf8, 0xc3, 0x8d, 0xfa, 0xfa, 0xe2, 0xe7, 0x4f, 0x01, 0x00, 0x00, 0xff, 0xff, 0x51, 0x6c, 0xa1,
	0x51, 0x02, 0x03, 0x00, 0x00,
}

func (this *UpstreamSpec) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*UpstreamSpec)
	if !ok {
		that2, ok := that.(UpstreamSpec)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.ServiceName != that1.ServiceName {
		return false
	}
	if this.ServiceNamespace != that1.ServiceNamespace {
		return false
	}
	if this.ServicePort != that1.ServicePort {
		return false
	}
	if len(this.Selector) != len(that1.Selector) {
		return false
	}
	for i := range this.Selector {
		if this.Selector[i] != that1.Selector[i] {
			return false
		}
	}
	if !this.ServiceSpec.Equal(that1.ServiceSpec) {
		return false
	}
	if !this.SubsetSpec.Equal(that1.SubsetSpec) {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
