// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: github.com/solo-io/gloo/projects/gloo/api/v1/options/retries/retries.proto

package retries

import (
	bytes "bytes"
	fmt "fmt"
	math "math"
	time "time"

	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/gogo/protobuf/proto"
	_ "github.com/gogo/protobuf/types"
	_ "github.com/solo-io/protoc-gen-ext/extproto"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf
var _ = time.Kitchen

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

// Retry Policy applied at the Route and/or Virtual Hosts levels.
type RetryPolicy struct {
	// Specifies the conditions under which retry takes place. These are the same
	// conditions [documented for Envoy](https://www.envoyproxy.io/docs/envoy/v1.14.1/configuration/http/http_filters/router_filter#config-http-filters-router-x-envoy-retry-on)
	RetryOn string `protobuf:"bytes,1,opt,name=retry_on,json=retryOn,proto3" json:"retry_on,omitempty"`
	// Specifies the allowed number of retries. This parameter is optional and
	// defaults to 1. These are the same conditions [documented for Envoy](https://www.envoyproxy.io/docs/envoy/v1.14.1/configuration/http/http_filters/router_filter#config-http-filters-router-x-envoy-retry-on)
	NumRetries uint32 `protobuf:"varint,2,opt,name=num_retries,json=numRetries,proto3" json:"num_retries,omitempty"`
	// Specifies a non-zero upstream timeout per retry attempt. This parameter is optional.
	PerTryTimeout        *time.Duration `protobuf:"bytes,3,opt,name=per_try_timeout,json=perTryTimeout,proto3,stdduration" json:"per_try_timeout,omitempty"`
	XXX_NoUnkeyedLiteral struct{}       `json:"-"`
	XXX_unrecognized     []byte         `json:"-"`
	XXX_sizecache        int32          `json:"-"`
}

func (m *RetryPolicy) Reset()         { *m = RetryPolicy{} }
func (m *RetryPolicy) String() string { return proto.CompactTextString(m) }
func (*RetryPolicy) ProtoMessage()    {}
func (*RetryPolicy) Descriptor() ([]byte, []int) {
	return fileDescriptor_3c06018876f3ed3e, []int{0}
}
func (m *RetryPolicy) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_RetryPolicy.Unmarshal(m, b)
}
func (m *RetryPolicy) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_RetryPolicy.Marshal(b, m, deterministic)
}
func (m *RetryPolicy) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RetryPolicy.Merge(m, src)
}
func (m *RetryPolicy) XXX_Size() int {
	return xxx_messageInfo_RetryPolicy.Size(m)
}
func (m *RetryPolicy) XXX_DiscardUnknown() {
	xxx_messageInfo_RetryPolicy.DiscardUnknown(m)
}

var xxx_messageInfo_RetryPolicy proto.InternalMessageInfo

func (m *RetryPolicy) GetRetryOn() string {
	if m != nil {
		return m.RetryOn
	}
	return ""
}

func (m *RetryPolicy) GetNumRetries() uint32 {
	if m != nil {
		return m.NumRetries
	}
	return 0
}

func (m *RetryPolicy) GetPerTryTimeout() *time.Duration {
	if m != nil {
		return m.PerTryTimeout
	}
	return nil
}

func init() {
	proto.RegisterType((*RetryPolicy)(nil), "retries.options.gloo.solo.io.RetryPolicy")
}

func init() {
	proto.RegisterFile("github.com/solo-io/gloo/projects/gloo/api/v1/options/retries/retries.proto", fileDescriptor_3c06018876f3ed3e)
}

var fileDescriptor_3c06018876f3ed3e = []byte{
	// 288 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x8c, 0x90, 0xcf, 0x4a, 0xf4, 0x30,
	0x14, 0xc5, 0xc9, 0xf7, 0x0d, 0xfe, 0x49, 0x19, 0x84, 0xe2, 0xa2, 0x33, 0xc8, 0x4c, 0x71, 0xd5,
	0x8d, 0x09, 0xea, 0x0b, 0xc8, 0x20, 0x08, 0xb3, 0x51, 0xca, 0xac, 0xdc, 0x94, 0x69, 0x8d, 0x31,
	0xda, 0xe6, 0x86, 0xf4, 0x46, 0xa6, 0xaf, 0xe1, 0xca, 0x47, 0xf0, 0x11, 0x7c, 0x1b, 0xc1, 0x77,
	0x70, 0x2f, 0x69, 0x3a, 0xee, 0x04, 0x57, 0xb9, 0xe7, 0x70, 0x4e, 0xee, 0x8f, 0x4b, 0x97, 0x52,
	0xe1, 0x83, 0x2b, 0x59, 0x05, 0x0d, 0x6f, 0xa1, 0x86, 0x13, 0x05, 0x5c, 0xd6, 0x00, 0xdc, 0x58,
	0x78, 0x14, 0x15, 0xb6, 0x41, 0xad, 0x8d, 0xe2, 0xcf, 0xa7, 0x1c, 0x0c, 0x2a, 0xd0, 0x2d, 0xb7,
	0x02, 0xad, 0x12, 0x3f, 0x2f, 0x33, 0x16, 0x10, 0xe2, 0xa3, 0xad, 0x1c, 0x62, 0xcc, 0x57, 0x99,
	0xff, 0x95, 0x29, 0x98, 0xce, 0x24, 0x80, 0xac, 0x05, 0xef, 0xb3, 0xa5, 0xbb, 0xe7, 0x77, 0xce,
	0xae, 0x7d, 0x2e, 0xb4, 0xa7, 0x87, 0x12, 0x24, 0xf4, 0x23, 0xf7, 0xd3, 0xe0, 0xc6, 0x62, 0x83,
	0xc1, 0x14, 0x1b, 0x0c, 0xde, 0xf1, 0x0b, 0xa1, 0x51, 0x2e, 0xd0, 0x76, 0x37, 0x50, 0xab, 0xaa,
	0x8b, 0x27, 0x74, 0xcf, 0x6f, 0xee, 0x0a, 0xd0, 0x09, 0x49, 0x49, 0xb6, 0x9f, 0xef, 0xf6, 0xfa,
	0x5a, 0xc7, 0x73, 0x1a, 0x69, 0xd7, 0x14, 0x03, 0x58, 0xf2, 0x2f, 0x25, 0xd9, 0x38, 0xa7, 0xda,
	0x35, 0x79, 0x70, 0xe2, 0x2b, 0x7a, 0x60, 0x84, 0x2d, 0x7c, 0x1b, 0x55, 0x23, 0xc0, 0x61, 0xf2,
	0x3f, 0x25, 0x59, 0x74, 0x36, 0x61, 0x81, 0x97, 0x6d, 0x79, 0xd9, 0xe5, 0xc0, 0xbb, 0x18, 0xbd,
	0x7e, 0xcc, 0x49, 0x3e, 0x36, 0xc2, 0xae, 0x6c, 0xb7, 0x0a, 0xad, 0xc5, 0xf2, 0xfd, 0x6b, 0x44,
	0xde, 0x3e, 0x67, 0xe4, 0xf6, 0xe2, 0x6f, 0x27, 0x35, 0x4f, 0xf2, 0x97, 0xb3, 0x96, 0x3b, 0xfd,
	0xce, 0xf3, 0xef, 0x00, 0x00, 0x00, 0xff, 0xff, 0xe5, 0x5d, 0xe3, 0x4f, 0x9d, 0x01, 0x00, 0x00,
}

func (this *RetryPolicy) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*RetryPolicy)
	if !ok {
		that2, ok := that.(RetryPolicy)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.RetryOn != that1.RetryOn {
		return false
	}
	if this.NumRetries != that1.NumRetries {
		return false
	}
	if this.PerTryTimeout != nil && that1.PerTryTimeout != nil {
		if *this.PerTryTimeout != *that1.PerTryTimeout {
			return false
		}
	} else if this.PerTryTimeout != nil {
		return false
	} else if that1.PerTryTimeout != nil {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
