// Code generated by solo-kit. DO NOT EDIT.

package kubernetes

import (
	"github.com/solo-io/go-utils/contextutils"
	"github.com/solo-io/solo-kit/pkg/api/v1/clients"
	"github.com/solo-io/solo-kit/pkg/api/v1/reconcile"
	"github.com/solo-io/solo-kit/pkg/api/v1/resources"
)

// Option to copy anything from the original to the desired before writing. Return value of false means don't update
type TransitionKubeNamespaceFunc func(original, desired *KubeNamespace) (bool, error)

type KubeNamespaceReconciler interface {
	Reconcile(namespace string, desiredResources KubeNamespaceList, transition TransitionKubeNamespaceFunc, opts clients.ListOpts) error
}

func kubeNamespacesToResources(list KubeNamespaceList) resources.ResourceList {
	var resourceList resources.ResourceList
	for _, kubeNamespace := range list {
		resourceList = append(resourceList, kubeNamespace)
	}
	return resourceList
}

func NewKubeNamespaceReconciler(client KubeNamespaceClient) KubeNamespaceReconciler {
	return &kubeNamespaceReconciler{
		base: reconcile.NewReconciler(client.BaseClient()),
	}
}

type kubeNamespaceReconciler struct {
	base reconcile.Reconciler
}

func (r *kubeNamespaceReconciler) Reconcile(namespace string, desiredResources KubeNamespaceList, transition TransitionKubeNamespaceFunc, opts clients.ListOpts) error {
	opts = opts.WithDefaults()
	opts.Ctx = contextutils.WithLogger(opts.Ctx, "kubeNamespace_reconciler")
	var transitionResources reconcile.TransitionResourcesFunc
	if transition != nil {
		transitionResources = func(original, desired resources.Resource) (bool, error) {
			return transition(original.(*KubeNamespace), desired.(*KubeNamespace))
		}
	}
	return r.base.Reconcile(namespace, kubeNamespacesToResources(desiredResources), transitionResources, opts)
}
